package Derytas;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: Derytas                                                             //
// Mtodos: - public void init: Inicializa el applet                          //
//          - public void paint: Pinta el applet                              //
//          -  public void update: Actualiza el applet                        //
//          - public String sGuardar: Construye una cadena con los elementos  //
//            del esquema para ser guardados en fichero                       //
//          - public void Abrir: Lee los elementos del esquema                //
//          - public void AbrirEntidad: Muestra la ventana de entidades en    //
//            modo alta                                                       //
//          - public void AbrirConfig: Muestra la ventana de opciones de      //
//            configuracin                                                   //
//          - public void AbrirEspecializacion: Muestra la ventana de         //
//            especializaciones en modo alta                                  //
//          - public void AbrirTipoUnion: Muestra la ventana de tipos unin   //
//            en modo alta                                                    //
//          - public void AbrirTipointerseccion: Muestra la ventana de tipos  //
//            interseccin en modo alta                                       //
//          - public void AbrirRelacion: Muestra la ventana de relaciones en  //
//            modo alta                                                       //
//          - public void AbrirSubclase: Muestra la ventana de subclases      //
//          - public void EliminarElemento: Muestra la ventana para eliminar  //
//            el elemento seleccionado                                        //
//          - public String sObtenerFicheroEsquema: Devuelve la ruta completa //
//            del fichero del esquema                                         //
//          - public String sObtenerFicheroScript: Devuelve la ruta completa  //
//            del fichero del esquema                                         //
//          - public void VisualizarScript: Abre una ventana para ver el      //
//            script                                                          //
//          - private void Ocultar: Oculta la ventana para ver el script      //
//          - public String sLeerScript: Devuelve una cadena con el script    //
//          - public void AvisoRecargar: Muestra un mensaje indicando que se  //
//            recargue la pgina                                              //
//          - public void AcercaDe: Muestra una ventana con informacin acerca//
//            de la aplicacin                                                //
//          - public void Modificar: Abre la ventana apropiada para modificar //
//            el elemento indicado                                            //
//          - public void EliminarComoSubclase: Muestra la ventana para       //
//            eliminar la relacin superclase-subclase entre dos entidades    //
// Descripcin: Applet de la aplicacin                                       //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class Derytas
   extends Applet {

   // Declaracin de los componentes del applet

   boolean bMoviendoElem; // Indica si hay algn elememto en movimiento
   String gsPath; // Directorio de la aplicacin
   Image imgLogo; // Imagen con el logo de Derytas

   int nXRatonAnt; // Coordenada X anterior del ratn
   int nYRatonAnt; // Coordenada Y anterior del ratn
   int nXRatonAct; // Coordenada X actual del ratn
   int nYRatonAct; // Coordenada Y actual del ratn

   clsMensajes oMensajes; // Objeto de la clase clsMensajes
   clsGeneral oGeneral; // Objeto de la clase clsGeneral
   clsFichero oFichero; // Objeto de la clase clsFichero
   clsScript oScript; // Objeto de la clase clsScript
   clsConfig oConfig; // Objeto de la clase clsConfig

   PopupMenu popMenu; // Men contextual de la aplicacin
   // Elementos del men contextual
   MenuItem miModificarElemento;
   MenuItem miEliminarElemento;
   MenuItem miEliminarComoSubclase;

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: init                                                     //
   // Parmetros: No                                                          //
   // Descripcin: Inicializa el Applet                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void init() {

      // Creacin de los componentes del applet

      bMoviendoElem = false;
      gsPath = getDocumentBase().getPath();
      imgLogo = getImage(getDocumentBase(), "imagenes/logo.jpg");

      // Crear el objeto de la clase clsGeneral
      oGeneral = new clsGeneral(super,
                                imgLogo);
      // Crear el objeto de la clase clsMensajes
      oMensajes = new clsMensajes(oGeneral);
      popMenu = new PopupMenu();
      oGeneral.oModificar = null;
      // Crear el objeto ventana Opciones
      oConfig = new clsConfig(oGeneral);

      miModificarElemento = new MenuItem(clsConstantes.sMENUITEM_MODIFICAR);
      // Agregar el listener para el MenuItem
      miModificarElemento.addActionListener(
         new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            Modificar();
         }
      });
      popMenu.add(miModificarElemento);

      miEliminarElemento = new MenuItem(clsConstantes.sMENUITEM_ELIMINAR);
      // Agregar el listener para el MenuItem
      miEliminarElemento.addActionListener(
         new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            EliminarElemento();
         }
      });
      popMenu.add(miEliminarElemento);

      miEliminarComoSubclase = new MenuItem(clsConstantes.
                                            sMENUITEM_ELIMINAR_SUBCLASE);
      // Agregar el listener para el MenuItem
      miEliminarComoSubclase.addActionListener(
         new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            EliminarComoSubclase();
         }
      });
      popMenu.add(miEliminarComoSubclase);

      this.setBackground(clsConstantes.COLOR_FONDO_APPLET);
      this.add(popMenu);
      this.setLayout(null);

      // Al iniciar no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
      // Por defecto la ventana se cierra despus de crear el elemento
      oConfig.bCerrar = true;
      oConfig.bComentScript = true;
      oConfig.bComentDic = true;
      // Por defecto se muestran todos los atributos
      oConfig.nVerAtributos = clsConstantes.nTODOS;
      // Por defecto se utiliza la opcin A
      oConfig.nVerAtributos = clsConstantes.nOPCION_A;
      oFichero = new clsFichero(oGeneral,
                                oConfig,
                                gsPath);
      oScript = new clsScript(oGeneral, oConfig);
      // Hacer que Mouse gestione los eventos del ratn
      clsRaton oRaton = new clsRaton();
      this.addMouseListener(oRaton);
      this.addMouseMotionListener(oRaton);

      enableEvents(AWTEvent.MOUSE_EVENT_MASK);
   } // Procedimiento: init

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: paint                                                    //
   // Parmetros: - g (Graphics) : Objeto grfico                             //
   // Descripcin: Pinta el Applet                                            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void paint(Graphics g) {
      // Llamar al Procedimiento "update" del applet
      update(g);
   } // Procedimiento: paint

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: update                                                   //
   // Parmetros: - g (Graphics) : Objeto grfico                             //
   // Descripcin: Actualiza el Applet                                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void update(Graphics g) {
      // Establecer el tipo de letra
      g.setFont(new Font("Courier", Font.PLAIN, 12));

      // Borrar el esquema
      g.clearRect(0, 0, this.getWidth(), this.getHeight());
      // Comprobar si se est moviendo un elemento del esquema
      if (bMoviendoElem) {
         oGeneral.oElementoActual.PintarLineas(g,
                                               clsConstantes.COLOR_FONDO_APPLET);
         oGeneral.oElementoActual.Pintar(g, clsConstantes.COLOR_FONDO_APPLET);
         // Situar el elemento en la posicin indicada por el ratn
         oGeneral.oElementoActual.CambiarPos(oGeneral.oElementoActual.nX +
                                             nXRatonAct - nXRatonAnt,
                                             oGeneral.oElementoActual.nY +
                                             nYRatonAct - nYRatonAnt);
         // Actualizar la posicin del ratn
         nXRatonAnt = nXRatonAct;
         nYRatonAnt = nYRatonAct;
      } // if
      //  Pintar las lneas del esquema
      for (int i = 0; i < oGeneral.vElementos.size(); i++) {
         ( (clsElemento) oGeneral.vElementos.elementAt(i)).PintarLineas(g,
            clsConstantes.COLOR_ELEMENTO);
      } // for

      // Pintar los elementos del esquema
      for (int i = 0; i < oGeneral.vElementos.size(); i++) {
         ( (clsElemento) oGeneral.vElementos.elementAt(i)).Pintar(g,
            clsConstantes.COLOR_ELEMENTO);
      } // for
   } // Procedimiento: update

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sGuardar                                                       //
   // Parmetros: No                                                          //
   // Retorno: Cadena con los elementos del esquema                           //
   // Descripcin: Construye una cadena con los elementos del esquema para ser//
   //              guardados en fichero                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sGuardar() {
      // Devolver la cadena con los elementos del esquema
      return oFichero.sGuardar();
   } // Funcin: sGuardar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: Abrir                                                     //
   // Parmetros: - psDatos (String): Cadena con el contenido del fichero que //
   //               guarda un esquema                                         //
   // Descripcin: Obtiene las propiedades de los elementos del esquema a     //
   //              partir de la cadena que recibe                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Abrir(String psDatos) {
      // Limpiar la pantalla
      oGeneral.LimpiarPantalla();

      // Llamar al Procedimiento Abrir de la clase clsFichero
      oFichero.Abrir(psDatos);

      // Mostrar en pantalla el esquema ledo
      repaint();
   } // Procedimiento: Abrir

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: Abrir                                                     //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de entidades en modo alta               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirEntidad() {
      // Comprobar si hay alguna ventana abierta
      if (!oGeneral.bVentanaAbierta) {
         // Mostrar la ventana de entidades en modo alta
         new clsEntidad(oGeneral, oConfig, clsConstantes.nMODO_ALTA);
         // Indicar que hay una ventana abierta
         oGeneral.bVentanaAbierta = true;
      } // if
      else {
         // Mostrar la ventana que hay abierta
         oGeneral.MostrarActual();
      } // else
   } // Procedimiento: AbrirEntidad

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirConfig                                               //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de opciones de configuracin            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirConfig() {
      // Comprobar si hay alguna ventana abierta
      if (!oGeneral.bVentanaAbierta) {
         // Mostrar la ventana de opciones de configuracin
         oConfig.Mostrar();
         // Indicar que hay una ventana abierta
         oGeneral.bVentanaAbierta = true;
      } // if
      else {
         // Mostrar la ventana que hay abierta
         oGeneral.MostrarActual();
      } // else
   } // Procedimiento: AbrirConfig

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirEspecializacion                                      //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de especializaciones en modo alta       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirEspecializacion() {
      // Mostrar la ventana de especializaciones en modo alta
      if (!oGeneral.bVentanaAbierta) {
         new clsEspecializacion(oGeneral, oConfig, clsConstantes.nMODO_ALTA);
         oGeneral.bVentanaAbierta = true;
      } // if
   } // Procedimiento: AbrirEspecializacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirTipoUnion                                            //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de tipos unin en modo alta             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirTipoUnion() {
      // Mostrar la ventana de tipos unin en modo alta
      if (!oGeneral.bVentanaAbierta) {
         new clsTipoUnion(oGeneral, oConfig, clsConstantes.nMODO_ALTA);
         oGeneral.bVentanaAbierta = true;
      } // if
   } // Procedimiento: AbrirTipoUnion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirTipoInterseccion                                     //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de tipos interseccin en modo alta      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirTipoInterseccion() {
      // Mostrar la ventana de tipos interseccin en modo alta
      if (!oGeneral.bVentanaAbierta) {
         new clsTipoInterseccion(oGeneral, oConfig, clsConstantes.nMODO_ALTA);
         oGeneral.bVentanaAbierta = true;
      } // if
   } // Procedimiento: AbrirTipoInterseccion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirRelacion                                             //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de relaciones en modo alta              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirRelacion() {
      // Mostrar la ventana de relaciones en modo alta
      if (!oGeneral.bVentanaAbierta) {
         new clsRelacion(oGeneral, oConfig, clsConstantes.nMODO_ALTA);
         oGeneral.bVentanaAbierta = true;
      } // if
      else {
         oGeneral.MostrarActual();
      }
   } // Procedimiento: AbrirRelacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AbrirSubclase                                             //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana de subclases                            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AbrirSubclase() {
      // Mostrar la ventana de subclases
      if (!oGeneral.bVentanaAbierta) {
         new clsSubclase(oGeneral, oConfig);
         oGeneral.bVentanaAbierta = true;
      } // if
   } // Procedimiento: AbrirSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: EliminarElemento                                          //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana para eliminar el elemento seleccionado  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void EliminarElemento() {
      // Mostrar la ventana de eliminar
      if (!oGeneral.bVentanaAbierta) {
         new clsEliminarElemento(oGeneral);
         oGeneral.bVentanaAbierta = true;
      } // if
   } // Procedimiento: EliminarElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sObtenerFicheroEsquema                                         //
   // Parmetros: - pnOpcion (int): Opcin de apertura del fichero del esquema//
   // Retorno: ndice del array de datos del siguiente elemento               //
   // Descripcin: Devuelve la ruta completa del fichero del esquema          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sObtenerFicheroEsquema(int pnOpcion) {
      // Devolver la ruta del fichero del esquema
      return oFichero.sObtenerFicheroEsquema(pnOpcion);
   } // Funcin: sObtenerFicheroEsquema

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sObtenerFicheroScript                                          //
   // Parmetros: No                                                          //
   // Retorno: ndice del array de datos del siguiente elemento               //
   // Descripcin: Devuelve la ruta completa del fichero para el script del   //
   //              esquema                                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sObtenerFicheroScript() {
      // Devolver la ruta del fichero del script del esquema
      return oFichero.sObtenerFicheroScript();
   } // Funcin: sObtenerFicheroScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: VisualizarScript                                          //
   // Parmetros: No                                                          //
   // Descripcin: Abre una ventana para ver el script                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void VisualizarScript() {

      Frame fraVentana;
      TextArea txaScript;

      // Comprobar que no hay una ventana abierta
      if (!oGeneral.bVentanaAbierta) {

         txaScript = new TextArea();
         fraVentana = new Frame("Script SQL para generar la Base de Datos");

         // Indicar que hay una ventana abierta
         oGeneral.bVentanaAbierta = true;
         // Indicar que es la ventana ventana
         oGeneral.EstablecerActual(fraVentana);

         txaScript.setEditable(false);

         txaScript.setText(oScript.sGenerarScript());

         fraVentana.add(txaScript);
         fraVentana.setSize(800, 600);
         fraVentana.setResizable(false);
         fraVentana.setIconImage(imgLogo);
         oGeneral.CentrarVentana(fraVentana);

         fraVentana.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               Ocultar();
            } // windowClosing
         });

         // Establecer la ventana actual
         oGeneral.EstablecerActual(fraVentana);
         fraVentana.setVisible(true);
      } // if
      else {
         // Mostrar la ventana abierta actualmente
         oGeneral.fraObtenerActual().setVisible(true);
      }
   } // Procedimiento: VisualizarScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: Ocultar                                                   //
   // Parmetros: No                                                          //
   // Descripcin: Oculta la ventana para ver el script                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Indicar que no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
      // Ocultar la ventana
      oGeneral.fraObtenerActual().setVisible(false);
      // Limpiar la ventana actual
      oGeneral.EstablecerActual(null);
   } // Procedimiento: Ocultar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sLeerScript                                                    //
   // Parmetros: No                                                          //
   // Retorno: Cadena con el script de creacin                               //
   // Descripcin: Devuelve una cadena con el script de creacin              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sLeerScript() {
      return oScript.sGenerarScript();
   } // Funcin: sLeerScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Clase: clsRaton                                                         //
   // Descripcin: Gestiona los eventos del ratn                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private class clsRaton
      extends MouseAdapter
      implements MouseMotionListener {
      public void mousePressed(MouseEvent e) {
         nXRatonAnt = e.getX();
         nYRatonAnt = e.getY();

         oGeneral.nXInicial = e.getX();
         oGeneral.nYInicial = e.getY();

         boolean bEliminar = true;
         boolean bSubclase = true;

         bMoviendoElem = oGeneral.bEnElemento(nXRatonAnt, nYRatonAnt, true);
         if (bMoviendoElem) {
            bEliminar = oGeneral.bPuedeEliminar();
            bSubclase = oGeneral.bPuedeEliminarSub();
         }

         popMenu.getItem(clsConstantes.nMENUITEM_MODIFICAR).setEnabled(
            bMoviendoElem && !oGeneral.bVentanaAbierta);
         popMenu.getItem(clsConstantes.nMENUITEM_ELIMINAR).setEnabled(
            bMoviendoElem && bEliminar);
         popMenu.getItem(clsConstantes.nMENUITEM_ELIMINAR_SUBCLASE).
            setEnabled(
            bMoviendoElem && bSubclase);
      } // Evento: mousePressed

      public void mouseReleased(MouseEvent e) {
         if (bMoviendoElem) {
            bMoviendoElem = false;
         } // if
      } // Evento: mouseReleased

      public void mouseDragged(MouseEvent e) {

         nXRatonAct = e.getX();
         nYRatonAct = e.getY();

         if (bMoviendoElem) {
            repaint();
         } // if
      } // Evento: mouseDragged

      public void mouseMoved(MouseEvent e) {
         // No hace nada.
      } // Evento: mouseMoved
   } // Clase: clsRaton

   public void processMouseEvent(MouseEvent e) {
      if (e.isPopupTrigger()) {
         popMenu.show(e.getComponent(), e.getX(), e.getY());
         oGeneral.nXInicial = e.getX();
         oGeneral.nYInicial = e.getY();
      } // if
      super.processMouseEvent(e);
   } // Procedimiento: processMouseEvent

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AvisoRecargar                                             //
   // Parmetros: No                                                          //
   // Descripcin: Muestra un mensaje indicando que se recargue la pgina     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AvisoRecargar() {
      // Mostrar el mensaje de error por no poder leer el fichero
      oMensajes.MostrarMensaje(clsConstantes.sERROR_RECARGAR_DERYTAS);
   } // AvisoRecargar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: AcercaDe                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Muestra una ventana con relacin acerca de la aplicacin   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AcercaDe() {

      final Frame fraVentana; // Ventana
      Label lblScript1;
      Label lblScript2;
      Label lblScript3;
      Label lblScript4;
      Label lblScript5;
      Label lblScript6;
      Label lblScript7;
      Label lblScript8;
      Label lblScript9;
      Label lblScript10;
      int nAnchoVentana = 350; // Ancho de la ventana y de las etiquetas
      Font fntFuente = new Font("", Font.BOLD + Font.ITALIC, 12);

      if (!oGeneral.bVentanaAbierta) {
         oGeneral.bVentanaAbierta = true;

         fraVentana = new Frame("Acerca de...");
         lblScript1 = new Label("Derytas");
         lblScript2 = new Label(
            "Diseo de Bases de Datos usando Esquemas EER y");
         lblScript3 = new Label("Traduccin Automtica a SQL");
         lblScript4 = new Label("Proyecto Fin de Carrera");
         lblScript5 = new Label("Realizado por: Jos David Quero Snchez");
         lblScript6 = new Label("Dirigido por: Jos Galindo Gmez");
         lblScript7 = new Label(
            "Ingeniera Tcnica en Informtica de Sistemas");
         lblScript8 = new Label("Universidad de Mlaga");
         lblScript9 = new Label("Ao 2004");
         lblScript10 = new Label();

         // lblScript1
         lblScript1.setBounds(new Rectangle(0,
                                            clsConstantes.nSEP_VVER +
                                            clsConstantes.nSEP_COM,
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript1.setAlignment(Label.CENTER);
         lblScript1.setFont(new Font("Times", Font.BOLD + Font.ITALIC, 20));

         // lblScript2
         lblScript2.setBounds(new Rectangle(0,
                                            lblScript1.getY() +
                                            lblScript1.getHeight() +
                                            2 * clsConstantes.nSEP_COM,
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript2.setAlignment(Label.CENTER);
         lblScript2.setFont(fntFuente);

         // lblScript3
         lblScript3.setBounds(new Rectangle(0,
                                            lblScript2.getY() +
                                            lblScript2.getHeight(),
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript3.setAlignment(Label.CENTER);
         lblScript3.setFont(fntFuente);

         // lblScript4
         lblScript4.setBounds(new Rectangle(0,
                                            lblScript3.getY() +
                                            lblScript3.getHeight() +
                                            2 * clsConstantes.nSEP_COM,
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript4.setAlignment(Label.CENTER);
         lblScript4.setFont(fntFuente);

         // lblScript5
         lblScript5.setBounds(new Rectangle(0,
                                            lblScript4.getY() +
                                            lblScript4.getHeight(),
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript5.setAlignment(Label.CENTER);
         lblScript5.setFont(fntFuente);

         // lblScript6
         lblScript6.setBounds(new Rectangle(0,
                                            lblScript5.getY() +
                                            lblScript5.getHeight(),
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript6.setAlignment(Label.CENTER);
         lblScript6.setFont(fntFuente);

         // lblScript7
         lblScript7.setBounds(new Rectangle(0,
                                            lblScript6.getY() +
                                            lblScript6.getHeight() +
                                            2 * clsConstantes.nSEP_COM,
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript7.setAlignment(Label.CENTER);
         lblScript7.setFont(fntFuente);

         // lblScript8
         lblScript8.setBounds(new Rectangle(0,
                                            lblScript7.getY() +
                                            lblScript7.getHeight(),
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript8.setAlignment(Label.CENTER);
         lblScript8.setFont(fntFuente);

         // lblScript9
         lblScript9.setBounds(new Rectangle(0,
                                            lblScript8.getY() +
                                            lblScript8.getHeight(),
                                            nAnchoVentana,
                                            clsConstantes.nALTO_COM));
         lblScript9.setAlignment(Label.CENTER);
         lblScript9.setFont(fntFuente);

         fraVentana.add(lblScript1);
         fraVentana.add(lblScript2);
         fraVentana.add(lblScript3);
         fraVentana.add(lblScript4);
         fraVentana.add(lblScript5);
         fraVentana.add(lblScript6);
         fraVentana.add(lblScript7);
         fraVentana.add(lblScript8);
         fraVentana.add(lblScript9);
         fraVentana.add(lblScript10);
         fraVentana.setSize(nAnchoVentana, 300);
         fraVentana.setResizable(false);
         fraVentana.setIconImage(imgLogo);
         oGeneral.CentrarVentana(fraVentana);
         fraVentana.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               fraVentana.dispose();
               oGeneral.bVentanaAbierta = false;
            } // windowClosing
         });
         fraVentana.setVisible(true);
         repaint();
      } // if
   } // Info

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: Modificar                                                 //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana apropiada para modificar el elemento    //
   //              seleccionado                                               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Modificar() {
      // Comprobar si hay alguna ventana abierta
      if (!oGeneral.bVentanaAbierta) {
         oGeneral.oModificar = oGeneral.oElementoActual;
         // Comprobar el tipo de elemento
         if ( (oGeneral.oElementoActual.nTipo == clsConstantes.nENTIDAD) ||
             (oGeneral.oElementoActual.nTipo == clsConstantes.nENTIDAD_DEBIL)) {
            clsEntidad oEntidad = new clsEntidad(oGeneral, oConfig,
                                                 clsConstantes.nMODO_MODIFICAR); // Crear el objeto ventana Entidad
         } // if
         else if ( (oGeneral.oElementoActual.nTipo ==
                    clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nESPECIALIZACION_SOLAPADA_PARCIAL) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nESPECIALIZACION_SOLAPADA_TOTAL)) {
            new clsEspecializacion(oGeneral, oConfig,
                                   clsConstantes.nMODO_MODIFICAR);
         } // else if
         else if ( (oGeneral.oElementoActual.nTipo ==
                    clsConstantes.nTIPO_UNION_PARCIAL) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nTIPO_UNION_TOTAL)) {
            new clsTipoUnion(oGeneral, oConfig, clsConstantes.nMODO_MODIFICAR);
         } // else if
         else if ( (oGeneral.oElementoActual.nTipo ==
                    clsConstantes.nTIPO_INTERSECCION_PARCIAL) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nTIPO_INTERSECCION_TOTAL)) {
            new clsTipoInterseccion(oGeneral, oConfig,
                                    clsConstantes.nMODO_MODIFICAR);
         } // else if
         else if ( (oGeneral.oElementoActual.nTipo == clsConstantes.nRELACION) ||
                  (oGeneral.oElementoActual.nTipo ==
                   clsConstantes.nRELACION_IDENTIFICATIVA)) {
            new clsRelacion(oGeneral, oConfig, clsConstantes.nMODO_MODIFICAR);
         } // else if

         // Indicar que hay una ventana abierta
         oGeneral.bVentanaAbierta = true;
      } // if
      else {
         // Mostrar la ventana que hay abierta
         oGeneral.MostrarActual();
      } // else
   } // Procedimiento: Modificar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procediiento: EliminarComoSubclase                                      //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la ventana para eliminar la relacin superclase-   //
   //              subclase entre dos entidades                               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void EliminarComoSubclase() {
      new clsEliminarComoSubclase(oGeneral);
   } // Procedimiento: EliminarComoSubclase

} // Clase: Derytas
