package Derytas;

import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsConfig                                                           //
// Mtodos: - public clsConfig: Constructor de la clase                       //
//          - public void Mostrar: Muestra la ventana                         //
//          - private void GuardarConfiguracion: Actualiza las variables de   //
//            configuracin                                                   //
//          - private void Ocultar: Cierra la ventana                         //
// Descripcin: Gestiona las opciones de configuracin de la aplicacin       //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class clsConfig
   extends Frame {

   // Variables de clase
   public int nVerAtributos; // Indica los atributos que se visualizan
   public int nOpcionEsp; // Opcin para la generacin de cdigo de las especializaciones
   public boolean bCerrar; // Indica si las ventanas se cierran o no tras crear o modificar un elemento
   public boolean bComentScript; // Indica si se generan comentarios en el script
   public boolean bComentDic; // Indica si se generan comentarios en el diccionario de la base de datos
   private clsGeneral oGeneral; // Objeto de la clase clsGeneral
   private int nAnchoCheckVentana; // Ancho particular para los CheckBox de la ventana

   // Componentes de la ventana
   private Checkbox chbCerrar; // Opcin para cerrar las ventanas
   private Label lblAtributos; // Etiqueta para la visualizacin de atributos
   private CheckboxGroup cbgAtributos; // CheckboxGroup para la opcin de visualizacin de atributos
   private Checkbox chbTodos; // Opcin para ver todos los atributos
   private Checkbox chbInmediatos; // Opcin para ver los atributos del primer nivel
   private Checkbox chbNinguno; // Opcin para no ver atributos
   private Label lblEspecializaciones; // Etiqueta para la opcin de las especializaciones
   private CheckboxGroup cbgEspecializaciones; // CheckboxGroup para la opcin de las especializaciones
   private Checkbox chbOpcionA; // Opcin de generacin A para las especializaciones
   private Checkbox chbOpcionB; // Opcin de generacin B para las especializaciones
   private Checkbox chbOpcionC; // Opcin de generacin C para las especializaciones
   private Checkbox chbOpcionD; // Opcin de generacin D para las especializaciones
   private Label lblComentarios; // Etiqueta para la generacin de comentarios
   private Checkbox chbScript; // Opcin para incluir comentarios en el script
   private Checkbox chbDiccionario; // Opcin para incluir comentarios en el diccionario de la bbdd
   private Button btnGuardar; // Botn para guardar los valores de la ventana
   private Button btnCancelar; // Opcin para cerrar la ventana sin guardar los valores de la ventana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsConfig                                                //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsConfig(clsGeneral poGeneral) {

      // Inicializacin de variables

      // Asignar el objeto de la clase clsGeneral
      oGeneral = poGeneral;
      // Establecer el ancho para los Checkbox de la ventana
      nAnchoCheckVentana = 100;

      // Crear los componentes de la ventana
      chbCerrar = new Checkbox("Cerrar las Ventanas");
      lblAtributos = new Label("Lista de Atributos que se muestran");
      cbgAtributos = new CheckboxGroup();
      chbTodos = new Checkbox(clsConstantes.sTODOS,
                              cbgAtributos,
                              (nVerAtributos == clsConstantes.nTODOS));
      chbInmediatos = new Checkbox(clsConstantes.sINMEDIATOS,
                                   cbgAtributos,
                                   (nVerAtributos ==
                                    clsConstantes.nINMEDIATOS));
      chbNinguno = new Checkbox(clsConstantes.sNINGUNO, cbgAtributos,
                                (nVerAtributos == clsConstantes.nNINGUNO));
      lblEspecializaciones = new Label("Opcin para las Especializaciones");
      cbgEspecializaciones = new CheckboxGroup();
      chbOpcionA = new Checkbox(clsConstantes.sOPCION_A,
                                cbgEspecializaciones,
                                (nOpcionEsp == clsConstantes.nOPCION_A));
      chbOpcionB = new Checkbox(clsConstantes.sOPCION_B,
                                cbgEspecializaciones,
                                (nOpcionEsp == clsConstantes.nOPCION_B));
      chbOpcionC = new Checkbox(clsConstantes.sOPCION_C,
                                cbgEspecializaciones,
                                (nOpcionEsp == clsConstantes.nOPCION_C));
      chbOpcionD = new Checkbox(clsConstantes.sOPCION_D,
                                cbgEspecializaciones,
                                (nOpcionEsp == clsConstantes.nOPCION_D));
      lblComentarios = new Label("Generar Comentarios");
      chbScript = new Checkbox("En el Script");
      chbDiccionario = new Checkbox(
         "En el Diccionario de la Base de Datos");
      btnGuardar = new Button("Guardar");
      btnCancelar = new Button("Cancelar");

      // Propiedades de los componentes de la ventana

      // chbCerrar
      // Establecer tamao y posicin
      chbCerrar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        clsConstantes.nSEP_VVER,
                                        clsConstantes.nANCHO_CHECKBOX,
                                        clsConstantes.nALTO_COM));
      // Obtener la opcin para cerrar de la variable de configuracin
      chbCerrar.setState(bCerrar);

      // lblAtributos
      // Establecer tamao y posicin
      lblAtributos.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                           chbCerrar.getY() +
                                           clsConstantes.nALTO_COM +
                                           clsConstantes.nSEP_COM,
                                           clsConstantes.nANCHO_LABEL,
                                           clsConstantes.nALTO_COM));

      // chbTodos
      // Establecer tamao y posicin
      chbTodos.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                       lblAtributos.getY() +
                                       clsConstantes.nALTO_COM, 54,
                                       clsConstantes.nALTO_COM));

      // chbInmediatos
      // Establecer tamao y posicin
      chbInmediatos.setBounds(new Rectangle(chbTodos.getX() +
                                            chbTodos.getWidth() +
                                            clsConstantes.nSEP_COM,
                                            chbTodos.getY(), 80,
                                            clsConstantes.nALTO_COM));

      // chbNinguno
      // Establecer tamao y posicin
      chbNinguno.setBounds(new Rectangle(chbInmediatos.getX() +
                                         chbInmediatos.getWidth() +
                                         clsConstantes.nSEP_COM,
                                         chbTodos.getY(),
                                         70,
                                         clsConstantes.nALTO_COM));

      // lblEspecializaciones
      // Establecer tamao y posicin
      lblEspecializaciones.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                   chbNinguno.getY() +
                                                   clsConstantes.nALTO_COM +
                                                   clsConstantes.nSEP_COM,
                                                   clsConstantes.nANCHO_LABEL,
                                                   clsConstantes.nALTO_COM));

      // chbOpcionA
      // Establecer tamao y posicin
      chbOpcionA.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                         lblEspecializaciones.getY() +
                                         clsConstantes.nALTO_COM, 70,
                                         clsConstantes.nALTO_COM));

      // chbOpcionB
      // Establecer tamao y posicin
      chbOpcionB.setBounds(new Rectangle(chbOpcionA.getX() +
                                         chbOpcionA.getWidth() +
                                         clsConstantes.nSEP_COM,
                                         chbOpcionA.getY(), 70,
                                         clsConstantes.nALTO_COM));

      // chbOpcionC
      // Establecer tamao y posicin
      chbOpcionC.setBounds(new Rectangle(chbOpcionB.getX() +
                                         chbOpcionB.getWidth() +
                                         clsConstantes.nSEP_COM,
                                         chbOpcionA.getY(), 70,
                                         clsConstantes.nALTO_COM));

      // chbOpcionD
      // Establecer tamao y posicin
      chbOpcionD.setBounds(new Rectangle(chbOpcionC.getX() +
                                         chbOpcionC.getWidth() +
                                         clsConstantes.nSEP_COM,
                                         chbOpcionA.getY(), 70,
                                         clsConstantes.nALTO_COM));

      // lblComentarios
      lblComentarios.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                             chbOpcionD.getY() +
                                             chbOpcionD.getHeight() +
                                             clsConstantes.nSEP_COM,
                                             clsConstantes.nANCHO_LABEL,
                                             clsConstantes.nALTO_COM));

      // chbScript
      // Establecer tamao y posicin
      chbScript.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        lblComentarios.getY() +
                                        lblComentarios.getHeight(),
                                        clsConstantes.nANCHO_CHECKBOX,
                                        clsConstantes.nALTO_COM));
      // Obtener la opcin para comentar el script de la variable de configuracin
      chbScript.setState(bComentScript);

      // chbDiccionario
      // Establecer tamao y posicin
      chbDiccionario.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                             chbScript.getY() +
                                             chbScript.getHeight(),
                                             clsConstantes.nANCHO_CHECKBOX,
                                             clsConstantes.nALTO_COM));
      // Obtener la opcin para comentar el script de la variable de configuracin
      chbDiccionario.setState(bComentDic);

      // btnCancelar
      // Establecer tamao y posicin
      btnCancelar.setBounds(new Rectangle(chbOpcionD.getX() +
                                          chbOpcionD.getWidth() -
                                          clsConstantes.nANCHO_BUTTON,
                                          chbDiccionario.getY() +
                                          chbDiccionario.getHeight() +
                                          clsConstantes.nSEP_COM,
                                          clsConstantes.nANCHO_BUTTON,
                                          clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCancelar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // Evento: addActionListener
      }); // addActionListener

      // btnGuardar
      // Establecer tamao y posicin
      btnGuardar.setBounds(new Rectangle(btnCancelar.getX() -
                                         clsConstantes.nANCHO_BUTTON -
                                         clsConstantes.nSEP_COM,
                                         btnCancelar.getY(),
                                         clsConstantes.nANCHO_BUTTON,
                                         clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnGuardar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            GuardarConfiguracion();
         } // Evento: actionPerformed
      }); // addActionListener

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(oGeneral.nAnchoVentana(btnCancelar.getX()),
              oGeneral.nAltoVentana(btnCancelar.getY()));
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Establecer el icono de la ventana
      setIconImage(oGeneral.imgLogo);
      // Establecer el ttulo de la ventana
      setTitle("Opciones de configuracin");
      // Aadir los componentes a la ventana
      add(chbCerrar);
      add(lblAtributos);
      add(chbTodos);
      add(chbInmediatos);
      add(chbNinguno);
      add(lblEspecializaciones);
      add(chbOpcionA);
      add(chbOpcionB);
      add(chbOpcionC);
      add(chbOpcionD);
      add(lblComentarios);
      add(chbScript);
      add(chbDiccionario);
      add(btnGuardar);
      add(btnCancelar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // No visualizar la ventana
      setVisible(false);
   } // Procedimiento: clsConfig

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Mostrar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Mostrar() {
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana abierta
      oGeneral.EstablecerActual(this);

      // Mostrar la opcin para cerrar las ventanas
      chbCerrar.setState(bCerrar == true);

      // Mostrar la opcin para visualizar los atributos
      chbTodos.setState(nVerAtributos == clsConstantes.nTODOS);
      chbInmediatos.setState(nVerAtributos == clsConstantes.nINMEDIATOS);
      chbNinguno.setState(nVerAtributos == clsConstantes.nNINGUNO);

      // Mostrar la opcin para generar el codigo de las especializaciones
      chbOpcionA.setState(nOpcionEsp == clsConstantes.nOPCION_A);
      chbOpcionB.setState(nOpcionEsp == clsConstantes.nOPCION_B);
      chbOpcionC.setState(nOpcionEsp == clsConstantes.nOPCION_C);
      chbOpcionD.setState(nOpcionEsp == clsConstantes.nOPCION_D);

      // Mostrar la opcin para crear comentarios en el script
      chbScript.setState(bComentScript == true);

      // Mostrar la opcin para insertar comentarios en el diccionario de la BBDD
      chbDiccionario.setState(bComentDic == true);

      // Visualizar la ventana
      setVisible(true);
   } // Procedimiento: Mostrar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Lgica necesaria  para cerrar la ventana                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Ocultar la ventana
      setVisible(false);
      // Indicar que no hay ventana actual
      oGeneral.EstablecerActual(null);
      // Indicar que no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
   } // Ocultar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GuardarConfiguracion                                     //
   // Parmetros: No                                                          //
   // Descripcin: Actualiza el valor de las variables de configuracin con   //
   //              los valores indicados en la ventana                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GuardarConfiguracion() {

      String sVerAtributos; // Opcin de visualizacin de los atributos
      String sOpcionEsp; // Opcin de generacin de las Especializaciones

      // Guardar la opcin de cerrar las ventanas
      bCerrar = chbCerrar.getState();

      // Guardar la visualizacin de los atributos
      sVerAtributos = cbgAtributos.getSelectedCheckbox().getLabel();

      // Guardar la opcin de visualizacin de los atributos
      if (sVerAtributos.equals(clsConstantes.sTODOS)) {
         nVerAtributos = clsConstantes.nTODOS;
      } // if
      else if (sVerAtributos.equals(clsConstantes.sINMEDIATOS)) {
         nVerAtributos = clsConstantes.nINMEDIATOS;
      } // else if
      else if (sVerAtributos.equals(clsConstantes.sNINGUNO)) {
         nVerAtributos = clsConstantes.nNINGUNO;
      } // else if

      // Guardar la opcin de generacin de las Especializaciones
      sOpcionEsp = cbgEspecializaciones.getSelectedCheckbox().getLabel();
      // Guardar la opcin de generacin de las Especializaciones
      if (sOpcionEsp.equals(clsConstantes.sOPCION_A)) {
         nOpcionEsp = clsConstantes.nOPCION_A;
      } // if
      else if (sOpcionEsp.equals(clsConstantes.sOPCION_B)) {
         nOpcionEsp = clsConstantes.nOPCION_B;
      } // else if
      else if (sOpcionEsp.equals(clsConstantes.sOPCION_C)) {
         nOpcionEsp = clsConstantes.nOPCION_C;
      } // else if
      else if (sOpcionEsp.equals(clsConstantes.sOPCION_D)) {
         nOpcionEsp = clsConstantes.nOPCION_D;
      } // else if

      // Guardar la opcin de creacin de comentarios en el script
      bComentScript = chbScript.getState();

      // Guardar la opcin de creacin de comentarios en el diccionario
      bComentDic = chbDiccionario.getState();

      // Cerrar la ventana
      Ocultar();

      // Actualizar el dibujo del esquema
      oGeneral.Repintar();
   } // Procedimiento: GuardarConfiguracion

} // Clase: clsConfig