package Derytas;

import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsEliminarComoSubclase                                             //
// Mtodos: - public clsEliminarComoSubclase: Constructor de la clase         //
//          - private void Eliminar: Elimina la relacin superclase-subclase  //
//            entre dos entidades                                             //
//          - private void Ocultar: Cierra la ventana                         //
// Descripcin: Clase para eliminar la relacin superclase-subclase entre dos //
//              entidades                                                     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
class clsEliminarComoSubclase
   extends Frame {

   // Variables de clase
   private clsGeneral oGeneral; // Objeto de la clase clsGeneral

   // Componentes de la ventana
   private Label lblTexto; // Etiqueta con el texto del mensaje
   private Button btnAceptar; // Botn para eliminar el elmento seleccionado
   private Button btnCancelar; // Botn para no eliminar el elmento seleccionado

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsEliminarComoSubclase                                  //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsEliminarComoSubclase(clsGeneral poGeneral) {

      // Inicializacin de variables

      // Asignar el objeto de la clase clsGeneral
      oGeneral = poGeneral;

      // Crear los componentes de la ventana
      lblTexto = new Label();
      btnAceptar = new Button("Aceptar");
      btnCancelar = new Button("Cancelar");

      // Propiedades de los componentes de la ventana

      // lblMensaje
      // Establecer tamao y posicin
      lblTexto.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                       clsConstantes.nSEP_VVER,
                                       clsConstantes.nANCHO_LABEL + 130,
                                       clsConstantes.nALTO_COM));
      // Mostrar el mensaje segn sea la superclase o la subclase
      if (!oGeneral.oElementoActual.sSubclase.equals("")) {
         lblTexto.setText("Desea que " + oGeneral.oElementoActual.sSubclase +
                          " deje de ser subclase de " +
                          oGeneral.oElementoActual.sNombre +
                          "?");
      } // if
      else {
         lblTexto.setText("Desea que " + oGeneral.oElementoActual.sNombre +
                          " deje de ser subclase de " +
                          oGeneral.oElementoActual.sSuperclase +
                          "?");
      } // else

      // btnCancelar
      // Establecer tamao y posicin
      btnCancelar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR +
                                          clsConstantes.nANCHO_LABEL + 130 -
                                          clsConstantes.nANCHO_BUTTON,
                                          clsConstantes.nSEP_VVER +
                                          clsConstantes.nALTO_COM +
                                          clsConstantes.nSEP_COM,
                                          clsConstantes.nANCHO_BUTTON,
                                          clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCancelar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Mtodo al que se llama cuando se produce el evento
            Ocultar();
         } // actionPerformed
      }); // addActionListener

      // btnAceptar
      // Establecer tamao y posicin
      btnAceptar.setBounds(new Rectangle(btnCancelar.getX() -
                                         clsConstantes.nSEP_COM -
                                         clsConstantes.nANCHO_BUTTON,
                                         btnCancelar.getY(),
                                         clsConstantes.nANCHO_BUTTON,
                                         clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnAceptar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Mtodo al que se llama cuando se produce el evento
            Eliminar();
         } // actionPerformed
      } // ActionListener
      );

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(clsConstantes.nSEP_VHOR +
              clsConstantes.nANCHO_LABEL +
              140 + clsConstantes.nSEP_VHOR,
              2 * clsConstantes.nSEP_VVER +
              clsConstantes.nALTO_COM +
              clsConstantes.nALTO_BUTTON);
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana abierta
      oGeneral.EstablecerActual(this);
      // Aadir los componentes a la ventana
      add(lblTexto);
      add(btnAceptar);
      add(btnCancelar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // Visualizar la ventana
      setVisible(true);
      // Indicar que hay una ventana abierta
      oGeneral.bVentanaAbierta = true;
   } // Procedimiento: clsEliminarComoSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Eliminar                                                 //
   // Parmetros: No                                                          //
   // Descripcin: Elimina la relacin superclase-subclase entre dos          //
   //              entidades                                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Eliminar() {
      // Comprobar desde qu elemento (la superclase o la subclase) se quiere
      // eliminar la relacin entre las dos entidades
      if (!oGeneral.oElementoActual.sSubclase.equals("")) {
         oGeneral.elmElemento(oGeneral.oElementoActual.sSubclase).sSuperclase =
            "";
         oGeneral.oElementoActual.sSubclase = "";
      } // if
      else {
         oGeneral.elmElemento(oGeneral.oElementoActual.sSuperclase).sSubclase =
            "";
         oGeneral.oElementoActual.sSuperclase = "";
      } // else

      // Actualizar el dibujo del esquema
      oGeneral.Repintar();
      // Cerrar la ventana
      Ocultar();
   } // Procedimiento: Eliminar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Realiza la lgica necesaria para ocultar la ventana        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      oGeneral.bVentanaAbierta = false;
      this.dispose();
   } // Procedimiento: Ocultar

} // Clase: clsEliminarComoSubclase
