package Derytas;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsEliminarElemento                                                 //
// Mtodos: - public clsEliminarElemento: Constructor de la clase             //
//          - private void EliminarElemento: Elimina el elemento seleccionado //
//          - private void Ocultar: Cierra la ventana                         //
// Descripcin: Clase para poder eliminar entidades, especializaciones, tipos //
//              unin, tipos interseccin y relaciones                        //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class clsEliminarElemento
   extends Frame {

   // Variables de clase
   private clsGeneral oGeneral; // Objeto de la clase clsGeneral
   private int gnTipo; // Tipo del elmento a eliminar

   // Componentes de la ventana
   private Label lblTexto; // Etiqueta con el texto del mensaje
   private Button btnAceptar; // Botn para eliminar el elmento seleccionado
   private Button btnCancelar; // Botn para no eliminar el elmento seleccionado

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsEliminarElemento                                      //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsEliminarElemento(clsGeneral poGeneral) {

      // Inicializacin de variables

      // Asignar el objeto de la clase clsGeneral
      oGeneral = poGeneral;
      // Obtener el tipo del elmento a eliminar
      gnTipo = oGeneral.oElementoActual.nTipo;

      // Crear los componentes de la ventana
      lblTexto = new Label();
      btnAceptar = new Button("Aceptar");
      btnCancelar = new Button("Cancelar");

      // Propiedades de los componentes de la ventana

      // lblMensaje
      // Establecer tamao y posicin
      lblTexto.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                       clsConstantes.nSEP_VVER,
                                       clsConstantes.nANCHO_LABEL + 130,
                                       clsConstantes.nALTO_COM));
      // Mostrar el mensaje segn el tipo de elemento que se quiere eliminar
      if ( (gnTipo == clsConstantes.nENTIDAD) ||
          (gnTipo == clsConstantes.nENTIDAD_DEBIL)) {
         lblTexto.setText("Desea eliminar la entidad '" +
                          oGeneral.oElementoActual.sNombre +
                          "'?");
      } // if
      else if ( (gnTipo == clsConstantes.nRELACION) ||
               (gnTipo == clsConstantes.nRELACION_IDENTIFICATIVA)) {
         lblTexto.setText("Desea eliminar la relacin '" +
                          oGeneral.oElementoActual.sNombre +
                          "'?");
      } // else if
      else if ( (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
               (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
               (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
               (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL)) {
         lblTexto.setText("Desea eliminar la especializacin '" +
                          oGeneral.oElementoActual.sNombre + "'?");
      } // else if
      else if ( (gnTipo == clsConstantes.nTIPO_UNION_PARCIAL) ||
               (gnTipo == clsConstantes.nTIPO_UNION_TOTAL)) {
         lblTexto.setText("Desea eliminar el tipo unin '" +
                          oGeneral.oElementoActual.sNombre +
                          "'?");
      } // else if
      else {
         lblTexto.setText("Desea eliminar el tipo interseccin '" +
                          oGeneral.oElementoActual.sNombre +
                          "'?");
      } // else

      // btnCancelar
      // Establecer tamao y posicin
      btnCancelar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR +
                                          clsConstantes.nANCHO_LABEL + 130 -
                                          clsConstantes.nANCHO_BUTTON,
                                          clsConstantes.nSEP_VVER +
                                          clsConstantes.nALTO_COM +
                                          clsConstantes.nSEP_COM,
                                          clsConstantes.nANCHO_BUTTON,
                                          clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCancelar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Mtodo al que se llama cuando se produce el evento
            Ocultar();
         } // actionPerformed
      }); // addActionListener

      // btnAceptar
      // Establecer tamao y posicin
      btnAceptar.setBounds(new Rectangle(btnCancelar.getX() -
                                         clsConstantes.nSEP_COM -
                                         clsConstantes.nANCHO_BUTTON,
                                         btnCancelar.getY(),
                                         clsConstantes.nANCHO_BUTTON,
                                         clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnAceptar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Mtodo al que se llama cuando se produce el evento
            EliminarElemento();
         } // actionPerformed
      }); // addActionListener

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(clsConstantes.nSEP_VHOR +
              clsConstantes.nANCHO_LABEL +
              140 + clsConstantes.nSEP_VHOR,
              2 * clsConstantes.nSEP_VVER +
              clsConstantes.nALTO_COM +
              clsConstantes.nALTO_BUTTON);
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana abierta
      oGeneral.EstablecerActual(this);
      // Aadir los componentes a la ventana
      add(lblTexto);
      add(btnAceptar);
      add(btnCancelar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // Visualizar la ventana
      setVisible(true);
      // Indicar que hay una ventana abierta
      oGeneral.bVentanaAbierta = true;
   } // Procedimiento: clsEliminarElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: EliminarElemento                                         //
   // Parmetros: No                                                          //
   // Descripcin: Elimina el elemento seleccionado                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void EliminarElemento() {

      // Declaracin de variables

      int iPosicion; // Posicin del elemento a eliminar en el vector de elementos
      int iReferencia; // ndice para recorrer el vector que referencia al elemento a eliminar
      Vector vReferencia; // Vector con la referencia al elemento a eliminar
      boolean bEncontrado; // Indica si se ha encontrado la referencia al elemento
      clsElemento elmElemento; // Elemento a tratar del vector de elementos

      // Inicializacin de variables
      iPosicion = 0;
      vReferencia = null;

      // Comprobar el tipo de elemento a eliminar
      if ( (gnTipo == clsConstantes.nENTIDAD) ||
          (gnTipo == clsConstantes.nENTIDAD_DEBIL)) {
         // Indicar que no se ha encontrado el elemento
         bEncontrado = false;
         // Iniciar el ndice para recorrer el vector
         iReferencia = 0;
         while ( (!bEncontrado) && (iReferencia < oGeneral.vElementos.size())) {
            if ( ( (clsElemento) oGeneral.vElementos.elementAt(iReferencia)).
                sNombre.
                equals(oGeneral.oElementoActual.sNombre)) {
               // Indicar que se ha encontrado el elemento
               bEncontrado = true;
               // Guardar la posicin donde se ha encontrado el elemento
               iPosicion = iReferencia;
            } // if
            iReferencia++;
         } // while
      } // if
      else {
         // Recorrer el vector de elementos realizando las siguientes acciones:
         // 1.- Si el elemento actual es una entidad, eliminar las posibles
         //      referencias al elemento que vayamos a eliminar
         // 2.- Si se trata del elemento que vamos a eliminar, guardar su
         //     posicin en el vector para eliminarlo del mismo posteriormente
         for (int iIndice = 0; iIndice < oGeneral.vElementos.size(); iIndice++) {
            elmElemento = (clsElemento) oGeneral.vElementos.elementAt(iIndice);
            // Guardar el ndice si se trata del elemento que vamos a modificar
            if (elmElemento.sNombre.equals(oGeneral.oElementoActual.sNombre)) {
               iPosicion = iIndice;
            } // if
            else if ( (elmElemento.nTipo == clsConstantes.nENTIDAD) ||
                     (elmElemento.nTipo == clsConstantes.nENTIDAD_DEBIL)) {
               if ( (gnTipo == clsConstantes.nRELACION) ||
                   (gnTipo == clsConstantes.nRELACION_IDENTIFICATIVA)) {
                  vReferencia = elmElemento.vRelaciones;
               } // if
               if ( (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
                   (gnTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) ||
                   (gnTipo == clsConstantes.nESPECIALIZACION_SOLAPADA_PARCIAL) ||
                   (gnTipo == clsConstantes.nESPECIALIZACION_SOLAPADA_TOTAL)) {
                  vReferencia = elmElemento.vEspecializaciones;
               } // if
               if ( (gnTipo == clsConstantes.nTIPO_UNION_PARCIAL) ||
                   (gnTipo == clsConstantes.nTIPO_UNION_TOTAL)) {
                  vReferencia = elmElemento.vUniones;
               } // if
               if ( (gnTipo == clsConstantes.nTIPO_INTERSECCION_PARCIAL) ||
                   (gnTipo == clsConstantes.nTIPO_INTERSECCION_TOTAL)) {
                  vReferencia = elmElemento.vIntersecciones;
               } // if

               bEncontrado = false;
               iReferencia = 0;
               while ( (!bEncontrado) && (iReferencia < vReferencia.size())) {
                  if ( ( (String) vReferencia.elementAt(iReferencia)).equals(
                     oGeneral.oElementoActual.sNombre)) {
                     vReferencia.removeElementAt(iReferencia);
                     bEncontrado = true;
                  } // if
                  iReferencia++;
               } // while
            } // else if
         } // for
      } // else

      // Quitar el elemento del vector de elementos
      oGeneral.vElementos.removeElementAt(iPosicion);
      // Actualizar el dibujo del esquema
      oGeneral.Repintar();
      // Cerrar la ventana
      Ocultar();
   } // Procedimiento: EliminarElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Realiza la lgica necesaria para ocultar la ventana        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      oGeneral.bVentanaAbierta = false;
      this.dispose();
   } // Procedimiento: Ocultar

} // Clase: clsEliminarElemento
