package Derytas;

import java.util.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsEspecializacion                                                  //
// Mtodos: - public clsEspecializacion: Constructor de la clase              //
//          - private void ActivarAgregarSubclase: Habilita el botn para     //
//            agregar una subclase                                            //
//          - private void ActivarAgregarSuperclase: Habilita el botn para   //
//            agregar una superclase                                          //
//          - private void ActivarQuitarSub: Habilita el botn para quitar    //
//            una subclase                                                    //
//          - private void ActualizarTitulo: Actualiza el ttulo de la        //
//            ventana                                                         //
//          - private void AgregarASubclases: Agrega la especializacion a las //
//            entidades                                                       //
//          - private void AgregarSubclase: Agrega una entidad como subclase  //
//          - private void AgregarSuperclase: Agrega una entidad como         //
//            superclase                                                      //
//          - private boolean bValidar: Comprueba que los datos introducidos  //
//            para la creacin de la especializacin son correctos            //
//          - private void CrearEspecializacin: Crea la especializacin      //
//          - private void HabilitarCrear: Habilita/Deshabiita el botn Crear //
//          - private void LimpiarVentana: Establece los valores iniciales de //
//            la ventana                                                      //
//          - private void Mostrar: Muestra la ventana segn el modo de       //
//            apertura indicado                                               //
//          - private void MostrarAtributo: Muestra el atributo para la       //
//            especializacin                                                 //
//          - private void Ocultar: Cierra la ventana                         //
//          - private void OcultarAtributo: Oculta el atributo para la        //
//            especializacin                                                 //
//          - QuitarEspecializacionEntidades: Desliga la especializacin de   //
//            las entidades                                                   //
//          - private void QuitarSubclase: Quita la subclase de la            //
//            especializacin                                                 //
//          - private void QuitarSuperclase: Quita la superclase de la        //
//            especializacin                                                 //
// Descripcin: Clase para crear y modificar especializaciones                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
class clsEspecializacion
   extends Frame {

   // Variables de clase
   private clsGeneral oGeneral;
   private clsConfig oConfig;
   private clsMensajes oMensajes;
   private int nModo; // Modo de apertura de la ventana

   // Componentes de la ventana
   private Label lblNombre; // Etiqueta para el nombre
   private TextField txtNombre; // Campo para el nombre
   private Label lblAtributo; // Etiqueta para el atributo
   private TextField txtAtributo; // Campo para el atributo
   private Label lblTipo; // Etiqueta para el tipo
   private CheckboxGroup cbgTipo; // CheckboxGroup para el tipo
   private Checkbox chbDisjuntaTotal; // Opcin para disjunta total
   private Checkbox chbDisjuntaParcial; // Opcin para disjunta parcial
   private Checkbox chbSolapadaTotal; // Opcin para solapada total
   private Checkbox chbSolapadaParcial; // Opcin para solapada parcial
   private Label lblListaSuperclase; // Etiqueta para la superclase
   private List lstListaSuperclase; // Lista para las superclases
   private Label lblListaSubclases; // Etiqueta para las subclases
   private List lstListaSubclases; // Lista para las subclases
   private Label lblBtnSuper; // Etiqueta para agregar/quitar la superclase
   private Button btnAgregarSuper; // Botn para agregar la superclase
   private Button btnQuitarSuper; // Botn para quitar la superclase
   private Label lblBtnSub; // Etiqueta para agregar/quitar subclases
   private Button btnAgregarSub; // Botn para agregar subclases
   private Button btnQuitarSub; // Botn para quitar subclases
   private Label lblSubclases; // Etiqueta para las subclases
   private List lstSubclases; // Lista de subclases
   private Button btnCrear; // Botn para crear la especializacin
   private Button btnCerrar; // Botn para cerrar la ventana
   private Checkbox chbCerrar; // Opcin para cerrar la ventana
   private Vector vSubclases; // Vector de subclases
   private Label lblSuperclase; // Etiqueta para la superclase
   private TextField txtSuperclase; // Campo para la superclase
   private String sNombreAntiguo; // Nombre de la especializacin

   /////////////////////////////////////////////////////////////////////////////
   //
   // CLASE       : clsEspecializacion
   //
   // DESCRIPCIN : Constructor de la clase.
   //
   /////////////////////////////////////////////////////////////////////////////
   public clsEspecializacion(clsGeneral poGeneral,
                             clsConfig poConfig,
                             int pnModo) {

      // Inicializacin de variables

      // Asignar el objeto de la clase clsGeneral
      oGeneral = poGeneral;
      // Asignar el objeto de la clase clsConfig
      oConfig = poConfig;
      // Obtener el modo de acceso
      nModo = pnModo;
      // Crear el objeto  de la clase clsMensajes
      oMensajes = new clsMensajes(oGeneral);
      // Definir el tamao para algunos componentes de la ventana
      int nAnchoButton = clsConstantes.nANCHO_BUTTON / 2;
      int nAltoList = clsConstantes.nALTO_LIST / 2;
      int nAnchoLabelButton = clsConstantes.nANCHO_BUTTON +
         2 * clsConstantes.nSEP_COM;

      // Crear los componentes de la ventana
      lblNombre = new Label("Nombre de la Especializacin");
      txtNombre = new TextField();
      lblAtributo = new Label("Nombre del Atributo (Opcional Disjuntas)");
      txtAtributo = new TextField();
      lblTipo = new Label("Tipo de Especializacin");
      cbgTipo = new CheckboxGroup();
      chbDisjuntaTotal = new Checkbox(clsConstantes.
                                      sESPECIALIZACION_DISJUNTA_TOTAL,
                                      cbgTipo, true);
      chbDisjuntaParcial = new Checkbox(clsConstantes.
                                        sESPECIALIZACION_DISJUNTA_PARCIAL,
                                        cbgTipo, false);
      chbSolapadaTotal = new Checkbox(clsConstantes.
                                      sESPECIALIZACION_SOLAPADA_TOTAL,
                                      cbgTipo, false);
      chbSolapadaParcial = new Checkbox(clsConstantes.
                                        sESPECIALIZACION_SOLAPADA_PARCIAL,
                                        cbgTipo, false);
      lblListaSuperclase = new Label("Elegir Entidad Superclase");
      lstListaSuperclase = new List();
      lblListaSubclases = new Label("Elegir Entidades Subclases");
      lstListaSubclases = new List();
      lblBtnSuper = new Label(" Quitar/Agregar");
      lblSuperclase = new Label("Superclase de la Especializacin");
      btnAgregarSuper = new Button(">>");
      btnQuitarSuper = new Button("<<");
      txtSuperclase = new TextField();
      lblBtnSub = new Label(" Quitar/Agregar");
      lblSubclases = new Label("Subclases de la Especializacin");
      lstSubclases = new List();
      btnAgregarSub = new Button(">>");
      btnQuitarSub = new Button("<<");
      btnCrear = new Button("Crear especializacin");
      btnCerrar = new Button("Cancelar");
      chbCerrar = new Checkbox("Cerrar despus de Crear");
      if (nModo == clsConstantes.nMODO_ALTA) {
         vSubclases = new Vector();
      } // if
      else {
         vSubclases = (Vector) oGeneral.oModificar.vSubclases;
      } // else

      // Propiedades de los componentes de la ventana

      // lblNombre
      // Establecer tamao y posicin
      lblNombre.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        clsConstantes.nSEP_VVER,
                                        clsConstantes.nANCHO_LABEL,
                                        clsConstantes.nALTO_COM));

      // txtNombre
      // Establecer tamao y posicin
      txtNombre.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        lblNombre.getY() +
                                        clsConstantes.nALTO_COM,
                                        clsConstantes.nANCHO_TEXTFIELD,
                                        clsConstantes.nALTO_COM));
      // Controlar el teclado
      txtNombre.addKeyListener(new KeyListener() {

         String sNombre; // Nombre de la entidad

         public void keyTyped(KeyEvent e) {
            //  No hace falta
         }; // keyTyped

         public void keyPressed(KeyEvent e) {
            if ( (e.getKeyCode() == e.VK_ENTER) &&
                (! (txtNombre.getText().equals("")))) {
               // Crear la especializacin cuando se pulsa Enter sobre el nombre
               CrearEspecializacion();
            } // if
            else {
               // Habilitar/Deshabilitar el botn Crear
               HabilitarCrear();
               if (txtNombre.getText().length() <= clsConstantes.nMAX_NOMBRE) {
                  // Guardar el nombre escrito hasta el momento
                  sNombre = txtNombre.getText();
                  // Actualizar el ttulo de la ventana
                  ActualizarTitulo();
               } // if
               else {
                  txtNombre.setText(sNombre);
               } // else
            } // else
         } // keyPressed

         public void keyReleased(KeyEvent e) {
            // Habilitar/Deshabilitar el botn Crear
            HabilitarCrear();
            if (txtNombre.getText().length() <= clsConstantes.nMAX_NOMBRE) {
               // Guardar el nombre escrito hasta el momento
               sNombre = txtNombre.getText();
               // Actualizar el ttulo de la ventana
               ActualizarTitulo();
            } // if
            else {
               txtNombre.setText(sNombre);
            } // else
         } // keyReleased
      }); // addKeyListener

      // lblAtributo
      // Establecer tamao y posicin
      lblAtributo.setBounds(new Rectangle(lblNombre.getX() +
                                          clsConstantes.nANCHO_LABEL +
                                          clsConstantes.nSEP_COM,
                                          lblNombre.getY(),
                                          clsConstantes.nANCHO_LABEL,
                                          clsConstantes.nALTO_COM));

      // txtAtributo
      // Establecer tamao y posicin
      txtAtributo.setBounds(new Rectangle(lblAtributo.getX(),
                                          lblAtributo.getY() +
                                          clsConstantes.nALTO_COM,
                                          clsConstantes.nANCHO_TEXTFIELD,
                                          clsConstantes.nALTO_COM));

      // lblTipo
      // Establecer tamao y posicin
      lblTipo.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                      txtNombre.getY() +
                                      clsConstantes.nALTO_COM +
                                      clsConstantes.nSEP_COM,
                                      clsConstantes.nANCHO_LABEL,
                                      clsConstantes.nALTO_COM));

      // chbDisjuntaTotal
      // Establecer tamao y posicin
      chbDisjuntaTotal.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                               lblTipo.getY() +
                                               clsConstantes.nALTO_COM,
                                               clsConstantes.nANCHO_CHECKBOX,
                                               clsConstantes.nALTO_COM));
      // Aadir el componente al listener para cuando cambie la seleccin
      chbDisjuntaTotal.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            // Llamar al mtodo que gestiona el evento
            MostrarAtributo();
         } // Evento: itemStateChanged
      }); // addItemListener

      // chbSolapadaTotal
      // Establecer tamao y posicin
      chbSolapadaTotal.setBounds(new Rectangle(chbDisjuntaTotal.getX() +
                                               clsConstantes.nANCHO_CHECKBOX +
                                               clsConstantes.nSEP_COM,
                                               chbDisjuntaTotal.getY(),
                                               clsConstantes.nANCHO_CHECKBOX,
                                               clsConstantes.nALTO_COM));
      // Aadir el componente al listener para cuando cambie la seleccin
      chbSolapadaTotal.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            // Llamar al mtodo que gestiona el evento
            OcultarAtributo();
         } // Evento: itemStateChanged
      }); // addItemListener

      // chbDisjuntaParcial
      // Establecer tamao y posicin
      chbDisjuntaParcial.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                 chbDisjuntaTotal.getY()
                                                 + clsConstantes.nALTO_COM,
                                                 clsConstantes.nANCHO_CHECKBOX,
                                                 clsConstantes.nALTO_COM));
      // Aadir el componente al listener para cuando cambie la seleccin
      chbDisjuntaParcial.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            // Llamar al mtodo que gestiona el evento
            MostrarAtributo();
         } // Evento: itemStateChanged
      }); // addItemListener

      // chbSolapadaParcial
      // Establecer tamao y posicin
      chbSolapadaParcial.setBounds(new Rectangle(chbDisjuntaParcial.getX() +
                                                 clsConstantes.nANCHO_CHECKBOX +
                                                 clsConstantes.nSEP_COM,
                                                 chbDisjuntaParcial.getY(),
                                                 clsConstantes.nANCHO_CHECKBOX,
                                                 clsConstantes.nALTO_COM));
      // Aadir el componente al listener para cuando cambie la seleccin
      chbSolapadaParcial.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            // Llamar al mtodo que gestiona el evento
            OcultarAtributo();
         } // Evento: itemStateChanged
      }); // addItemListener

      // lblListaSuperclase
      lblListaSuperclase.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                 chbSolapadaParcial.getY() +
                                                 clsConstantes.nALTO_COM +
                                                 clsConstantes.nSEP_COM,
                                                 clsConstantes.nANCHO_LABEL,
                                                 clsConstantes.nALTO_COM));

      // lstListaSuperclase
      // Establecer tamao y posicin
      lstListaSuperclase.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                 lblListaSuperclase.getY() +
                                                 clsConstantes.nALTO_COM,
                                                 clsConstantes.nANCHO_LIST,
                                                 nAltoList));
      // Cargar la lista desplegable para la superclase
      oGeneral.CargarListaSuperclases(lstListaSuperclase);
      // Aadir el componente al listener para cuando cambie la seleccin
      lstListaSuperclase.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblListaSubclases
      // Establecer tamao y posicin
      lblListaSubclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                lstListaSuperclase.getY() +
                                                nAltoList +
                                                clsConstantes.nSEP_COM,
                                                clsConstantes.nANCHO_LABEL,
                                                clsConstantes.nALTO_COM));

      // lstListaSubclases
      // Establecer tamao y posicin
      lstListaSubclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                                lblListaSubclases.getY() +
                                                clsConstantes.nALTO_COM,
                                                clsConstantes.nANCHO_LIST,
                                                nAltoList));
      // Cargar la lista para las subclases
      oGeneral.CargarListaSubclases(lstListaSubclases);
      // Aadir el componente al listener para cuando cambie la seleccin
      lstListaSubclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSuper
      lblBtnSuper.setBounds(new Rectangle(lblListaSuperclase.getX() +
                                          clsConstantes.nANCHO_LABEL +
                                          clsConstantes.nSEP_COM,
                                          lblListaSuperclase.getY(),
                                          nAnchoLabelButton,
                                          clsConstantes.nALTO_COM));

      // btnQuitarSuper
      // Establecer tamao y posicin
      btnQuitarSuper.setBounds(new Rectangle(lblBtnSuper.getX(),
                                             lstListaSuperclase.getY(),
                                             nAnchoButton,
                                             clsConstantes.nALTO_BUTTON));
      // Habilitar el botn si el modo de acceso es modificar
      btnQuitarSuper.setEnabled(nModo == clsConstantes.nMODO_MODIFICAR);
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSuper
      // Establecer tamao y posicin
      btnAgregarSuper.setBounds(new Rectangle(btnQuitarSuper.getX() +
                                              nAnchoButton +
                                              clsConstantes.nSEP_COM,
                                              btnQuitarSuper.getY(),
                                              nAnchoButton,
                                              clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSuper.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSub
      // Establecer tamao y posicin
      lblBtnSub.setBounds(new Rectangle(lblBtnSuper.getX(),
                                        lblListaSubclases.getY(),
                                        nAnchoLabelButton,
                                        clsConstantes.nALTO_COM));

      // btnQuitarSub
      // Establecer tamao y posicin
      btnQuitarSub.setBounds(new Rectangle(lblBtnSub.getX(),
                                           lblBtnSub.getY() +
                                           clsConstantes.nALTO_COM,
                                           nAnchoButton,
                                           clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnQuitarSub.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSub
      // Establecer tamao y posicin
      btnAgregarSub.setBounds(new Rectangle(btnQuitarSub.getX() +
                                            nAnchoButton +
                                            clsConstantes.nSEP_COM,
                                            btnQuitarSub.getY(),
                                            nAnchoButton,
                                            clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSub.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblSuperclase
      // Establecer tamao y posicin
      lblSuperclase.setBounds(new Rectangle(lblBtnSuper.getX() +
                                            clsConstantes.nANCHO_BUTTON +
                                            2 * clsConstantes.nSEP_COM,
                                            lblListaSuperclase.getY(),
                                            clsConstantes.nANCHO_LABEL,
                                            clsConstantes.nALTO_COM));

      // txtSuperclase
      // Establecer tamao y posicin
      txtSuperclase.setBounds(new Rectangle(lblSuperclase.getX(),
                                            lblSuperclase.getY() +
                                            clsConstantes.nALTO_COM,
                                            clsConstantes.nANCHO_TEXTFIELD,
                                            clsConstantes.nALTO_COM));
      // Deshabilitar el campo
      txtSuperclase.setEnabled(false);

      // lblSubclases
      // Establecer tamao y posicin
      lblSubclases.setBounds(new Rectangle(lblSuperclase.getX(),
                                           lblListaSubclases.getY(),
                                           clsConstantes.nANCHO_LABEL,
                                           clsConstantes.nALTO_COM));

      // lstSubclases
      // Establecer tamao y posicin
      lstSubclases.setBounds(new Rectangle(lblSuperclase.getX(),
                                           lblSubclases.getY() +
                                           clsConstantes.nALTO_COM,
                                           clsConstantes.nANCHO_LIST,
                                           nAltoList));
      // Aadir el componente al listener para cuando cambie la seleccin
      lstSubclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarQuitarSub();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnCerrar
      // Establecer tamao y posicin
      btnCerrar.setBounds(new Rectangle(lstSubclases.getX() +
                                        clsConstantes.nANCHO_LIST -
                                        clsConstantes.nANCHO_BUTTON,
                                        lstSubclases.getY() +
                                        nAltoList +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_BUTTON,
                                        clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCerrar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnCrear
      // Establecer tamao y posicin
      btnCrear.setBounds(new Rectangle(btnCerrar.getX() -
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR -
                                       clsConstantes.nSEP_COM,
                                       btnCerrar.getY(),
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR,
                                       clsConstantes.nALTO_BUTTON));
      // Habilitar el botn segun el modo de acceso
      btnCrear.setEnabled(nModo == clsConstantes.nMODO_MODIFICAR);
      // Aadir el componente al listener para cuando se pulse el botn
      btnCrear.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            CrearEspecializacion();
         } // Evento: actionPerformed
      }); // addActionListener

      // chbCerrar
      chbCerrar.setState(oConfig.bCerrar);
      chbCerrar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        btnCrear.getY() +
                                        clsConstantes.nALTO_BUTTON +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_CHECKBOX +
                                        40,
                                        clsConstantes.nALTO_COM));

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(oGeneral.nAnchoVentana(btnCerrar.getX()),
              oGeneral.nAltoVentana(chbCerrar.getY()));
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Establecer el icono de la ventana
      setIconImage(oGeneral.imgLogo);
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana actual
      oGeneral.EstablecerActual(this);
      // Aadir los componenentes a la ventana
      add(lblNombre);
      add(txtNombre);
      add(lblAtributo);
      add(txtAtributo);
      add(lblTipo);
      add(chbDisjuntaTotal);
      add(chbDisjuntaParcial);
      add(chbSolapadaTotal);
      add(chbSolapadaParcial);
      add(lblListaSuperclase);
      add(lblListaSubclases);
      add(lblBtnSuper);
      add(lblSuperclase);
      add(txtSuperclase);
      add(lstListaSuperclase);
      add(lstListaSubclases);
      add(btnAgregarSuper);
      add(btnQuitarSuper);
      add(lblSubclases);
      add(lstSubclases);
      add(lblBtnSub);
      add(btnAgregarSub);
      add(btnQuitarSub);
      add(btnCrear);
      add(btnCerrar);
      add(chbCerrar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // Mostrar los datos de la ventana segn el modo de acceso
      Mostrar();
      // Mostrar la ventana
      setVisible(true);
   } // Procedimiento: clsEspecializacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Lgica necesaria  para cerrar la ventana                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Limpiar la ventana actual
      oGeneral.EstablecerActual(null);
      // Guardar si las ventanas deben cerrarse o no despus de crear
      oConfig.bCerrar = chbCerrar.getState();
      // Indicar que no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
      // Ocultar la ventana
      this.dispose();
   } // Procedimiento: Ocultar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Mostrar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Limpia los campos de la ventana o los informa con los      //
   //              datos de una especializacin segun el modo de acceso       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Mostrar() {
      if (nModo == clsConstantes.nMODO_ALTA) {
         // Limpiar la ventana
         LimpiarVentana();
      } // if
      else {
         // Cambiar el ttulo del botn de crear
         btnCrear.setLabel("Modificar Especializacin");
         // Cambiar el ttulo de la check de cerrar la ventana
         chbCerrar.setLabel("Cerrar despus de Modificar");
         // Cerrar la ventana tras modificar
         chbCerrar.setState(true);
         // Impedir que no se cierre la ventana, inhabilitando la check
         chbCerrar.setEnabled(false);
         // Guardar el Nombre original
         sNombreAntiguo = oGeneral.oModificar.sNombre;
         // Mostrar el Nombre
         txtNombre.setText(sNombreAntiguo);
         // Identificar el tipo de Especializacin
         if (oGeneral.oModificar.nTipo ==
             clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) {
            cbgTipo.setSelectedCheckbox(chbDisjuntaTotal);
            // Mostrar el atributo para la especializacin
            MostrarAtributo();
            if (oGeneral.oModificar.sAtributoEspecializacion.equals(
               clsConstantes.sNO_ATRIBUTO_ESPECIALIZACION)) {
               txtAtributo.setText("");
            } // if
            else {
               txtAtributo.setText(oGeneral.oModificar.
                                   sAtributoEspecializacion);
            } // else
         } // if
         else if (oGeneral.oModificar.nTipo ==
                  clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) {
            cbgTipo.setSelectedCheckbox(chbDisjuntaParcial);
            // Mostrar el atributo para la especializacin
            MostrarAtributo();
            if (oGeneral.oModificar.sAtributoEspecializacion.equals(
               clsConstantes.
               sNO_ATRIBUTO_ESPECIALIZACION)) {
               txtAtributo.setText("");
            } // if
            else {
               txtAtributo.setText(oGeneral.oModificar.
                                   sAtributoEspecializacion);
            } // else
         } // else if
         else if (oGeneral.oModificar.nTipo ==
                  clsConstantes.nESPECIALIZACION_SOLAPADA_TOTAL) {
            cbgTipo.setSelectedCheckbox(chbSolapadaTotal);
            // Ocultar el atributo para la especializacin
            OcultarAtributo();
         } // else if
         else {
            cbgTipo.setSelectedCheckbox(chbSolapadaTotal);
            // Ocultar el atributo para la especializacin
            OcultarAtributo();
         } // else

         // Mostrar la Superclase de la especializacin y quitarlas de las disponibles
         txtSuperclase.setText(oGeneral.oModificar.sSuperclase);
         // Mostrar las entidades Subclase de la especializacin y quitarlas de las disponibles
         for (int i = 0; i < vSubclases.size(); i++) {
            lstSubclases.add( (String) vSubclases.elementAt(i));
         } // for
         // Cambiar el ttulo de la ventana
         setTitle("Especializacin: " + oGeneral.oModificar.sNombre);
      } // if
   } // Procedimiento: Mostrar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSuperclase                                        //
   // Parmetros: No                                                          //
   // Descripcin: Establece la entidad seleccionadao como superclase         //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSuperclase() {
      txtSuperclase.setText(lstListaSuperclase.getSelectedItem());
      lstListaSuperclase.remove(lstListaSuperclase.getSelectedIndex());
      btnAgregarSuper.setEnabled(false);
      btnQuitarSuper.setEnabled(true);
      HabilitarCrear();
   } // Procedimiento: AgregarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSuperclase                                         //
   // Parmetros: No                                                          //
   // Descripcin: Devuelve la superclase a la lista de entidades para        //
   //              para superclases                                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSuperclase() {
      lstListaSuperclase.add(txtSuperclase.getText());
      txtSuperclase.setText("");
      btnQuitarSuper.setEnabled(false);
      btnCrear.setEnabled(false);
   } // Procedimiento: QuitarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSuperclase                                 //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para agregar la superclase               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSuperclase() {
      btnAgregarSuper.setEnabled(txtSuperclase.getText().equals(""));
   } // Procedimiento: ActivarAgregarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSubclase                                   //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para agregar subclases                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSubclase() {
      btnAgregarSub.setEnabled(true);
   } // Procedimiento: ActivarAgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSubclase                                          //
   // Parmetros: No                                                          //
   // Descripcin: Agrega la entidad seleccionada como subclase               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSubclase() {

      String sSubclase; // Nombre de la entidad seleccionada

      // Obtener el nombre de la entidad seleccionada
      sSubclase = lstListaSubclases.getSelectedItem();
      // Aadir la entidad a la lista de subclaes
      lstSubclases.add(sSubclase);
      // Aadir la entidad al vector de subclases
      vSubclases.addElement(sSubclase);
      // Quitar la entidad de la lista de entidades disponibles
      lstListaSubclases.remove(lstListaSubclases.getSelectedIndex());
      // Deshabilitar el botn
      btnAgregarSub.setEnabled(false);
      // Habilitar/Deshabilitar el botn Crear
      HabilitarCrear();
   } //Procedimiento: AgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSubclase                                          //
   // Parmetros: No                                                          //
   // Descripcin: Quita la subclase seleccionada                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSubclase() {

      int iSubclase; // ndice de la subclase seleccionada

      // Obtener el ndice de la subclase seleccionada
      iSubclase = lstSubclases.getSelectedIndex();
      // Eliminar la subclase del vector de subclases
      vSubclases.removeElementAt(iSubclase);
      // Aadir la subclase a la lista de entidades disponibles
      lstListaSubclases.add(lstSubclases.getSelectedItem());
      // Eliminar la subclase de la lista de subclases
      lstSubclases.remove(iSubclase);
      // Deshabilitar el botn
      btnQuitarSub.setEnabled(false);
      // Habilitar/Deshabilitar el botn Crear
      HabilitarCrear();
   } // Procedimiento: QuitarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarQuitarSub                                         //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para quitar subclases                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarQuitarSub() {
      btnQuitarSub.setEnabled(true);
   } // Procedimiento: ActivarQuitarSub

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: HabilitarCrear                                           //
   // Parmetros: No                                                          //
   // Descripcin: Habilita/Deshabilita el botn Crear                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void HabilitarCrear() {
      btnCrear.setEnabled(!txtNombre.getText().equals("") &&
                          (vSubclases.size() > 1) &&
                          !txtSuperclase.getText().equals(""));
   } // Procedimiento: HabilitarCrear

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: LimpiarVentana                                           //
   // Parmetros: No                                                          //
   // Descripcin: Establece los valores iniciales de la ventana              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void LimpiarVentana() {
      txtNombre.setText("");
      setTitle("Nueva Especializacin");
      btnAgregarSuper.setEnabled(false);
      btnAgregarSub.setEnabled(false);
      btnQuitarSuper.setEnabled(false);
      btnQuitarSub.setEnabled(false);
      txtSuperclase.setText("");
      txtAtributo.setText("");
      lstSubclases.removeAll();
      vSubclases.removeAllElements();
      lstListaSuperclase.removeAll();
      lstListaSubclases.removeAll();
      oGeneral.CargarListaSuperclases(lstListaSuperclase);
      oGeneral.CargarListaSubclases(lstListaSubclases);
      btnCrear.setEnabled(false);
      txtNombre.requestFocus();
   } // Procedimiento: LimpiarVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CrearEspecializacion                                     //
   // Parmetros: No                                                          //
   // Descripcin: Crea la especializacin con los datos introducidos en la   //
   //              ventana                                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void CrearEspecializacion() {

      String sNombre; // Nombre de la especializacin
      int nTipo; // Tipo de especializacin
      clsElemento oEntidad; // Objeto para una entidad
      clsElemento oEspecializacion; // Objeto para la especializacin

      String sTipo;

      // Obtener el nombre de la especializacin/generalizacin
      sNombre = oGeneral.sFiltrarNombre(txtNombre.getText());
      // Obtener el tipo de especializacin
      sTipo = cbgTipo.getSelectedCheckbox().getLabel();
      // Asignar el tipo de especializacin
      if (sTipo.equals(clsConstantes.sESPECIALIZACION_DISJUNTA_TOTAL)) {
         nTipo = clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL;
      } // if
      else if (sTipo.equals(clsConstantes.
                            sESPECIALIZACION_DISJUNTA_PARCIAL)) {
         nTipo = clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL;
      } // else if
      else if (sTipo.equals(clsConstantes.sESPECIALIZACION_SOLAPADA_TOTAL)) {
         nTipo = clsConstantes.nESPECIALIZACION_SOLAPADA_TOTAL;
      } // else if
      else {
         nTipo = clsConstantes.nESPECIALIZACION_SOLAPADA_PARCIAL;
      } // else

      // Aadir una nueva especializacin si pasa las validaciones
      if (bValidar(sNombre,
                   nTipo)) {
         if (nModo == clsConstantes.nMODO_ALTA) {
            // Crear el objeto para la nueva especializacin
            oEspecializacion = new clsElemento(oGeneral,
                                               oConfig.nVerAtributos);
            // Asigna el Nombre del elemento
            oEspecializacion.sNombre = sNombre;
            // Asigna el Tipo de elemento
            oEspecializacion.nTipo = nTipo;
            // Asigna la coordenada X de la posicin del elemento
            oEspecializacion.nX = oGeneral.nXInicial;
            // Asigna la coordenada Y de la posicin del elemento
            oEspecializacion.nY = oGeneral.nYInicial;
            // Buscar una posicin libre en el esquema
            while (oGeneral.bEnElemento(oEspecializacion.nX,
                                        oEspecializacion.nY,
                                        false)) {
               // Asigna la coordenada X de la posicin del elemento
               oEspecializacion.nX += clsConstantes.nSEP_COM;
               // Asigna la coordenada Y de la posicin del elemento
               oEspecializacion.nY += clsConstantes.nSEP_COM;
            } // while
            // Asigna el Ancho del elemento
            oEspecializacion.nAncho = clsConstantes.nANCHO_ESPGEN_UNCAT;
            // Asigna el Alto del elemento
            oEspecializacion.nAlto = clsConstantes.nALTO_ESPGEN_UNCAT;
            oEspecializacion.sSuperclase = txtSuperclase.getText();
            oEspecializacion.vSubclases = (Vector) vSubclases.clone();
            // Obtener el atributo de la Especializacin
            oEspecializacion.sAtributoEspecializacion = txtAtributo.
               getText();
            // Asignar la especializacin a la superclase
            oGeneral.elmElemento(oEspecializacion.sSuperclase).vEspecializaciones.add(sNombre);
            // Asignar la especializacin a las subclases
            AgregarASubclases(oEspecializacion);
            // Aadir la especializacin al vector de elementos
            oGeneral.vElementos.addElement(oEspecializacion);
         } // if
         else {
            // Recuperar los datos de la ventana
            oGeneral.oModificar.sNombre = sNombre;
            oGeneral.oModificar.nTipo = nTipo;
            oGeneral.oModificar.sSuperclase = txtSuperclase.getText();
            oGeneral.oModificar.vSubclases = (Vector) vSubclases.clone();
            // Obtener el atributo de la Especializacin
            oGeneral.oModificar.sAtributoEspecializacion = txtAtributo.
               getText();
            // Desligar la especializacin de sus entidades
            QuitarEspecializacionEntidades(sNombreAntiguo);
            // Obtener el objeto para la superclase
            oEntidad = oGeneral.elmElemento(oGeneral.oModificar.sSuperclase);
            // Asignar la especializacin a la superclase
            oEntidad.vEspecializaciones.add(oGeneral.oModificar.sNombre);
            // Asignar la especializacin a las subclases
            AgregarASubclases(oGeneral.oModificar);
         } // else
         oGeneral.oModificar = null;

         // Actualizar la variable global bCerrar con el valor de la ventana
         oConfig.bCerrar = chbCerrar.getState();

         // Comprobar si se debe ocultar la ventana
         if (oConfig.bCerrar) {
            // Ocultar la ventana
            Ocultar();
         } // if
         else {
            // Limpiar la ventana
            LimpiarVentana();
         } // else

         // Actualizar el esquema
         oGeneral.Repintar();
      } // if
   } // Procedimiento: CrearEspecializacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarEspecializacionEntidades                           //
   // Parmetros: No                                                          //
   // Descripcin: Desliga la especializacin de las entidades                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarEspecializacionEntidades(String psNombreAntiguo) {

      int iElemento; // ndice para recorrer el vector de elementos
      clsElemento oElemento; // Elemento actual a tratar
      int iEspecializacion; // ndice para recorrer el vector de relaciones
      boolean bEncontrada;

      for (iElemento = 0; iElemento < oGeneral.vElementos.size(); iElemento++) {
         oElemento = (clsElemento) oGeneral.vElementos.elementAt(iElemento);
         if ( (oElemento.nTipo == clsConstantes.nENTIDAD) ||
             (oElemento.nTipo == clsConstantes.nENTIDAD_DEBIL)) {
            bEncontrada = false;
            iEspecializacion = 0;
            while ( (!bEncontrada) &&
                   (iEspecializacion < oElemento.vEspecializaciones.size())) {
               if ( ( (String) oElemento.vEspecializaciones.elementAt(
                  iEspecializacion)).equals(psNombreAntiguo)) {
                  oElemento.vEspecializaciones.removeElementAt(
                     iEspecializacion);
               } // if
               iEspecializacion++;
            } // while
         } // if
      } // for
   } // Proceidmiento: QuitarEspecializacionEntidades

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bValidar                                                       //
   // Parmetros: - psNombre (String): Nombre del atributo                    //
   //             - pnTipo (int): Tipo de atributo                            //
   // Retorno: Devuelve un valor lgico que indica si se han pasado o no      //
   //          todas las validaciones                                         //
   // Descripcin: Comprueba que los datos para crear la especializacin son  //
   //              correctos, mostrando un mensaje de error para los datos    //
   //              que no sean vlidos                                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private boolean bValidar(String sNombre,
                    int nTipo) {

      boolean bValido = true; // Valor a devolver con el resultado de las validaciones

      // Validar que el nombre no sea vaco
      if (bValido && (sNombre.equals(""))) {
         oMensajes.MostrarMensaje(clsConstantes.sERROR_CAMPO_VACIO,
                                  "Nombre",
                                  this);
         bValido = false;
      }

      // Validar que el elemento no exista ya (si no es modificacin)
      if ( (oGeneral.oModificar == null) ||
          ( (oGeneral.oModificar != null) && (!sNombre.equals(sNombreAntiguo)))) {
         if (bValido &&
             (oGeneral.bExisteElemento(sNombre, nTipo, oGeneral.vElementos))) {
            oMensajes.MostrarMensaje(clsConstantes.sERROR_ELEMENTO_YA_EXISTE,
                                     sNombre,
                                     this);
            bValido = false;
         } // if
      } // if

      // Devolver el valor con el resultado de las validaciones
      return bValido;
   } // Funcin: bValidar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActualizarTitulo                                         //
   // Parmetros: No                                                          //
   // Descripcin: Actualiza el ttulo de la ventana con el valor introducido //
   //              para el nombre despus de aplicarle el filtro              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActualizarTitulo() {
      if (txtNombre.getText().equals("")) {
         setTitle("Nueva Especializacin");
      } // if
      else {
         setTitle("Especializacin: " +
                  oGeneral.sFiltrarNombre(txtNombre.getText()));
      } // else
   } // Procedimiento: ActualizarTitulo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: MostrarAtributo                                          //
   // Parmetros: No                                                          //
   // Descripcin: Muestra la etiqueta y el campo correspondientes al         //
   //              atributo de la especializacin                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void MostrarAtributo() {
      lblAtributo.setVisible(true);
      txtAtributo.setVisible(true);
   } // Procedimiento: MostrarAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: OcultarAtributo                                          //
   // Parmetros: No                                                          //
   // Descripcin: Oculta la etiqueta y el campo correspondientes al atributo //
   //              de la especializacin                                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void OcultarAtributo() {
      lblAtributo.setVisible(false);
      txtAtributo.setVisible(false);
      txtAtributo.setText("");
   } // Procedimiento: OcultarAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarASubclases                                        //
   // Parmetros: No                                                          //
   // Descripcin: Actualiza el ttulo de la ventana con el valor introducido //
   //              para el nombre despus de aplicarle el filtro              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarASubclases(clsElemento oElemento) {

      clsElemento oEntidad; // Objeto para una entidad

      // Recorrer las subclases de la especializacin
      for (int i = 0; i < oElemento.vSubclases.size(); i++) {
         // Obtener el objeto para una subclase
         oEntidad = oGeneral.elmElemento( (String) vSubclases.elementAt(i));
         // Aadir la especializacin a la subclase
         oEntidad.vEspecializaciones.addElement(oElemento.sNombre);
      } // for
   } // Procedimiento: AgregarASubclases

} // Clase: clsEspecializacion
