package Derytas;

import java.applet.*;
import java.util.*;
import java.awt.*;
import java.awt.List;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsGeneral                                                          //
// Mtodos: - public clsGeneral: Constructor de la clase                      //
//          - public clsElemento elmElemento: Devuelve el objeto del esquema  //
//            con el nombre indicado                                          //
//          - public String sIdentificarLlave: Construye una cadena con la    //
//            llave del elemento                                              //
//          - public void CargarListaSuperclases: Carga una lista con las     //
//            entidades que pueden ser superclases                            //
//          - public void CargarListaSubclases: Carga una lista con las       //
//            entidades que pueden ser subclases                              //
//          - public void CargarChoice: Carga una lista con los objetos que   //
//            cumplen los requisitos indicados                                //
//          - public void CargarChoiceDominio: Carga una lista desplegable    //
//            con los dominios                                                //
//          - public void CargarLista: Carga una lista con los objeto del     //
//            tipo indicado                                                   //
//          - public boolean bExisteElemento: Recorre el vector de elementos  //
//            para buscar un elemento                                         //
//          - public boolean bAtributoExistente: Indica si se encuentra un    //
//            atributo con el nombre recibido                                 //
//          - public boolean bLlaveCompuestaOK: Comprueba que una llave       //
//            compuesta es correcta                                           //
//          - public void CentrarVentana: Centra la ventana en pantalla       //
//          - public boolean bCompararAtributosSuperclases: Comprueba que las //
//            superclases del vector recibido tengan la misma llave           //
//          - public boolean bCompararAtributos: Comprueba si dos entidades   //
//            tienen la misma llave                                           //
//          - public boolean bAtributosIguales: Comprueba si dos atributos    //
//            son iguales                                                     //
//          - public String sObtenerTablaSubclase: Devuelve el nombre de la   //
//            tabla para la subclase pasada como parmetro                    //
//          - public String sSuperclaseDeSubclase: Devuelve el nombre de la   //
//            superclase para la subclase recibida                            //
//          - public String sFiltrarNombre: Filtra el nombre recibido         //
//          - public boolean bEsNumero: Indica si el valor recibido es        //
//            numrico                                                        //
//          - public int nAnchoVentana: Devuelve el ancho de la ventana       //
//          - public int nAltoVentana: Devuelve el alto de la ventana         //
//          - public boolean bEnElemento: Indica si se ha pulsado el ratn    //
//            sobre un elemento                                               //
//          - public clsEntRel erObtenerEntRel: Devuelve el objeto con la     //
//            entidad participante con el nombre indicado                     //
//          - public void EliminarAtributo: Elimina el atributo seleccionado  //
//            en la lista de la lista y del vector de atributos               //
//          - public void Repintar: Actualiza el esquema en pantalla          //
//          - public void LimpiarPantalla: Limpia el esquema de su contenido  //
//          - public boolean bPuedeEliminar: Indica si se puede habilitar la  //
//            opcin Elimina Elemento del men                                //
//          - public boolean bPuedeEliminarSub: Indica si se puede habilitar  //
//            la opcin Eliminar como Subclase del men                       //
//          - public void EstablecerActual: Indica la ventana que est        //
//            abierta                                                         //
//          - public Frame fraObtenerActual: Devuelve la ventana que est     //
//            abierta                                                         //
//          - public void MostrarActual: Trae al frente la ventana que est   //
//            abierta                                                         //
//          - public void Subir: Sube el atributo seleccionado en la lista de //
//            atributos                                                       //
//          - public void Bajar: Baja el atributo seleccionado en la lista de //
//            atributos                                                       //
//          - public void ListaClick: Gestiona el evento Click sobre la lista //
//            de atributos                                                    //
//          - public void HabilitarSubirBajar: Habilita/Deshabilita los       //
//            los botones para subir y bajar atributos                        //
//          - private void AsignarSuperllave: Marca los atributos de los      //
//            atributos llave como pertenecientes a una superllave            //
//          - private void AsignarPropietario: Actualiza los atributos de la  //
//            entidad con el nombre de la entidad a la que pertenecen         //
// Descripcin: Clase con los mtodos comunes al resto de clases              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

public class clsGeneral {

   private Frame fraVentanaActual; // Ventana que se est visualizando
   public Vector vElementos; // Vector con los elementos del esquema
   public boolean bVentanaAbierta; // Indica si hay alguna ventana visualizndose
   public clsElemento oElementoActual; // Elemento sobre el que se ha pulsado el raton
   public clsElemento oModificar; // Objeto que se modifica
   public int nXInicial; // Posicin de horizontal de creacin de los elementos
   public int nYInicial; // Posicin de vertical de creacin de los elementos
   private Applet oApplet; // Objeto con el Applet de la aplicacin
   public Image imgLogo; // Icono para mostrar en las ventanas

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsGeneral                                               //
   // Parmetros: - poApplet (Applet): Objeto con el applet de la apliacinde //
   //             - pimgLogo (Image): Imagen con el logo de la aplicacin     //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsGeneral(Applet poApplet,
                     Image pimgLogo) {

      // Inicializacin de variables

      // Recuperar el applet de la aplicacin
      oApplet = poApplet;
      // Recuperar la imagen del logo de la aplicacin
      imgLogo = pimgLogo;
      // Crear el vector de elementos
      vElementos = new Vector();
   } // Procedimiento: clsGeneral

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: elmElemento                                              //
   // Parmetros: - psNombre (String): Nombre del elemento que se quiere      //
   //               recuperar                                                 //
   // Retorno: Objeto del esquema                                             //
   // Descripcin: Devuelve el objeto del esquema con el nombre indicado      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsElemento elmElemento(String psNombre) {

      int iIndice; // Contador para el bucle

      // Inicializar el contador
      iIndice = 0;
      // Recorrer el vector de elementos hasta encontrar el elemento
      while ( (iIndice < vElementos.size()) &&
             (! ( (clsElemento) vElementos.elementAt(iIndice)).sNombre.equals(
         psNombre))) {
         iIndice++;
      } // while

      // Devolver el objeto
      return (clsElemento) vElementos.elementAt(iIndice);
   } // Funcin: elmElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sIdentificarLlave                                              //
   // Parmetros: - pvVector (Vector): Vector de atributos                    //
   // Retorno: Cadena con la llave del elemento                               //
   // Descripcin: Construye una cadena con la llave del elemento             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sIdentificarLlave(Vector pvVector) {

      clsElemento oAtributo; // Objeto para el atributo
      String sLlave = ""; // Cadena con la llave

      // Recorrer el vector recibido
      for (int i = 0; i < pvVector.size(); i++) {
         // Obtener el objeto para el atributo
         oAtributo = (clsElemento) pvVector.elementAt(i);
         // Comprobar si es llave
         if (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) {
            // Aadir el atributo a la cadena
            if (sLlave.equals("")) {
               sLlave = oAtributo.sNombre;
            } // if
            else {
               sLlave += "," + oAtributo.sNombre;
            } // else
            sLlave += sIdentificarLlave(oAtributo.vAtributos);
         } // if
      } // for

      // Devolver la cadena
      return sLlave;
   } // Funcin: sIdentificarLlave

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CargarListaSuperclases                                   //
   // Parmetros: - plstLista (List): Lista donde se cargan los elementos     //
   // Descripcin: Carga una lista con las entidades que pueden ser           //
   //              superclases                                                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CargarListaSuperclases(List plstLista) {

      clsElemento oElemento; // Objeto para un elemento del esquema

      // Limpiar la lista
      plstLista.removeAll();
      // Recorrer el vector de elementos
      for (int i = 0; i < vElementos.size(); i++) {
         // Obtener un elemento del esquema
         oElemento = (clsElemento) vElementos.elementAt(i);
         // Comprobar que cumple los requisitos para ser superclase
         if ( (oElemento.nTipo == clsConstantes.nENTIDAD) &&
             (!oElemento.sLlave.equals("")) &&
             oElemento.sSubclase.equals("") &&
             oElemento.sSuperclase.equals("") &&
             (oElemento.vEspecializaciones.size() == 0) &&
             (oElemento.vUniones.size() == 0) &&
             (oElemento.vIntersecciones.size() == 0)) {
            // Aadir el nombre a la lista
            plstLista.add( ( (clsElemento) vElementos.elementAt(i)).sNombre);
         } // if
      } // for
   } // Procedimiento: CargarLista

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CargarListaSubclases                                     //
   // Parmetros: - plstLista (List): Lista donde se cargan los elementos     //
   // Descripcin: Carga una lista con las entidades que pueden ser           //
   //              subclases                                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CargarListaSubclases(List plstLista) {

      clsElemento oElemento; // Objeto para un elemento del esquema

      // Limpiar la lista
      plstLista.removeAll();
      // Recorrer el vector de elementos
      for (int i = 0; i < vElementos.size(); i++) {
         // Obtener un elemento del esquema
         oElemento = (clsElemento) vElementos.elementAt(i);
         // Comprobar que cumple los requisitos para ser subclase
         if ( (oElemento.nTipo == clsConstantes.nENTIDAD) &&
             oElemento.sLlave.equals("") &&
             oElemento.sSubclase.equals("") &&
             oElemento.sSuperclase.equals("") &&
             (oElemento.vEspecializaciones.size() == 0) &&
             (oElemento.vUniones.size() == 0) &&
             (oElemento.vIntersecciones.size() == 0)) {
            // Aadir el nombre a la lista
            plstLista.add( ( (clsElemento) vElementos.elementAt(i)).sNombre);
         } // if
      } // for
   } // Procedimiento: CargarListaSubclases

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CargarChoice                                             //
   // Parmetros: - pchoChoice (Choice): Lista donde se cargan los elementos  //
   //             - pnTipo (int): Tipo del elemento que se quiere carga       //
   //             - pbVacio (boolean): Indica si se carga el valor "Vaco"    //
   // Descripcin: Carga una lista con los elementos que cumplen con los      //
   //              requisitos indicados                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CargarChoice(Choice pchoChoice,
                            int pnTipo,
                            boolean pbVacio) {

      clsElemento oElemento; // Objeto para un elemento del esquema

      if (pbVacio) {
         pchoChoice.add("Vaco");
      } // if
      // Recorrer el vector de elementos
      for (int i = 0; i < vElementos.size(); i++) {
         // Obtener un elemento del esquema
         oElemento = (clsElemento) vElementos.elementAt(i);
         // Comprobar que el elemento es del tipo deseado
         if (oElemento.nTipo == pnTipo) {
            // Aadir el nombre a la lista
            pchoChoice.add( ( (clsElemento) vElementos.elementAt(i)).sNombre);
         } // if
      } // for
   } // Procedimiento: CargarChoice

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CargarChoiceDominio                                             //
   // Parmetros: - pchoChoice (Choice): Lista donde se cargan los elementos  //
   // Descripcin: Carga una lista desplegable con los dominios               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CargarChoiceDominio(Choice pchoChoice) {
      pchoChoice.add(clsConstantes.sDOMINIO_NUMBER);
      pchoChoice.add(clsConstantes.sDOMINIO_LONG);
      pchoChoice.add(clsConstantes.sDOMINIO_CHAR);
      pchoChoice.add(clsConstantes.sDOMINIO_VARCHAR2);
      pchoChoice.add(clsConstantes.sDOMINIO_NCHAR);
      pchoChoice.add(clsConstantes.sDOMINIO_NVARCHAR2);
      pchoChoice.add(clsConstantes.sDOMINIO_RAW);
      pchoChoice.add(clsConstantes.sDOMINIO_LONG_RAW);
      pchoChoice.add(clsConstantes.sDOMINIO_DATE);
      pchoChoice.add(clsConstantes.sDOMINIO_BLOB);
      pchoChoice.add(clsConstantes.sDOMINIO_CLOB);
      pchoChoice.add(clsConstantes.sDOMINIO_BFILE);
      pchoChoice.add(clsConstantes.sDOMINIO_ROWID);
      pchoChoice.add(clsConstantes.sDOMINIO_UROWID);
   } // Procedimiento: CargarChoiceDominio

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CargarChoiceDominio                                      //
   // Parmetros: - plstLista (List): Lista donde se cargan los elementos     //
   //             - pnTipo (int): Tipo del elemento a cargar en la lista      //
   // Descripcin: Carga una lista con los objetos del tipo indicado          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CargarLista(List plstLista,
                           int pnTipo) {

      clsElemento oElemento; // Objeto para un elemento del esquema

      // Recorrer el vector de elementos
      for (int i = 0; i < vElementos.size(); i++) {
         // Obtener un elemento del esquema
         oElemento = (clsElemento) vElementos.elementAt(i);
         if (oElemento.nTipo == pnTipo) {
            // Aadir el nombre a la lista
            plstLista.add( ( (clsElemento) vElementos.elementAt(i)).sNombre);
         } // if
      } // for
   } // Procedmiento: CargarLista

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bExisteElemento                                                //
   // Parmetros: - psNombre (String): Nombre de un elemento del esquema      //
   //             - pnTipo (int): Tipo del elemento del esquema               //
   //             - pvElementos (Vector): Vector de elementos                 //
   // Retorno: Valor lgico que indica si el elemento ya existe               //
   // Descripcin: Recorre el vector de elementos para buscar un elemento     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bExisteElemento(String psNombre,
                                  int pnTipo,
                                  Vector pvElementos) {

      boolean bEncontrado = false; // Indica si se ha encontrado el elemento
      int iIndice = 0; // ndice para recorrer el vector
      clsElemento oElemento; // Objeto para un elemento del esquema

      if ( (pnTipo == clsConstantes.nATRIBUTO_SIMPLE) ||
          (pnTipo == clsConstantes.nATRIBUTO_DERIVADO) ||
          (pnTipo == clsConstantes.nATRIBUTO_LLAVE) ||
          (pnTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
          (pnTipo == clsConstantes.nATRIBUTO_MULTIVALUADO)) {
         while ( (iIndice < pvElementos.size()) && (!bEncontrado)) {
            oElemento = (clsElemento) pvElementos.elementAt(iIndice);
            if (psNombre.equals(oElemento.sNombre)) {
               bEncontrado = true;
            } // if
            else {
               bEncontrado = bExisteElemento(oElemento.sNombre,
                                             oElemento.nTipo,
                                             oElemento.vAtributos);
            } // else
            iIndice++;
         } // while
      } // if
      else {
         while ( (iIndice < pvElementos.size()) && (!bEncontrado)) {
            oElemento = (clsElemento) pvElementos.elementAt(iIndice);
            if (oElemento.sNombre.equals(psNombre)) {
               bEncontrado = true;
            } // if
            iIndice++;
         } // while
      } // else

      // Devolver el valor de la bsqueda
      return bEncontrado;
   } // Funcin: bExisteElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bAtributoExistente                                             //
   // Parmetros: - psNombre (String): Nombre de un atributo                  //
   //             - pvAtributos (Vector): Vector de atributos                 //
   // Retorno: Valor lgico que indica si existe el atributo                  //
   // Descripcin: Recorre el vector de atributos buscando uno con el nombre  //
   //              recibido                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bAtributoExistente(String psNombre,
                                     Vector pvAtributos) {

      clsElemento oAtributo; // Objeto para el atributo

      // Recorrer el vector de atributos
      for (int i = 0; i < pvAtributos.size(); i++) {
         // Obtener un atributo
         oAtributo = (clsElemento) pvAtributos.elementAt(i);
         if (oAtributo.sNombre.equals(psNombre)) {
            // Se ha encontrado un atributo con el mismo nombre
            return true;
         } // if
         // Buscar en el vector de atributos del atributo
         if (bAtributoExistente(psNombre,
                                oAtributo.vAtributos)) {
            return true;
         } // if
      } // for

      // Devolver "FALSE" porque si se ha llegado aqu es porque no se ha
      // encontrado el atributo
      return false;
   } // Funcin: bExisteElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bLlaveCompuestaOK                                              //
   // Parmetros: - pvAtributos (Vector): Vector de atributos                 //
   // Retorno: Valor lgico que indica si la llave compuesta es correcta      //
   // Descripcin: Recorre el vector de atributos para comprobar que la llave //
   //              est compuesta por atributos simplres                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bLlaveCompuestaOK(Vector pvAtributos) {

      clsElemento oAtributo; // Objeto para el atributo

      // Recorrer el vector de atributos
      for (int i = 0; i < pvAtributos.size(); i++) {
         // Obtener un atributo
         oAtributo = (clsElemento) pvAtributos.elementAt(i);
         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_SIMPLE) {
            // Se ha encontrado un atributo que no es simple
            return false;
         } // if
         if (!bLlaveCompuestaOK(oAtributo.vAtributos)) {
            return false;
         } // if
      } // for

      // Devolver "TRUE" porque si se ha llegado aqu es porque todos los atributos
      // son simples
      return true;
   } // Funcin: bLlaveCompuestaOK

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CentrarVentana                                           //
   // Parmetros: - pfraVentana (Frame): Ventana que se quiere centrar        //
   // Descripcin: Centra en pantalla el Frame recibido                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CentrarVentana(Frame pfraVentana) {
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = pfraVentana.getSize();

      if (frameSize.height > screenSize.height) {
         frameSize.height = screenSize.height;
      }

      if (frameSize.width > screenSize.width) {
         frameSize.width = screenSize.width;
      }

      pfraVentana.setLocation( (screenSize.width - frameSize.width) / 2,
                              (screenSize.height - frameSize.height) / 2);
   } // Procedimiento: CentrarVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bCompararAtributosSuperclases                                  //
   // Parmetros: - pvSuperclases (Vector): Vector de superclases             //
   // Retorno: Valor lgico que indica si las superclases tienen la misma     //
   //          llave                                                          //
   // Descripcin: Recorre el vector de superclases para comprobar si tienen  //
   //              la misma llave                                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bCompararAtributosSuperclases(Vector pvSuperclases) {

      clsElemento oElementoActual; // Superclase que estamos tratando
      clsElemento elmAuxiliar; // Elemento auxiliar para superclases
      int iActual; // Indice de la Superclase que estamos tratando
      int iAuxiliar; // Indice auxiliar para superclases
      boolean bIguales = true; // Indica si todas las llaves son iguales
      int nSuperclases; // Nmero de superclases de la Unin

      // Obtener el nmero de superclases del Elemento (tipo unin o interseccin)
      nSuperclases = pvSuperclases.size();

      // Iniciar el ndice de la superclase actual
      iActual = 0;
      while ( (iActual < nSuperclases) && bIguales) {
         // Obtener la Superclase que queremos tratar
         oElementoActual = elmElemento( (String) pvSuperclases.elementAt(
            iActual));

         // Iniciar el ndice de la superclase con la que queremos comparar
         iAuxiliar = iActual + 1;
         while ( (iAuxiliar < nSuperclases) && bIguales) {
            // Obtener la Superclase con la que comparar
            elmAuxiliar = elmElemento( (String) pvSuperclases.elementAt(
               iAuxiliar));
            // Obtener el resultado parcial de la validacin
            bIguales = bCompararAtributos(oElementoActual, elmAuxiliar);
            // Incrementar el ndice de la Superclase con la que comparar
            iAuxiliar++;
         } // while
         // Incrementar el ndice
         iActual++;
      } // while

      // Devolver el resultado de la comprobacin
      return bIguales;
   } // Funcin: bCompararAtributosSuperclases

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bCompararAtributos                                             //
   // Parmetros: - oSuperclase1 (clsElemento): Superclase                    //
   //             - oSuperclase2 (clsElemento): Superclase                    //
   // Retorno: Valor lgico que indica si las superclases tienen la misma     //
   //          llave                                                          //
   // Descripcin: Comprueba si dos superclases tienen la misma llave         //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bCompararAtributos(clsElemento oSuperclase1,
                                     clsElemento oSuperclase2) {

      clsElemento elmAtributo1; // Atributo de la Superclase1
      clsElemento elmAtributo2; // Atributo de la Superclase2
      int iSuperclase1; // Indice de la Superclase que estamos tratando
      int iSuperclase2; // Indice auxiliar para superclases
      boolean bIguales = true; // Indica si todas las llaves son iguales
      boolean bEnSuperclase2; // Indica si Atributo1 est en Superclase2

      // Iniciar el contador de atributos para la Superclase1
      iSuperclase1 = 0;
      while ( (iSuperclase1 < oSuperclase1.vAtributos.size()) && bIguales) {
         // Elegir el atributo actual para comparar
         elmAtributo1 = (clsElemento) oSuperclase1.vAtributos.elementAt(
            iSuperclase1);

         // Iniciar el contador de atributos para la Superclase2
         iSuperclase2 = 0;
         // Inicialmente no se ha encontrado el Atributo1 en Superclase2
         bEnSuperclase2 = false;
         while ( (iSuperclase2 < oSuperclase2.vAtributos.size()) &&
                !bEnSuperclase2) {
            // Elegir el atributo actual para comparar
            elmAtributo2 = (clsElemento) oSuperclase2.vAtributos.elementAt(
               iSuperclase2);
            bEnSuperclase2 = bAtributosIguales(elmAtributo1, elmAtributo2);
            // Incrementar el contador de atributos de Superclase2
            iSuperclase2++;
         } // while
         // Comprobar si el atributo de la Superclase1 est en la Superclase2
         bIguales = bEnSuperclase2;
         // Incrementar el contador de atributos de Superclase1
         iSuperclase1++;
      } // while

      // Devolver el resultado de la comprobacin
      return bIguales;
   } // Funcin: bCompararAtributos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bAtributosIguales                                              //
   // Parmetros: - oAtributo1 (clsElemento): Atributo                        //
   //             - oAtributo2 (clsElemento): Atributo                        //
   // Retorno: Valor lgico que indica si las superclases tienen la misma     //
   //          llave                                                          //
   // Descripcin: Comprueba si dos atributos son iguales                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bAtributosIguales(clsElemento oAtributo1,
                                    clsElemento oAtributo2) {

      boolean bIguales = false; // Indica si los atributos son iguales o no
      int iAtributo1; // ndice para el Atributo1
      int iAtributo2; // ndice para el Atributo1
      boolean bEncontrado; // Indica si se ha encontrado la componente de
      // un atributo compuesto en otro atributo compuesto
      clsElemento elmSimple1; // Componente simple cuanto Atributo1 es compuesto
      clsElemento elmSimple2; // Componente simple cuanto Atributo2 es compuesto

      if (oAtributo1.nTipo == oAtributo2.nTipo) {
         if (oAtributo1.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            // Considerar el caso en que los atributos son compuestos. En este
            // caso debern tener el mismo nmero de atributos
            if ( (oAtributo1.vAtributos.size() > 0) &&
                (oAtributo2.vAtributos.size() > 0) &&
                (oAtributo1.vAtributos.size() == oAtributo2.vAtributos.size())) {
               // Los atributos compuestos deben tener mismo nombre y dominio
               if (oAtributo1.sNombre.equals(oAtributo2.sNombre) &&
                   oAtributo1.sDominio.equals(oAtributo2.sDominio)) {
                  // Iniciar el ndice para el Atributo1
                  iAtributo1 = 0;
                  // Considerar los atributo como iguales y comprobar si nos hemos equivocado
                  bIguales = true;
                  while ( (iAtributo1 < oAtributo1.vAtributos.size()) &&
                         bIguales) {
                     // Obtener la componente simple del Atributo1 compuesto segun el ndice
                     elmSimple1 = (clsElemento) oAtributo1.vAtributos.
                        elementAt(
                        iAtributo1);
                     // Iniciar el ndice para el Atributo2
                     iAtributo2 = 0;
                     // Iniciar la variable bEncontrado
                     bEncontrado = false;
                     while ( (iAtributo2 < oAtributo2.vAtributos.size()) &&
                            !bEncontrado) {
                        // Obtener la componente simple del Atributo2 compuesto segun el ndice
                        elmSimple2 = (clsElemento) oAtributo2.vAtributos.
                           elementAt(iAtributo2);
                        // Comprobar si los atributos son iguales
                        bEncontrado = bAtributosIguales(elmSimple1, elmSimple2);
                        // Incrementar el ndice para el Atributo2
                        iAtributo2++;
                     } // while
                     // Para que sean iguales debe haber encontrado elmSimple1 en elmAtributo2
                     bIguales = bEncontrado;
                     // Incrementar el ndice para el Atributo1
                     iAtributo1++;
                  } // while
                  bIguales = bAtributosIguales(oAtributo1,
                                               oAtributo2);
               } // if
            } // if
            else if ( (oAtributo1.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                     (oAtributo1.nTipo ==
                      clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                     (oAtributo1.bSuperllave)) {
               // Considerar los atributos iguales si tienen mismo nombre y dominio
               bIguales = (oAtributo1.sNombre.equals(oAtributo2.sNombre) &&
                           oAtributo1.sDominio.equals(oAtributo2.sDominio));
            } // else
         } // if
      } // if

      // Devolver el resultado de la comprobacin
      return bIguales;
   } // Funcin: bAtributosIguales

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sObtenerTablaSubclase                                          //
   // Parmetros: - oSubclase (Elemento) : Subclase cuya tabla a la que       //
   //               pertenece se quiere conocer                               //
   // Retorno: Nombre de la Tabla para la Subclase pasada                     //
   //               como parmetro                                            //
   // Descripcin: Devuelve el nombre de la tabla para la Subclase pasada     //
   //              como parmetro                                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sObtenerTablaSubclase(clsElemento oSubclase,
                                       int pnOpcionEsp) {

      clsElemento oEspecializacion; // Especializacin de la Subclase
      String sTabla; // Nombre de la tabla que generar la Especializacin

      // Obtener la Especializacion de la Subclase
      oEspecializacion = elmElemento( (String) oSubclase.
                                     vEspecializaciones.
                                     elementAt(0));
      if (pnOpcionEsp == clsConstantes.nOPCION_A) {
         sTabla = oSubclase.sNombre;
      } // if
      else if (pnOpcionEsp == clsConstantes.nOPCION_B) {
         if (oEspecializacion.nTipo ==
             clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) {
            // Slo para disjunta-total
            sTabla = oSubclase.sNombre;
         } // if
         else {
            sTabla = oSubclase.sNombre;
         } // else
      } // else if
      else if (pnOpcionEsp == clsConstantes.nOPCION_C) {
         if ( (oEspecializacion.nTipo ==
               clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
             (oEspecializacion.nTipo ==
              clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL)) {
            sTabla = sSuperclaseDeSubclase(oSubclase);
         } // if
         else {
            sTabla = sSuperclaseDeSubclase(oSubclase);
         } // else
      } // else if
      else {
         sTabla = sSuperclaseDeSubclase(oSubclase);
      } // else

      // Devolver el resultado
      return sTabla;
   } // Funcin: sObtenerTablaSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sSuperclaseDeSubclase                                          //
   // Parmetros: - oSubclase (Elemento) : Subclase cuya superclase se quiere //
   //               conocer                                                   //
   // Retorno: Nombre de la superclase                                        //
   // Descripcin: Devuelve el nombre de la superclase para la subclase       //
   //              pasada como parmetro                                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sSuperclaseDeSubclase(clsElemento oSubclase) {
      return elmElemento( (String) oSubclase.vEspecializaciones.elementAt(0)).
         sSuperclase;
   } // Funcin: sSuperclaseDeSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sFiltrarNombre                                                 //
   // Parmetros: - psNombre (String) : Nombre que se quiere filtrar          //
   //               conocer                                                   //
   // Retorno: Nombre filtrado                                                //
   // Descripcin: Filtra el nombre recibido sustituyendo y eliminando        //
   //              caracteres no deseados                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sFiltrarNombre(String psNombre) {

      String sNombre;

      sNombre = psNombre;
      String sReemplazar;
      char cReemplazar;

      // Eliminar la tilde de las vocales en minsculas
      sNombre = sNombre.replaceAll("", "a").replaceAll("",
         "e").replaceAll("", "i").replaceAll("", "o").replaceAll("", "u");
      // Eliminar la tilde de las vocales en maysculas
      sNombre = sNombre.replaceAll("", "A").replaceAll("",
         "E").replaceAll("", "I").replaceAll("", "O").replaceAll("", "U");
      // Eliminar la diresis de las vocales en minsculas
      sNombre = sNombre.replaceAll("", "a").replaceAll("",
         "e").replaceAll("", "i").replaceAll("", "o").replaceAll("", "u");
      // Eliminar la diresis de las vocales en maysculas
      sNombre = sNombre.replaceAll("", "A").replaceAll("",
         "E").replaceAll("", "I").replaceAll("", "O").replaceAll("", "U");
      // Eliminar el circunflejo de las vocales en minsculas
      sNombre = sNombre.replaceAll("", "a").replaceAll("",
         "e").replaceAll("", "i").replaceAll("", "o").replaceAll("", "u");
      // Eliminar el circunflejo de las vocales en maysculas
      sNombre = sNombre.replaceAll("", "A").replaceAll("",
         "E").replaceAll("", "I").replaceAll("", "O").replaceAll("", "U");
      // Eliminar el acentro grave de las vocales en minsculas
      sNombre = sNombre.replaceAll("", "a").replaceAll("",
         "e").replaceAll("", "i").replaceAll("", "o").replaceAll("", "u");
      // Eliminar el acentro grave de las vocales en maysculas
      sNombre = sNombre.replaceAll("", "A").replaceAll("",
         "E").replaceAll("", "I").replaceAll("", "O").replaceAll("", "U");
      // Reemplazar las  por nni
      sNombre = sNombre.replaceAll("", "n");
      // Reemplazar las  por NNI
      sNombre = sNombre.replaceAll("", "N");
      // Reemplazar los espacios en blanco por "_"
      sNombre = sNombre.replaceAll(" ", "_");
      // Reemplazar los caracteres no alfanumricos por "_"
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("@", "_");
      sNombre = sNombre.replaceAll("%", "_");
      sNombre = sNombre.replaceAll("/", "_");
      sNombre = sNombre.replaceAll("=", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("\\[", "_");
      sNombre = sNombre.replaceAll("\\+", "_");
      sNombre = sNombre.replaceAll(">", "_");
      sNombre = sNombre.replaceAll("\\.", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("#", "_");
      sNombre = sNombre.replaceAll("&", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("\\(", "_");
      sNombre = sNombre.replaceAll("\\)", "_");
      sNombre = sNombre.replaceAll("'", "_");
      sNombre = sNombre.replaceAll("\\?", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("!", "_");
      sNombre = sNombre.replaceAll("\\^", "_");
      sNombre = sNombre.replaceAll("`", "_");
      sNombre = sNombre.replaceAll("\\]", "_");
      sNombre = sNombre.replaceAll("\\*", "_");
      sNombre = sNombre.replaceAll("", "_");
      sNombre = sNombre.replaceAll("<", "_");
      sNombre = sNombre.replaceAll(",", "_");
      sNombre = sNombre.replaceAll(";", "_");
      sNombre = sNombre.replaceAll(":", "_");

      // Devolver el nombre filtrado
      return sNombre;
   } // Funcin: sFiltrarNombre

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bEsNumero                                                      //
   // Parmetros: - psCampo (String) : Indica si se ha recibido un nmero     //
   // Retorno: Valor lgico con el valor de la comprobacin                   //
   // Descripcin: Comprueba si el valor recibido es numrico                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bEsNumero(String psCampo) {

      int iIndice; // ndice para recorrer la cadena recibida

      iIndice = 0;
      // Recorrer la cadena recibida
      while (iIndice < psCampo.length()) {
         if ( (psCampo.charAt(iIndice) != '0') &&
             (psCampo.charAt(iIndice) != '1') &&
             (psCampo.charAt(iIndice) != '2') &&
             (psCampo.charAt(iIndice) != '3') &&
             (psCampo.charAt(iIndice) != '4') &&
             (psCampo.charAt(iIndice) != '5') &&
             (psCampo.charAt(iIndice) != '6') &&
             (psCampo.charAt(iIndice) != '7') &&
             (psCampo.charAt(iIndice) != '8') &&
             (psCampo.charAt(iIndice) != '9')) {

            // Indicar que no es un nmero
            return false;
         } // if
         iIndice++;
      } // while

      // Si se llega a este punto es porque es un nmero
      return true;
   } // Funcin: bEsNumero

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: nAnchoVentana                                                  //
   // Parmetros: - pnXbtnCancelar (int) : Coordenada X del boton Cancelar de //
   //               una ventana                                               //
   // Retorno: Ancho de la ventana                                            //
   // Descripcin: A partir del valor pasado como parmetro, calcula el ancho //
   //               que debe tener una ventana                                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public int nAnchoVentana(int pnXbtnCancelar) {
      return (pnXbtnCancelar + clsConstantes.nANCHO_BUTTON +
              clsConstantes.nSEP_VHOR);
   } // Funcin: nAnchoVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: nAltoVentana                                                   //
   // Parmetros: - pnYchbCerrar (int) : Coordenada Y de la check para        //
   //               cerrar la ventana o dejarla abierta                       //
   // Retorno: Alto de la ventana                                             //
   // Descripcin: A partir del valor pasado como parmetro, calcula el alto  //
   //              que debe tener una ventana                                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public int nAltoVentana(int pnYchbCerrar) {
      return (pnYchbCerrar + clsConstantes.nALTO_COM + clsConstantes.nSEP_VVER);
   } // Funcin: nAltoVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bEnElemento                                                    //
   // Parmetros: - pnX (int) : Coordenada X donde se ha pulsado el ratn     //
   //             - pnY (int) : Coordenada Y donde se ha pulsado el ratn     //
   //             - pbReferencia (boolean): Indica si se crea referencia al   //
   //               elemento                                                  //
   // Retorno: bEncontrado (boolean) : Indica si en la posicin pasada hay    //
   //          algn elemento                                                 //
   // Descripcin: Comprueba si en la posicin pasada hay algn elemento. En  //
   //               caso afirmativo devuelve true, y hace que elemMov apunte  //
   //               a dicho elemento                                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bEnElemento(int pnX, int pnY, boolean pbReferencia) {

      boolean bEncontrado; // Indica si ha encontrado un elemento
      int iIndice; // Recorre el vector de vectores
      clsElemento elmAux = null; // Elemento del vector cuya posicin examinamos

      // Inicializacin de variables
      bEncontrado = false;
      iIndice = 0;

      // Mientras no se haya encontrado un elemento en la posicin indicada y
      // queden elementos en el vector para ser examinados se hace esa
      // comprobacin
      while (!bEncontrado && (iIndice < vElementos.size())) {
         elmAux = (clsElemento) vElementos.elementAt(iIndice);
         bEncontrado = (elmAux.nX <= pnX) && (pnX <= (elmAux.nX + elmAux.nAncho)) &&
            (elmAux.nY <= pnY) && (pnY <= (elmAux.nY + elmAux.nAlto));
         iIndice++;
      } // while

      // Si se ha encontrado un elemento en la posicin indicada se hace una
      // referencia al mismo
      if (bEncontrado && pbReferencia) {
         oElementoActual = elmAux;
      } // if

      // Devuelve el resultado de la bsqueda
      return bEncontrado;
   } // Funcin: bEnElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: erObtenerEntRel                                                //
   // Parmetros: - pvVector (Vector) : Vector con entidades participantes en //
   //               una relacin                                              //
   //             - psNombre (String) : Nombre de una entidad                 //
   // Retorno: El objeto con la entidad participante                          //
   // Descripcin: Busca y devuelve la entidad con el nombre indicado en el   //
   //              vector recibido                                            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsEntRel erObtenerEntRel(Vector pvVector,
                                    String psNombre) {

      int iIndice; // ndice para recorrer el vector
      boolean bEncontrado; // Indica si se ha encontrado
      clsEntRel erEntidad = null; // Valor de retorno

      bEncontrado = false;
      iIndice = 0;
      while ( (iIndice < pvVector.size()) && (!bEncontrado)) {
         erEntidad = (clsEntRel) pvVector.elementAt(iIndice);
         if (erEntidad.sNombre.equals(psNombre)) {
            bEncontrado = true;
         } // if
         iIndice++;
      } // while

      // Devolver la entidad participante
      return erEntidad;
   } // Funcin: clsEntRel

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: EliminarAtributo                                         //
   // Parmetros: - plstAtributos (List) : Lista de atributos                 //
   //             - pvAtributos (Vector) : Vector de atributos                //
   //             - pbtnElimAtrib (Button): Botn para eliminar atributos     //
   // Descripcin: Elimina el atributo seleccionado en la lista de la lista y //
   //              del vector recibidos                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void EliminarAtributo(List plstAtributos,
                                Vector pvAtributos,
                                Button pbtnElimAtrib) {

      int iIndice; // ndice del atributo seleccionado

      // Obtener el ndice
      iIndice = plstAtributos.getSelectedIndex();
      // Eliminar el atributo de la lista
      plstAtributos.remove(iIndice);
      // Eliminar el atributo del vector
      pvAtributos.removeElementAt(iIndice);
      // Deshabilitar el botn
      pbtnElimAtrib.setEnabled(false);
   } // Procedimiento: EliminarAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Repintar                                                 //
   // Parmetros: No                                                          //
   // Descripcin: Actualiza el esquema en pantalla                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Repintar() {
      oApplet.repaint();
   } // Procedimiento: Repintar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: LimpiarPantalla                                          //
   // Parmetros: No                                                          //
   // Descripcin: Limpia el esquema de su contenido                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void LimpiarPantalla() {
      // Limpiar el vector con los elementos del esquema
      vElementos.removeAllElements();
      // Repintar el esquema
      Repintar();
   } // Procedimiento: LimpiarPantalla

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bPuedeEliminar                                                 //
   // Parmetros: No                                                          //
   // Retorno: Valor para habilitar el men de Eliminar Elemento              //
   // Descripcin: Indica si se puede habilitar la opcin Eliminar del men   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bPuedeEliminar() {
      return (!bVentanaAbierta) &&
         ( ( (oElementoActual.nTipo == clsConstantes.nENTIDAD) ||
            (oElementoActual.nTipo == clsConstantes.nENTIDAD_DEBIL)) &&
          (oElementoActual.vEspecializaciones.size() == 0) &&
          (oElementoActual.vRelaciones.size() == 0) &&
          (oElementoActual.vUniones.size() == 0) &&
          (oElementoActual.vIntersecciones.size() == 0) &&
          oElementoActual.sSubclase.equals("") &&
          oElementoActual.sSuperclase.equals("") ||
          ( (oElementoActual.nTipo != clsConstantes.nENTIDAD) &&
           (oElementoActual.nTipo != clsConstantes.nENTIDAD_DEBIL)));
   } // Funcin: bEnElemento

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bPuedeEliminarSub                                              //
   // Parmetros: No                                                          //
   // Retorno: Valor para habilitar el men de eliminar                       //
   // Descripcin: Indica si se puede habilitar la opcin                     //
   //              Eliminar como Subclase del men                            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public boolean bPuedeEliminarSub() {
      return (!bVentanaAbierta) &&
         (oElementoActual.nTipo == clsConstantes.nENTIDAD) &&
         (!oElementoActual.sSubclase.equals("") ||
          !oElementoActual.sSuperclase.equals(""));
   } // Funcin: bPuedeEliminarSub

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: EstablecerActual                                         //
   // Parmetros: - pfraVentana (Frame)                                       //
   // Descripcin: Indica la ventana que est abierta                         //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void EstablecerActual(Frame pfraVentana) {
      fraVentanaActual = pfraVentana;
   } // Procedimiento: EstablecerActual

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: fraObtenerActual                                               //
   // Parmetros: No                                                          //
   // Retorno: Ventana que est abierta                                       //
   // Descripcin: Devuelve la ventana que est abierta                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public Frame fraObtenerActual() {
      return fraVentanaActual;
   } // Funcin: fraObtenerActual

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: MostrarActual                                            //
   // Parmetros: No                                                          //
   // Descripcin: Trae al frente la ventana que est abierta                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void MostrarActual() {
      fraVentanaActual.toFront();
   } // Procedimiento: MostrarActual

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Subir                                                    //
   // Parmetros: - plstAtributos (List): Lista con el atributo seleccionado  //
   //             - pvAtributos (Vector): Vector de atributos                 //
   //             - pbtnSubir (Button): Botn para subir atributos            //
   //             - pbtnBajar (Button): Botn para bajar atributos            //
   // Descripcin: Sube el atributo seleccionado en la lista de atributos     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Subir(List plstAtributos,
                     Vector pvAtributos,
                     Button pbtnSubir,
                     Button pbtnBajar) {

      int iIndice; // ndice seleccionado en la lista
      String sAnterior; // Elemento anterior de la lista
      clsElemento elmAnterior; // Elemento anterior en el vector
      clsElemento elmActual; // Elemento a mover

      // Obtener el ndice seleccionado en la lista
      iIndice = plstAtributos.getSelectedIndex();

      if (iIndice > 0) {
         sAnterior = plstAtributos.getItem(iIndice - 1);
         plstAtributos.replaceItem(plstAtributos.getSelectedItem(),
                                   iIndice - 1);
         plstAtributos.replaceItem(sAnterior, iIndice);
         plstAtributos.select(iIndice - 1);

         elmAnterior = (clsElemento) pvAtributos.elementAt(iIndice - 1);
         elmActual = (clsElemento) pvAtributos.elementAt(iIndice);
         pvAtributos.removeElementAt(iIndice);
         pvAtributos.removeElementAt(iIndice - 1);
         pvAtributos.add(iIndice - 1, elmActual);
         pvAtributos.add(iIndice, elmAnterior);
         // Habilitar/Deshabilitar los botones Subir/Bajar
         HabilitarSubirBajar(plstAtributos,
                             pbtnSubir,
                             pbtnBajar);
      } // if
   } // Procedimiento: Subir

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Bajar                                                    //
   // Parmetros: - plstAtributos (List): Lista con el atributo seleccionado  //
   //             - pvAtributos (Vector): Vector de atributos                 //
   //             - pbtnSubir (Button): Botn para subir atributos            //
   //             - pbtnBajar (Button): Botn para bajar atributos            //
   // Descripcin: Baja el atributo seleccionado en la lista de atributos     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void Bajar(List plstAtributos,
                     Vector pvAtributos,
                     Button pbtnSubir,
                     Button pbtnBajar) {

      int iIndice; // ndice seleccionado en la lista
      String sSiguiente; // Elemento siguiente de la lista
      clsElemento elmSiguiente; // Elemento siguiente en el vector
      clsElemento elmActual; // Elemento a mover

      // Obtener el ndice seleccionado en la lista
      iIndice = plstAtributos.getSelectedIndex();

      if (iIndice != (plstAtributos.getItemCount() - 1)) {
         sSiguiente = plstAtributos.getItem(iIndice + 1);
         plstAtributos.replaceItem(plstAtributos.getSelectedItem(),
                                   iIndice + 1);
         plstAtributos.replaceItem(sSiguiente, iIndice);
         plstAtributos.select(iIndice + 1);

         elmSiguiente = (clsElemento) pvAtributos.elementAt(iIndice + 1);
         elmActual = (clsElemento) pvAtributos.elementAt(iIndice);
         pvAtributos.removeElementAt(iIndice + 1);
         pvAtributos.removeElementAt(iIndice);
         pvAtributos.add(iIndice, elmSiguiente);
         pvAtributos.add(iIndice + 1, elmActual);
         // Habilitar/Deshabilitar los botones Subir/Bajar
         HabilitarSubirBajar(plstAtributos,
                             pbtnSubir,
                             pbtnBajar);
      } // if
   } // Procedimiento: Bajar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ListaClick                                               //
   // Parmetros: - pbElimatrib (Button): Botn para eliminar atributos       //
   //             - plstAtributos (List): Lista de atributos                  //
   //             - pbtnSubir (Button): Botn para subir atributos            //
   //             - pbtnBajar (Button): Botn para bajar atributos            //
   // Descripcin: Gestiona el evento Click sobre la lista de atributos       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void ListaClick(Button pbElimatrib,
                          List plstAtributos,
                          Button pbtnSubir,
                          Button pbtnBajar) {

      int iIndice; // ndice seleccionado en la lista

      // Activa el botn para eliminar los atributos
      pbElimatrib.setEnabled(true);

      // Habilitar/Deshabilitar los botones Subir/Bajar
      HabilitarSubirBajar(plstAtributos,
                          pbtnSubir,
                          pbtnBajar);
   } // Procedimiento: ListaClick

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ListaClick                                               //
   // Parmetros: - plstAtributos (List): Lista de atributos                  //
   //             - pbtnSubir (Button): Botn para subir atributos            //
   //             - pbtnBajar (Button): Botn para bajar atributos            //
   // Descripcin: Gestiona el evento Click sobre la lista de atributos       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void HabilitarSubirBajar(List plstAtributos,
                                   Button pbtnSubir,
                                   Button pbtnBajar) {

      int iIndice; // ndice seleccionado en la lista

      // Obtener el ndice seleccionado en la lista
      iIndice = plstAtributos.getSelectedIndex();
      // Activa/Desactiva el botn para subir atributos en la lista
      pbtnSubir.setEnabled(iIndice != 0);
      // Activa/Desactiva el botn para bajar atributos en la lista
      pbtnBajar.setEnabled(iIndice != (plstAtributos.getItemCount() - 1));
   } // Procedimiento: HabilitarSubirBajar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AsignarPropietario                                       //
   // Parmetros: - psNombre (String): Nombre de la entidad o de la relacin  //
   //               a la que pertenece el atributo                            //
   //             - pvAtributos (Vector): Vector de atributos de una entidad, //
   //               de una relacin o de otro atributo                        //
   //               va leyendo                                                //
   // Descripcin: Obtiene las propiedades de la entidad del esquema indicada //
   //              por el ndice que se recibe como parmetro                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AsignarPropietario(String psNombre, Vector pvAtributos) {

      clsElemento oAtributo; // Objeto para contener un atributo

      // Recorrer el vector de atributos
      for (int iIndice = 0; iIndice < pvAtributos.size(); iIndice++) {
         // Obteer el atributo actual
         oAtributo = (clsElemento) pvAtributos.elementAt(iIndice);
         // Asignar el nombre del propietario del atributo
         oAtributo.sElementoAtributo = psNombre;
         // Comprobar si es un atributo compuesto
         if (oAtributo.vAtributos.size() > 0) {
            // Asignar el propietario a los componentes del atributo
            AsignarPropietario(psNombre, oAtributo.vAtributos);
         } // if
      } // for
   } // Procedimiento: AsignarPropietario

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AsignarSuperllave                                        //
   // Parmetros: -  pvAtributos (Vector): Vector de atributos del atributo   //
   // Descripcin: Marca los atributos del atributo como componentes de una   //
   //              superclase para el caso de atributos compuestos llave      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void AsignarSuperllave(Vector pvAtributos) {

      clsElemento oAtributo; // Objeto para contener un atributo

      // Recorrer el vector de atributos
      for (int i = 0; i < pvAtributos.size(); i++) {
         // Obtener el atributo del vector correspondiente al ndice
         oAtributo = (clsElemento) pvAtributos.elementAt(i);
         // Marcar el atributo como componente de una superllave
         oAtributo.bSuperllave = true;
         // Comprobar si es atributo compuesto
         if (oAtributo.vAtributos.size() > 0) {
            // Marcar como superllave los componentes simples del atributo
            AsignarSuperllave(oAtributo.vAtributos);
         } // if
      } // for
   } // Procedimiento: AsignarSuperllave

} // Clase: clsGeneral