package Derytas;

import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsMensajes                                                         //
// Mtodos: - public clsMensajes: Constructor de la clase                     //
//          - public void MostrarMensaje: Abre la ventana de mensajes para    //
//            mostrar el mensaje indicado                                     //
//          - private void Ocultar: Cierra la ventana                         //
// Descripcin: Construye los mensajes que muestra la aplicacin              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class clsMensajes {

   // Variables de clase
   private boolean bAbierta; // Indica si hay una ventana de mensajes abierta
   private clsGeneral oGeneral; // Instancia de la clase clsGeneral

   // Componentes de la ventana
   private Frame fraVentana; // Ventana para mostrar el mensaje
   private Label lblMensaje; // Etiqueta para mostrar el mensaje
   private Frame fraLlamante; // Ventana que lanza el mensaje

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsMensajes                                               //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsMensajes(clsGeneral poGeneral) {

      // Inicializacin de variables

      // Obtener el objeto de la clase clsGeneral
      oGeneral = poGeneral;

      // Crear los componentes de la ventana

      // Crear la etiqueta para mostrar el mensaje
      lblMensaje = new Label();
      // Crear la ventana para mostrar el mensaje
      fraVentana = new Frame("Error");
      // Indicar que no hay ninguna ventana de mensajes abierta
      bAbierta = false;

      // Propiedades de los componentes de la ventana

      // lblMensaje
      // Asignar tamao y posicin
      lblMensaje.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                         clsConstantes.nSEP_VVER,
                                         clsConstantes.
                                         nANCHO_LABEL_MENSAJE,
                                         clsConstantes.nALTO_COM));

      // fraVentana
      // Asignar tamao
      fraVentana.setSize(2 * clsConstantes.nSEP_VHOR +
                         clsConstantes.nANCHO_LABEL_MENSAJE,
                         2 * clsConstantes.nSEP_VVER +
                         clsConstantes.nALTO_COM);
      // Asignar Layout
      fraVentana.setLayout(null);
      // Asignar el logotipo al icono de la ventana
      fraVentana.setIconImage(oGeneral.imgLogo);
      // Aadir componentes
      fraVentana.add(lblMensaje);
      // No permitir que se redimensione la ventana
      fraVentana.setResizable(false);
      // Cerrar la ventana
      oGeneral.CentrarVentana(fraVentana);
      // Controlar el cierre de la ventana
      fraVentana.addWindowListener(
         new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            Ocultar();
         } // windowClosing
      } // WindowAdapter
      );
   } // Procedimiento: Mensajes

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: MostrarMensaje                                           //
   // Parmetros: - psMensaje (String): Mensaje a mostrar                     //
   //             - psParam (String): Parmetro a sustituir en el mensaje     //
   //             - pfraLlamante (Frame): Ventana desde donde se muestra el   //
   //               mensaje                                                   //
   // Descripcin: Abre la ventana de mensajes para mostrar el mensaje        //
   //              indicado                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void MostrarMensaje(String psMensaje,
                              String psParam,
                              Frame pfraLlamante) {

      // Comprobar que no haya abierta una ventana con un mensaje
      if (!bAbierta) {
         // Asignar el frame de la ventana llamante
         fraLlamante = pfraLlamante;
         // Ocultar la ventana desde donde se muestra el mensaje
         pfraLlamante.setVisible(false);
         // Indicar que se abre una ventana con un mensaje
         bAbierta = true;
         // Asignar el mensaje a la etiqueta
         lblMensaje.setText(psMensaje.replaceFirst("%Param", psParam));
         // Mostrar la ventana con el mensaje
         fraVentana.setVisible(true);
      } // if
   } // Procedimiento: MostrarMensaje

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: MostrarMensaje                                           //
   // Parmetros: - psMensaje (String): Mensaje a mostrar                     //
   //             - pfraLlamante (Frame): Ventana desde donde se muestra el   //
   //               mensaje                                                   //
   // Descripcin: Abre la ventana de mensajes para mostrar el mensaje        //
   //              indicado                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void MostrarMensaje(String psMensaje, Frame pfraLlamante) {
      // Comprobar que no haya abierta una ventana con un mensaje
      if (!bAbierta) {
         // Asignar el frame de la ventana llamante
         fraLlamante = pfraLlamante;
         // Ocultar la ventana desde donde se muestra el mensaje
         pfraLlamante.setVisible(false);
         // Indicar que se abre una ventana con un mensaje
         bAbierta = true;
         // Asignar el mensaje a la etiqueta
         lblMensaje.setText(psMensaje);
         // Mostrar la ventana con el mensaje
         fraVentana.setVisible(true);
      } // if
   } // Procedimiento: MostrarMensaje

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: MostrarMensaje                                           //
   // Parmetros: - psMensaje (String): Mensaje a mostrar                     //
   // Descripcin: Abre la ventana de mensajes para mostrar el mensaje        //
   //              indicado                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void MostrarMensaje(String psMensaje) {
      // Comprobar que no haya abierta una ventana con un mensaje
      if (!bAbierta) {
         // Asignar el frame de la ventana llamante
         fraLlamante = null;
         // Indicar que se abre una ventana con un mensaje
         bAbierta = true;
         // Asignar el mensaje a la etiqueta
         lblMensaje.setText(psMensaje);
         // Mostrar la ventana con el mensaje
         fraVentana.setVisible(true);
      } // if
   } // Procedimiento: MostrarMensaje

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Lgica necesaria  para cerrar la ventana                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Ocultar la ventana con el mensaje
      fraVentana.setVisible(false);
      // Indicar que no hay abierta ninguna ventana con mensajes
      bAbierta = false;
      // Mostrar la ventana desde donde se muestra el mensaje
      if (fraLlamante != null) {
         fraLlamante.setVisible(true);
      } // if
   } // Procedimiento: Ocultar

} // Clase: clsMensajes
