package Derytas;

import java.util.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsScript                                                           //
// Mtodos: - public clsScript: Constructor de la clase                       //
//          - private void GenerarScript(): Genera el script a partir del     //
//            esquema                                                         //
//          - private void GenerarExtendidos: Genera el codigo para los       //
//            elementos extendidos                                            //
//          - private void GenerarSubclase: Genera el codigo para una         //
//            superclase o una subclase                                       //
//          - private void GenerarEspecializacion: Genera el cdigo para una  //
//            especializacin                                                 //
//          - private void GenerarEspecializacion_A: Generar el cdigo para   //
//            una especializacin usando la opcin de generacin A            //
//          - private void GenerarEspecializacion_A: Generar el cdigo para   //
//            una especializacin usando la opcin de generacin B            //
//          - private void GenerarEspecializacion_A: Generar el cdigo para   //
//            una especializacin usando la opcin de generacin C            //
//          - private void GenerarEspecializacion_A: Generar el cdigo para   //
//            una especializacin usando la opcin de generacin D            //
//          - private void GenerarUnion_Iguales: genera el codigo para un tipo//
//            unin con llaves iguales                                        //
//          - private void GenerarUnion_Diferentes: genera el codigo para un  //
//            tipo unin con llaves diferentes                                //
//          - private void GenerarInterseccion: Generar el codigo para un tipo//
//            interseccin                                                    //
//          - private void GenerarUnion: Generar el codigo para un tipo unin //
//          - private void GenerarComponentesAtributoMultivaluado: Genera los //
//            componentes de la tabla de un atributo multivaluado             //
//          - GenerarAtributoMultivaluado: Genera el cdigo para un atributo  //
//            multivaluado                                                    //
//          - private void GenerarEntidadPropietaria: Genera el codigo para la//
//            entidad propietaria de otra                                     //
//          - private void GenerarEntidadPropietariaMultivaluadoDebil: Genera //
//            el cdigo de una entidad dbil propietaria de un atributo       //
//            multivaluado                                                    //
//          - private void CompletarEntidadDebil: Completa la llave de una    //
//            entidad dbil que participa en una relacin no identificativa   //
//          - private void GenerarRelacionIdentificativa: Genera el cdigo    //
//            para una relacin identificativa                                //
//          - private void GenerarEntidad: Genera el cdigo para una entidad  //
//          - private void GenerarEntidadDebil: Genera el cdigo para una     //
//            entidad dbil                                                   //
//          - private void GenerarEntidadUnionDiferente: Genera el cdigo para//
//            una entidad de un tipo unin con llaves diferentes              //
//          - private void GenerarEntidad_B: Genera el cdigo para una entidad//
//            perteneciente a una especializacin con la opcin B             //
//          - private void GenerarEntidad_B: Genera el cdigo para una entidad//
//            perteneciente a una especializacin con la opcin C             //
//          - private void GenerarEntidad_B: Genera el cdigo para una entidad//
//            perteneciente a una especializacin con la opcin D             //
//          - private void EliminarMarcas: Elimina las marcas de las          //
//            plantillas                                                      //
//          - private void GenerarRelacion_11_1N: Genera el cdigo para       //
//            relaciones 1:1 o 1:N para la entidad pasada como parmetro      //
//          - private void GenerarRelacionMasDos: Genera el codigo para       //
//            relaciones de grado mayor que dos                               //
//          - private void GenerarRelacion_NM: Genera el cdigo para          //
//            relaciones N:M                                                  //
//          - private void GenerarEntidadParticipante: Genera el cdigo para  //
//            una entidad participante en una relacin N:M                    //
//          - private void GenerarPropiedadesAtributo: Genera el cdigo para  //
//            las propiedades de un atributo                                  //
//          - private void GenerarPropiedadesAtributo_NM: Genera el cdigo    //
//            para las propiedades de un atributo de la tabla de una relacin //
//            N:M                                                             //
//          - private void GenerarPropiedadesAtributo_NM_Debil: Genera el     //
//            cdigo para las propiedades de un atributo de una entidad debil //
//            para la tabla de una relacin N:M                               //
//          - private void GenerarPropiedadesAtributoMultivaluado: Genera el  //
//            cdigo para las propiedades de un atributo multivaluado         //
//          - private void GenerarPropiedadesAtributoRelacion: Genera el      //
//            cdigo para las propiedades del atributo de una relacin        //
//          - private void GenerarLlaveSubclaseUnion: Genera la llave para la //
//            relacin con una subclase de un tipo unin                      //
//          - private void GenerarLlaveSubclaseInterseccin: Genera la llave  //
//            para la relacin con una subclase de un tipo interseccin       //
//          - private void GenerarAtributosExternos: Genera el cdigo para los//
//            atributos de las llaves externas                                //
//          - private void GenerarAtributosExternosSubclase: Genera el cdigo //
//            para los atributos de las llaves externas de las subclases de   //
//            las especializaciones                                           //
//          - private void GenerarAtributoExternosSuperclase: Genera la llave //
//            externa a la llave ficticia del tipo unin                      //
//          - private void GenerarAtributosPropietaria: Genera el cdigo para //
//            el propietario de un atributo                                   //
//          - private void GenerarAtributosPropietariaMultivaluadoDebil:      //
//            Genera el cdigo correspondiente a una entidad dbil propietaria//
//            de un atributo multivaluado                                     //
//          - private void GenerarAtributosPropietariaDebil: Genera el cdigo //
//            correspondiente a la entidad propietaria de una entidad dbil   //
//            participante en una relacin no identificativa                  //
//          - private void GenerarAtributos: Genera el cdigo correspondiente //
//            a los atributos de un elemento del esquema                      //
//          - private String sBuscarUltimoAtributo: Devuelve el nombre del    //
//            ltimo atributo en el vector recibido                           //
//          - private Vector vBuscarUltimoAtributo: Busca el ltimo atributo, //
//            comprueba si hay atributos llave, restricciones Unique de tabla //
//            y si el ltimo atributo tiene comentario                        //
//          - private void GenerarUniqueTabla: Genera el cdigo para la       //
//            restriccin Unique de tabla                                     //
//          - private String sFormatearComentario: Formatea el comentario para//
//            el script                                                       //
//          - private String sRestUnique: Extrae el nombre de la restriccin  //
//            Unique de la cadena recibida                                    //
//          - private String sAtriUnique: Extrae el nombre del atributo nico //
//            de la cadena recibida                                           //
//          - private void GenerarAtributosUnionDiferente: Genera el cdigo   //
//            para los atributos de un tipo unin con llaves diferentes       //
//          - private void GenerarAtributosSuperclaseUnion: Genera el cdigo  //
//            para los atributos de una superclase de un tipo unin           //
//          - private void GenerarAtributosSubclaseUnion: Genera el cdigo    //
//            para los atributos de la subclase de un tipo unin              //
//          - private void GenerarAtributos_B: Genera el cdigo de los        //
//            atributos de una entidad perteneciente a una especializacin    //
//            usando la opcin de generacin B                                //
//          - private void GenerarAtributos_C: Genera el cdigo de los        //
//            atributos de una entidad perteneciente a una especializacin    //
//            usando la opcin de generacin C                                //
//          - private void GenerarAtributos_D: Genera el cdigo de los        //
//            atributos de una entidad perteneciente a una especializacin    //
//            usando la opcin de generacin D                                //
//          - private void GenerarAtributos_Subclases_D: Genera el cdigo de  //
//            los atributos de una subclase perteneciente a una               //
//            especializacin usando la opcin de generacin D                //
//          - private void GenerarLlaveFicticia:  Generar el codigo para la   //
//            llave ficticia de la Subclase que se est pasando               //
//          - private void GenerarAtributosLlave: Genera el cdigo para los   //
//            atributos llave                                                 //
//          - private void GenerarAtributosLlave_NM: Genera el cdigo para los//
//            atributos llave de una relacin N:M                             //
//          - private void GenerarAtributosLlave_NM_Debil: Genera el codigo   //
//            para los atributos llaves de una entidad dbil participante en  //
//            una relacin N:M                                                //
//          - private void GenerarAtributosRelacion: Generar el cdigo par los//
//            atributos de una relacin                                       //
//          - private void GenerarAtributosRelacionMasDos: Generar el cdigo  //
//            para los atributos de una relacin de grado mayor que dos       //
//          - private void GenerarAtributosRelacion_NM: Generar el cdigo para//
//            los atributos de una relacin N:M                               //
//          - private void GenerarPropiedadesAtributosNM: Generar el cdigo   //
//            para las propiedades de un atributo de una relacin N:M         //
//          - public String sGenerarScript: Construye una cadena con el script//
//            de creacin de la bbdd                                          //
//          - private int nEsSubclase: Indica si una entidad es subclase      //
//          - private clsElemento elmEspecializacionDeSubclase: Devuelve la   //
//            superclase de la subclase recibida                              //
//          - private clsElemento elmEntidadPropietaria: Devuelve la entidad  //
//            propietaria de la dbil que se recibe                           //
//          - private boolean bExisteMultivaluado: Indica si existe un        //
//            atributo multivaluado con el nombre recibido                    //
// Descripcin: Genera el script de creacin de la base de datos del esquema  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class clsScript {

   // Variables de clase
   private String gsTablas; // Cdigo con la creacin de las tablas
   private String gsReferencias; // Cdigo con las referecias de claves externas
   private clsGeneral oGeneral;
   private clsConfig oConfig;

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsScript                                                //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   //             - poConfig (clsConfig): Objeto de la clase clsConfig para   //
   //               poder acceder a las variables de configuracin            //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   ////////////////////////////////////////////////////////////////////////////
   public clsScript(clsGeneral poGeneral,
                    clsConfig poConfig) {
      // Inicializacin de variables

      // Asignar el objeto de la clase clsGeneral
      oGeneral = poGeneral;
      // Asignar el objeto de la clase clsConfig
      oConfig = poConfig;
   } // Procedimiento: clsScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarScript                                            //
   // Parmetros: No                                                          //
   // Descripcin: Genera el script para crear una base de datos a partir de  //
   //              los elementos que componen el esquema que se ha dibujado   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarScript() {

      clsElemento oElemento; // Elemento cuyo cdigo se va a generar

      // Generar el cdigo para especializaciones, tipos unin, tipos interseccin
      // y subclases
      GenerarExtendidos();

      // Recorrer el vector de elementos para generar el cdigo
      for (int iIndice = 0; iIndice < oGeneral.vElementos.size(); iIndice++) {
         // Obtener el elemento actual
         oElemento = (clsElemento) oGeneral.vElementos.elementAt(iIndice);
         // Generar el cdigo correspondiente segn el tipo de elemento
         if (oElemento.nTipo == clsConstantes.nENTIDAD) {
            // Si no es Superclase o Subclase
            if (oElemento.sSuperclase.equals("") &&
                oElemento.sSubclase.equals("") &&
                (oElemento.vEspecializaciones.size() == 0) &&
                (oElemento.vIntersecciones.size() == 0) &&
                (oElemento.vUniones.size() == 0)) {
               // Generar el cdigo correspondiente a una entidad
               GenerarEntidad(oElemento);
            } // if
         } // if

         else if ( (oElemento.nTipo == clsConstantes.nRELACION) &&
                  (oElemento.vEntRel.size() == 2)) {
            // Generar el cdigo correspondiente a una relacin binaria
            GenerarRelacion_NM(oElemento);
         } // else if
         else if ( (oElemento.nTipo == clsConstantes.nRELACION) &&
                  (oElemento.vEntRel.size() > 2)) {
            // Generar el cdigo correspondiente a una relacin n-aria
            GenerarRelacionMasDos(oElemento);
         } // else if
         else if (oElemento.nTipo == clsConstantes.nRELACION_IDENTIFICATIVA) {
            // Generar el cdigo correspondiente a una relacin identificativa
            GenerarRelacionIdentificativa(oElemento);
         } // else if
         else if (oElemento.nTipo == clsConstantes.nATRIBUTO_MULTIVALUADO) {
            // Generar el cdigo correspondiente a un atributo multivaluado
            GenerarAtributoMultivaluado(oElemento);
         } // else if
      } // for

      // Permitir que se vuelva a generar el cdigo
      for (int i = 0; i < oGeneral.vElementos.size(); i++) {
         ( (clsElemento) oGeneral.vElementos.elementAt(i)).bGenerado = false;
      } // for
   } // Procedimiento: GenerarScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarExtendidos                                        //
   // Parmetros: No                                                          //
   // Descripcin: Genera el script correspondiente a subclases,              //
   //              especializaciones, tipos unin y tipos interseccin        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarExtendidos() {

      clsElemento oElemento; // Elemento cuyo cdigo se va a generar

      // Recorrer el vector de elementos para generar el cdigo
      for (int iIndice = 0; iIndice < oGeneral.vElementos.size(); iIndice++) {
         // Obtener el elemento actual
         oElemento = (clsElemento) oGeneral.vElementos.elementAt(iIndice);

         // Generar el cdigo correspondiente segn el tipo de elemento
         if (oElemento.nTipo == clsConstantes.nENTIDAD) {
            // Si es Superclase o Subclase
            if ( (!oElemento.sSuperclase.equals("") ||
                  !oElemento.sSubclase.equals("")) &&
                (oElemento.vEspecializaciones.size() == 0) &&
                (oElemento.vIntersecciones.size() == 0) &&
                (oElemento.vUniones.size() == 0)) {
               GenerarSubclase(oElemento);
            } // if
         } // if
         else if ( (oElemento.nTipo ==
                    clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
                  (oElemento.nTipo ==
                   clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) ||
                  (oElemento.nTipo ==
                   clsConstantes.nESPECIALIZACION_SOLAPADA_PARCIAL) ||
                  (oElemento.nTipo ==
                   clsConstantes.nESPECIALIZACION_SOLAPADA_TOTAL)) {
            GenerarEspecializacion(oElemento);
         } // else if
         else if ( (oElemento.nTipo ==
                    clsConstantes.nTIPO_UNION_PARCIAL) ||
                  (oElemento.nTipo ==
                   clsConstantes.nTIPO_UNION_TOTAL)) {
            GenerarUnion(oElemento);
         } // else if
         else if ( (oElemento.nTipo ==
                    clsConstantes.nTIPO_INTERSECCION_PARCIAL) ||
                  (oElemento.nTipo ==
                   clsConstantes.nTIPO_INTERSECCION_TOTAL)) {
            GenerarInterseccion(oElemento);
         } // else if
      } // for
   } // Procedimiento: GenerarScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarSubclase                                          //
   // Parmetros: - poElemento (clsElemento): Entidad superclase o subclase   //
   // Descripcin: Genera el cdigo para una superclase o una subclase        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarSubclase(clsElemento poElemento) {
      if (poElemento.sSuperclase.equals("")) {
         // Generar el cdigo para la Superclase de la Subclase
         GenerarEntidad(poElemento);
      } // if
      else {
         GenerarEntidad(poElemento);
      } // else
   } // Procedimiento: GenerarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEspecializacion                                   //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para una especializacin                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEspecializacion(clsElemento poElemento) {
      if (oConfig.nOpcionEsp == clsConstantes.nOPCION_A) {
         GenerarEspecializacion_A(poElemento);
      } // if
      else if (oConfig.nOpcionEsp == clsConstantes.nOPCION_B) {
         if (poElemento.nTipo == clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL) {
            // Entrar por la opcin B slosi la Superclase no participa en
            // ninguna relacin. Si no, por la A
            if ( (oGeneral.elmElemento(poElemento.sSuperclase).vRelaciones != null) &&
                (oGeneral.elmElemento(poElemento.sSuperclase).vRelaciones.size() >
                 0)) {
               // Slo para disjunta-total
               GenerarEspecializacion_A(poElemento);
            } // if
            else {
               // Slo para disjunta-total
               GenerarEspecializacion_B(poElemento);
            } // else
         } // if
         else {
            GenerarEspecializacion_A(poElemento);
         } // else
      } // else if
      else if (oConfig.nOpcionEsp == clsConstantes.nOPCION_C) {
         if ( (poElemento.nTipo ==
               clsConstantes.nESPECIALIZACION_DISJUNTA_PARCIAL) ||
             (poElemento.nTipo ==
              clsConstantes.nESPECIALIZACION_DISJUNTA_TOTAL)) {
            GenerarEspecializacion_C(poElemento);
         } // if
         else {
            GenerarEspecializacion_D(poElemento);
         } // else
      } // else if
      else {
         GenerarEspecializacion_D(poElemento);
      } // else
   } // Procedimiento: GenerarEspecializacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEspecializacion_A                                 //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para una especializacin utilizando la    //
   //              opcin de generacin A                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEspecializacion_A(clsElemento poElemento) {

      // Generar el cdigo de la Superclase de la Especializacin
      GenerarEntidad(oGeneral.elmElemento(poElemento.sSuperclase));

      // Generar el codigo de las Subclases de la Especializacin
      for (int i = 0; i < poElemento.vSubclases.size(); i++) {
         GenerarEntidad(oGeneral.elmElemento( (String) poElemento.vSubclases.
                                             elementAt(i)));
      } // for
   } // Procedimiento: GenerarEspecializacion_A

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEspecializacion_B                                 //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para una especializacin utilizando la    //
   //              opcin de generacin B                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEspecializacion_B(clsElemento poElemento) {
      // Generar el codigo de las Subclases de la Especializacin
      for (int i = 0; i < poElemento.vSubclases.size(); i++) {
         GenerarEntidad_B(oGeneral.elmElemento( (String) poElemento.vSubclases.
                                               elementAt(i)));
      } // for
   } // Procedimiento: GenerarEspecializacion_B

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEspecializacion_C                                 //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para una especializacin utilizando la    //
   //              opcin de generacin C                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEspecializacion_C(clsElemento poElemento) {
      // Generar el codigo de la Especializacin
      GenerarEntidad_C(oGeneral.elmElemento(poElemento.sSuperclase), true);

      // Generar el codigo de las Subclases de la Especializacin
      for (int i = 0; i < poElemento.vSubclases.size(); i++) {
         GenerarEntidad_C(oGeneral.elmElemento( (String) poElemento.vSubclases.
                                               elementAt(i)), false);
      } // for

      // Aadir la plantilla para el atributo de la Especializacin
      gsTablas = gsTablas.replaceFirst("%Atributos",
                                       clsConstantes.
                                       sATRIBUTO_ESPECIALIZACION_C);
      // Poner como atributo el nombre de la Especializacin si no se ha indicado
      if (poElemento.sAtributoEspecializacion.equals("")) {
         gsTablas = gsTablas.replaceFirst("%AtributoEsp", poElemento.sNombre);
      } // if
      else {
         gsTablas = gsTablas.replaceFirst("%AtributoEsp",
                                          poElemento.sAtributoEspecializacion);
      } // else

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarEspecializacion_C

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEspecializacion_D                                 //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para una especializacin utilizando la    //
   //              opcin de generacin D                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEspecializacion_D(clsElemento poElemento) {

      int nSubclasesMenos1; // Subclases de la Especializacin menos una

      // Obtener las subclases de la Especializacin
      nSubclasesMenos1 = poElemento.vSubclases.size() - 1;

      // Generar el codigo de la Especializacin
      GenerarEntidad_D(oGeneral.elmElemento(poElemento.sSuperclase), true, false);

      // Generar el codigo de las Subclases de la Especializacin
      for (int i = 0; i <= nSubclasesMenos1; i++) {
         GenerarEntidad_D(oGeneral.elmElemento( (String) poElemento.vSubclases.
                                               elementAt(i)), false,
                          (i == nSubclasesMenos1));
      } // for
   } // Procedimiento: GenerarEspecializacion_D

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarUnion_Iguales                                     //
   // Parmmetros: - poElemento (clsElemento): Tipo unin cuyo cdigo se va a //
   //                generar                                                  //
   // Descripcin: Generar el cdigo para un tipo unin con llaves iguales    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarUnion_Iguales(clsElemento poElemento) {
      // Generar el codigo de las Superclases de la Unin
      for (int i = 0; i < poElemento.vSuperclases.size(); i++) {
         GenerarEntidad(oGeneral.elmElemento( (String) poElemento.vSuperclases.
                                             elementAt(i)));
      } // for

      // Generar el cdigo de la Subclase de la Unin
      GenerarEntidad(oGeneral.elmElemento(poElemento.sSubclase));
   } // Procedimiento: GenerarUnion_Iguales

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarUnion_Diferentes                                  //
   // Parmmetros: - poElemento (clsElemento): Tipo unin cuyo cdigo se va a //
   // Descripcin : Generar el cdigo para un tipo unin con llaves diferentes//
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarUnion_Diferentes(clsElemento poElemento) {
      // Generar el codigo de las Superclases de la Unin
      for (int i = 0; i < poElemento.vSuperclases.size(); i++) {
         GenerarEntidadUnionDiferente(oGeneral.elmElemento( (String)
            poElemento.vSuperclases.elementAt(i)));
      } // for

      // Generar el cdigo de la Subclase de la Unin
      GenerarEntidadUnionDiferente(oGeneral.elmElemento(poElemento.sSubclase));
   } // Procedimiento: GenerarUnion_Diferentes

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarInterseccion                                      //
   // Parmmetros: - poElemento (clsElemento) : Tipo interseccin cuyo cdigo //
   //                se va a generar                                          //
   // Descripcin : Generar el cdigo para un tipo interseccin               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarInterseccion(clsElemento poElemento) {
      // Generar el codigo de las Superclases de la Interseccin
      for (int i = 0; i < poElemento.vSuperclases.size(); i++) {
         GenerarEntidad(oGeneral.elmElemento( (String) poElemento.
                                             vSuperclases.
                                             elementAt(i)));
      } // for

      // Generar el cdigo de la Subclase de la Interseccin
      GenerarEntidad(oGeneral.elmElemento(poElemento.sSubclase));
   } // Procedimiento: GenerarInterseccion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarUnion                                      //
   // Parmmetros: - poElemento (clsElemento) : Tipo unin cuyo cdigo se va  //
   //                a generar                                                //
   // Descripcin : Generar el cdigo para un tipo unin                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarUnion(clsElemento poElemento) {
      if (poElemento.bLlavesIguales) {
         GenerarUnion_Iguales(poElemento);
      } // if
      else {
         GenerarUnion_Diferentes(poElemento);
      } // else
   } // Procedimiento: GenerarUnion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarComponentesAtributoMultivaluado                   //
   // Parmmetros: - poElemento (clsElemento) : Objeto con el elemento a      //
   //                generar                                                  //
   // Descripcin : Genera los componentes de la tabla de un atributo         //
   //               multivaluado                                              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarComponentesAtributoMultivaluado(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para un atributo

      if (poElemento.vAtributos.size() > 0) {

         for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {

            // Obtener el elemento actual
            oAtributo = (clsElemento) poElemento.vAtributos.elementAt(
               iIndice);

            if (oAtributo.nTipo == clsConstantes.nATRIBUTO_MULTIVALUADO) {
               if (!bExisteMultivaluado(oAtributo.sNombre)) {
                  oGeneral.vElementos.addElement(oAtributo);
               } // if

            } // if
            else {
               if (oAtributo.vAtributos.size() > 0) {
                  GenerarComponentesAtributoMultivaluado(oAtributo);
               } // if
               else {
                  // Aadir la plantilla para el atributo
                  gsTablas = gsTablas.replaceFirst("%Atributos",
                     clsConstantes.sATRIBUTO); // AKI

                  // Reemplazar el dominio del atributo
                  gsTablas = gsTablas.replaceFirst("%Dominio",
                     oAtributo.sDominio);

                  // Reemplazar las restricciones del atributo
                  GenerarPropiedadesAtributoMultivaluado(oAtributo);

                  gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                     clsConstantes.sCLAVE_PRIMARIA);

                  // Reemplazar el nombre del atributo
                  gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                                 oAtributo.sNombre);

                  // Reemplazar el nombre de la entidad propietaria
                  gsTablas = gsTablas.replaceAll("%TablaReferencia",
                                                 oAtributo.sElementoAtributo);

               } // else
            } // else
         } // for
      } // if
      else {
         // Aadir la plantilla para el atributo
         gsTablas = gsTablas.replaceFirst("%Atributos",
                                          clsConstantes.sATRIBUTO);

         // Reemplazar el dominio del atributo
         gsTablas = gsTablas.replaceFirst("%Dominio", poElemento.sDominio);

         // Reemplazar las restricciones del atributo
         GenerarPropiedadesAtributoMultivaluado(poElemento);

         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.sCLAVE_PRIMARIA);

         // Reemplazar el nombre del atributo
         gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                        poElemento.sNombre);

      } // else
   } // Procedimiento: GenerarComponentesAtributoMultivaluado

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarComponentesAtributoMultivaluado                   //
   // Parmmetros: - poAtributo (clsElemento) : Objeto con el elemento a      //
   //                generar                                                  //
   // Descripcin : Genera el cdigo para un atributo multivaluado            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributoMultivaluado(clsElemento poAtributo) {

      clsElemento oEntidad; // Objeto para la entidad
      clsElemento oEntidadPropietaria; // Objeto para la entidad propietaria de otra dbil

      // Obtener el elemento propietario del atributo
      oEntidad = oGeneral.elmElemento(poAtributo.sElementoAtributo);

      // Aadir la plantilla de la creacin de la tabla
      gsTablas += clsConstantes.sCREATE_TABLE_MULTIVALUADO;

      // Generar el cdigo asociado a la entidad propietaria
      if (oEntidad.nTipo == clsConstantes.nENTIDAD_DEBIL) {
         // Obtener la entidad propietaria
         oEntidadPropietaria = elmEntidadPropietaria(oEntidad);

         GenerarEntidadPropietaria(oEntidad, true);
         GenerarEntidadPropietariaMultivaluadoDebil(oEntidadPropietaria);

         // Reemplazar el nombre de la entidad
         gsTablas = gsTablas.replaceAll("%TablaReferencia",
                                        oEntidad.sNombre);
         // Reemplazar el nombre de la entidad
         gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                                                  oEntidad.sNombre);

      } // if
      else {
         GenerarEntidadPropietaria(oEntidad, true);
      } // else

      // Reemplazar los atributos de la tabla
      GenerarComponentesAtributoMultivaluado(poAtributo);

      // Reemplazar el nombre de la tabla que se crea
      gsTablas = gsTablas.replaceAll("%AtributoMultivaluado",
                                     poAtributo.sNombre);
      gsTablas = gsTablas.replaceAll("%TablaMultivaluado", oEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%AtributoMultivaluado",
                                               poAtributo.sNombre);
      // Reemplazar el nombre de la entidad
      gsTablas = gsTablas.replaceAll("%NombreTabla", poAtributo.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poAtributo.sNombre);

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarAtributoMultivaluado

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidadPropietaria                                //
   // Parmmetros: - poEntidad (clsElemento) : Objeto con el elemento a       //
   //                generar                                                  //
   // Descripcin : Genera el cdigo de la entidad propietaria de otra        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidadPropietaria(clsElemento poEntidad,
                                          boolean pbMultivaluado) {
      // Aadir la plantilla de nueva referencia para la entidad
      if (pbMultivaluado) {
         gsReferencias += clsConstantes.sCONSTRAINT_FOREIGN_KEY_MULT;
      } // if
      else {
         gsReferencias += clsConstantes.sCONSTRAINT_FOREIGN_KEY;
      }
      // Generar los atributos correspondientes a la entidad
      GenerarAtributosPropietaria(poEntidad, pbMultivaluado);
      // Reemplazar el nombre de la entidad
      gsTablas = gsTablas.replaceAll("%TablaReferencia", poEntidad.sNombre);
      // Reemplazar el nombre de la entidad
      gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                                               poEntidad.sNombre);
   } // Procedimiento: GenerarEntidadPropietaria

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidadPropietariaMultivaluadoDebil               //
   // Parmmetros: - poEntidad (clsElemento) : Objeto con el elemento a       //
   //                generar                                                  //
   // Descripcin : Genera el cdigo de una entidad dbil propietaria de un   //
   //               atributo multivaluado                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidadPropietariaMultivaluadoDebil(clsElemento poEntidad) {
      // Generar los atributos correspondientes a la entidad
      GenerarAtributosPropietariaMultivaluadoDebil(poEntidad);
      // Reemplazar el nombre de la entidad
      gsTablas = gsTablas.replaceAll("%TablaPropietaria", poEntidad.sNombre);
      // Reemplazar el nombre de la entidad
      gsReferencias = gsReferencias.replaceAll("%TablaPropietaria",
                                               poEntidad.sNombre);
   } // Procedimiento: GenerarEntidadPropietariaMultivaluadoDebil

// Completa la llave de la entidad dbil cuando sta participa en otra relacion
   // que no sea la identificativa
   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CompletarEntidadDebil                                    //
   // Parmmetros: - poEntidad (clsElemento) : Objeto con el elemento a       //
   //                generar                                                  //
   // Descripcin : Completa la llave de la entidad dbil cuando sta         //
   //               participa en otra relacion que no sea la identificativa   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void CompletarEntidadDebil(clsElemento poEntidad) {
      // Generar los atributos correspondientes a la entidad
      GenerarAtributosPropietariaDebil(poEntidad);
      // Reemplazar el nombre de la entidad
      gsTablas = gsTablas.replaceAll("%TablaPropietaria", poEntidad.sNombre);
      // Reemplazar el nombre de la entidad
      gsReferencias = gsReferencias.replaceAll("%TablaPropietaria",
                                               poEntidad.sNombre);
   } // Procedimiento: CompletarEntidadDebil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarRelacionIdentificativa                            //
   // Parmetros: - poRelacion (clsElemento): Objeto de con la relacin       //
   //               identificativa de una entidad dibl                       //
   // Descripcin: Genera el cdigo de una relacin identificativa            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarRelacionIdentificativa(clsElemento poRelacion) {

      clsElemento oEntidadDebil; // Objeto para la entidad dbil
      clsElemento oEntidadPropietaria; // Objeto para la entidad propietaria
      clsElemento oAux; // Objeto auxiliar para una de las entidades participantes

      // Obtener la primera entidad participante
      oAux = oGeneral.elmElemento( ( (clsEntRel) poRelacion.vEntRel.elementAt(0)).
                                  sNombre);

      // Comprobar si es la entidad dbil
      if (oAux.nTipo == clsConstantes.nENTIDAD_DEBIL) {
         oEntidadDebil = oAux;
         oEntidadPropietaria = oGeneral.elmElemento( ( (clsEntRel) poRelacion.
            vEntRel.elementAt(1)).sNombre);
      } // if
      else {
         oEntidadDebil = oGeneral.elmElemento( ( (clsEntRel) poRelacion.vEntRel.
                                                elementAt(1)).sNombre);
         oEntidadPropietaria = oAux;
      } // else

      // Generar el codigo asociado a la entidad debil
      GenerarEntidadDebil(oEntidadDebil,
                          oEntidadPropietaria,
                          poRelacion);

   } // Procedimiento: GenerarRelacionIdentificativa

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidad                                           //
   // Parmetros: - poEntidad (clsElemento): Entidad cuyo cdigo se quiere    //
   //               generar                                                   //
   // Descripcin: Construye el cdigo correspondiente a una entidad          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidad(clsElemento poEntidad) {

      String sUltimo = ""; // ltimo atributo de la tabla
      boolean bLlave = false; // Indica si tiene llave
      boolean bUnique = false; // Indica si tiene restriccin Unique
      boolean bComentario = false; // Indica si tiene comentario
      Vector vUltimo; // Vector con el ltimo atributo de la tabla
      clsElemento oEspecializacion; // Especializacin a la que pertenece una entidad

      // Obtener un vector con el ltimo atributo de la entidad
      vUltimo = vBuscarUltimoAtributo(poEntidad.vAtributos,
                                      bLlave,
                                      bUnique);
      // Recuperar el nombre del ltimo atributo de la tabla
      sUltimo = (String) vUltimo.elementAt(0);
      // Obtener si tiene atributo llave
      bLlave = ( (String) vUltimo.elementAt(1)).equals("true");
      // Obtener si tiene restriccin Unique
      bUnique = ( (String) vUltimo.elementAt(2)).equals("true");
      // Obtener si tiene comentario
      bComentario = ( (String) vUltimo.elementAt(3)).equals("true");

      // Aadir la plantilla de la creacin de la tabla
      gsTablas += clsConstantes.sCREATE_TABLE;
      // Reemplazar el comentario para el script de la tabla
      if (oConfig.bComentScript) {
         gsTablas = gsTablas.replaceFirst("%ComentScript",
                                          sFormatearComentario(poEntidad.
            sComentario, true));
      } // if
      else {
         gsTablas = gsTablas.replaceFirst("%ComentScript", "");
      } // else

      // Reemplazar el comentario para el diccionario de la BBDD
      if ( (oConfig.bComentDic) && (!poEntidad.sComentario.equals(""))) {
         gsTablas = gsTablas.replaceFirst("%ComentDic",
                                          clsConstantes.sCOMENTARIO_TABLA);
         gsTablas = gsTablas.replaceFirst("%Comentario",
                                          sFormatearComentario(poEntidad.
            sComentario, false));
      } // if

      // Reemplazar los atributos de la tabla
      GenerarAtributos(poEntidad, sUltimo, bLlave, bUnique, bComentario);

      // Generar relaciones 1:1
      GenerarRelacion_11_1N(poEntidad);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poEntidad.sNombre);

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarEntidad

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidadDebil                                      //
   // Parmetros: - poEntidadDebil (clsElemento): Entidad cuyo cdigo se      //
   //               generar                                                   //
   //             - poEntidadPropietaria (clsElemento): Entidad propietaria   //
   //               de la entidad debil                                       //
   //             - poRelacion (clsElemento): Relacin identificativa         //
   // Descripcin: Construye el cdigo correspondiente a una entidad dbil    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidadDebil(clsElemento poEntidadDebil,
                                    clsElemento poEntidadPropietaria,
                                    clsElemento poRelacion) {

      String sUltimo = ""; // ltimo atributo de la tabla
      boolean bLlave = false; // Indica si tiene llave
      boolean bUnique = false; // Indica si tiene restriccin Unique
      boolean bComentario = false; // Indica si tiene comentario
      Vector vUltimo; // Vector con el ltimo atributo de la tabla

      // Obtener un vector con el ltimo atributo de la entidad
      vUltimo = vBuscarUltimoAtributo(poEntidadDebil.vAtributos,
                                      bLlave,
                                      bUnique);
      // Recuperar el nombre del ltimo atributo de la tabla
      sUltimo = (String) vUltimo.elementAt(0);
      // Obtener si tiene atributo llave
      bLlave = ( (String) vUltimo.elementAt(1)).equals("true");
      // Obtener si tiene restriccin Unique
      bUnique = ( (String) vUltimo.elementAt(2)).equals("true");
      // Obtener si tiene comentario
      bComentario = ( (String) vUltimo.elementAt(3)).equals("true");

      // Aadir la plantilla de la creacin de la tabla
      gsTablas += clsConstantes.sCREATE_TABLE;
      // Reemplazar el comentario para el script de la tabla
      if (oConfig.bComentScript) {
         gsTablas = gsTablas.replaceFirst("%ComentScript",
                                          sFormatearComentario(poEntidadDebil.
            sComentario, true));
      } // if
      else {
         gsTablas = gsTablas.replaceFirst("%ComentScript", "");
      } // else

      // Reemplazar el comentario para el diccionario de la BBDD
      if ( (oConfig.bComentDic) && (!poEntidadDebil.sComentario.equals(""))) {
         gsTablas = gsTablas.replaceFirst("%ComentDic",
                                          clsConstantes.sCOMENTARIO_TABLA);
         gsTablas = gsTablas.replaceFirst("%Comentario",
                                          sFormatearComentario(poEntidadDebil.
            sComentario, false));
      } // if

      // Reemplazar los atributos de la tabla
      GenerarAtributos(poEntidadDebil, sUltimo, bLlave, bUnique, bComentario);

      // Reemplazar el nombre de la entidad dbil
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidadDebil.sNombre);

      // Generar el cdigo asociado a la entidad propietaria
      GenerarEntidadPropietaria(poEntidadPropietaria, false);

      // Reemplazar las marcas correspondientes a la entidad propietaria
      gsReferencias = gsReferencias.replaceAll(",%ClaveExterna", "");
      gsReferencias = gsReferencias.replaceAll(",%ClaveReferencia", "");

      // Reemplazar los atributos de la relacin
      GenerarAtributosRelacion(poRelacion);

      // Reemplazar el nombre de la relacin
      gsTablas = gsTablas.replaceAll("%Relacion", poRelacion.sNombre);

      // Generar relaciones 1:1
      GenerarRelacion_11_1N(poEntidadDebil);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidadDebil.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poEntidadDebil.sNombre);

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarEntidadDebil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidadUnionDiferente                             //
   // Parmetros: - poEntidad (Elemento) : Supreclase o Subclase cuyo cdigo  //
   //               se va a generar                                           //
   // Descripcin: Generar el cdigo para una Superclase o una Subclase de un //
   //              tipo unin con llaves diferentes                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidadUnionDiferente(clsElemento poEntidad) {

      // Aadir la plantilla de la creacin de la tabla
      gsTablas += clsConstantes.sCREATE_TABLE;
      // Reemplazar los atributos de la tabla
      GenerarAtributosUnionDiferente(poEntidad);
      // Generar relaciones 1:1
      GenerarRelacion_11_1N(poEntidad);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poEntidad.sNombre);

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarEntidadUnionDiferente

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidad_B                                         //
   // Parmetros: - poEntidad (Elemento) : Superclase o Subclase cuyo cdigo  //
   //               se va a generar                                           //
   // Descripcin: Generar el cdigo para una Superclase o una Subclase de una//
   //              especializacin usando la opcin de generacin B           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidad_B(clsElemento poEntidad) {

      // Aadir la plantilla de la creacin de la tabla
      gsTablas += clsConstantes.sCREATE_TABLE;

      // Reemplazar los atributos de la tabla
      GenerarAtributos_B(poEntidad);

      // Generar relaciones 1:1
      GenerarRelacion_11_1N(poEntidad);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poEntidad.sNombre);

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarEntidad_B

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidad_C                                         //
   // Parmetros: - poEntidad (Elemento) : Superclase o Subclase cuyo cdigo  //
   //               se va a generar                                           //
   //             - bSuperclase (boolean): Indica si es superclase            //
   // Descripcin: Generar el cdigo para una Superclase o una Subclase de una//
   //              especializacin usando la opcin de generacin C           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidad_C(clsElemento elmEntidad,
                                 boolean bSuperclase) {

      // Aadir la plantilla de la creacin de la tabla si es la Superclase
      if (bSuperclase) {
         gsTablas += clsConstantes.sCREATE_TABLE;
      } // if

      // Reemplazar los atributos de la tabla
      GenerarAtributos_C(elmEntidad);

      // Generar relaciones 1:1
      GenerarRelacion_11_1N(elmEntidad);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", elmEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               elmEntidad.sNombre);
   } // Procedimiento: GenerarEntidad_C

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidad_D                                         //
   // Parmetros: - poEntidad (Elemento) : Superclase o Subclase cuyo cdigo  //
   //               se va a generar                                           //
   //             - bSuperclase (boolean): Indica si es superclase            //
   //             - bEliminarMarcas (boolean): Indica se eliminan las marcas  //
   // Descripcin: Generar el cdigo para una Superclase o una Subclase de una//
   //              especializacin usando la opcin de generacin D           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidad_D(clsElemento poEntidad,
                                 boolean bSuperclase,
                                 boolean bEliminarMarcas) {

      // Aadir la plantilla de la creacin de la tabla si es la Superclase
      if (bSuperclase) {
         gsTablas += clsConstantes.sCREATE_TABLE;
      } // if

      // Reemplazar los atributos de la tabla
      GenerarAtributos_D(poEntidad);

      // Generar el atributo de pertenencia si es Subclase
      if (!bSuperclase) {
         gsTablas = gsTablas.replaceFirst("%Atributos",
                                          clsConstantes.
                                          sATRIBUTO_PERTENECE_ESPECIALIZACION_D);
      } // if

      // Generar relaciones 1:1
      GenerarRelacion_11_1N(poEntidad);

      // Reemplazar el nombre de la tabla
      gsTablas = gsTablas.replaceAll("%NombreTabla", poEntidad.sNombre);
      gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                               poEntidad.sNombre);

      // Eliminar las marcas si es la ltima subclase que se genera
      if (bEliminarMarcas) {
         EliminarMarcas();
      } // if
   } // Procedimiento: GenerarEntidad_D

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: EliminarMarcas                                           //
   // Parmetros: No                                                          //
   // Descripcin: Elimina las marcas de las plantillas                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void EliminarMarcas() {
      // Eliminar la marca "%ComentDic"
      gsTablas = gsTablas.replaceFirst("%ComentDic", "");
      // Eliminar la marca "%,ComentDic"
      gsTablas = gsTablas.replaceFirst(",%ComentDic", "");
      // Eliminar la marca "%ComentScript"
      gsTablas = gsTablas.replaceFirst("%ComentScript", "");
      // Eliminar la marca "%,ComentScript"
      gsTablas = gsTablas.replaceFirst(",%ComentScript", "");
      // Eliminar la ltima marca ",%Atributos"
      gsTablas = gsTablas.replaceAll(",%Atributos", "");
      // Eliminar la ltima marca "%Atributos"
      gsTablas = gsTablas.replaceAll("%Atributos", "");
      // Eliminar la ltima marca "%PrimaryKey"
      gsTablas = gsTablas.replaceAll("%PrimaryKey", "");
      // Eliminar la ltima marca ",%ClavePrimaria"
      gsTablas = gsTablas.replaceAll(",%ClavePrimaria", "");
      // Eliminar la ltima marca "%ClavePrimaria"
      gsTablas = gsTablas.replaceAll("%ClavePrimaria", "");
      // Eliminar la ltima marca ",%Unique"
      gsTablas = gsTablas.replaceAll(",%Unique", "");
      // Eliminar la ltima marca "%Unique"
      gsTablas = gsTablas.replaceAll("%Unique", "");
      // Eliminar la ltima marca ",%ClavePrimaria"
      gsTablas = gsTablas.replaceAll(",%AtributoUnico", "");
      // Eliminar la ltima marca "%ClavePrimaria"
      gsTablas = gsTablas.replaceAll("%AtributoUnico", "");
      // Eliminar la ltima marca ",%ClavePrimaria"
      gsReferencias = gsReferencias.replaceAll(",%ClaveExterna", "");
      // Eliminar la ltima marca "%ClavePrimaria"
      gsReferencias = gsReferencias.replaceAll("%ClaveExterna", "");
      // Eliminar la ltima marca ",%ClavePrimaria"
      gsReferencias = gsReferencias.replaceAll(",%ClaveReferencia", "");
      // Eliminar la ltima marca "%ClavePrimaria"
      gsReferencias = gsReferencias.replaceAll("%ClaveReferencia", "");
   } // Procedimiento: EliminarMarcas

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarRelacion_11_1N                                    //
   // Parmetros: - poEntidad (clsElemento) : Entidad participante en la      //
   //               relacin                                                  //
   // Descripcin: Generar el codigo para relaciones 1:1 o 1:N para la entidad//
   //              pasada como parmetro                                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarRelacion_11_1N(clsElemento poEntidad) {

      clsElemento oRelacion; // Relacin cuyo cdigo se genera
      clsElemento oEntidadRelacionada; // Elemento con la otra Entidad participante
      clsEntRel erEntidad1; // Primera Entidad participante en la Relacin
      clsEntRel erEntidad2; // Segunda Entidad participante en la Relacin
      clsEntRel erAux; // Entidad auxiliar
      String gsTablasubclase = ""; // Nombre de la tabla para Subclases
      int nSubclase; // Tiene el valor que indica si la otra Entidad es Subclase

      // Recorrer el vector de elementos para generar el cdigo para todas las
      // relaciones 1:1 y 1:N
      for (int iIndice = 0; iIndice < poEntidad.vRelaciones.size(); iIndice++) {
         // Obtener el elemento para el ndice actual
         oRelacion = oGeneral.elmElemento( (String) poEntidad.vRelaciones.
                                            elementAt(iIndice));
         // Generar el cdigo si el elemento es de tipo Relacin
         if (oRelacion.nTipo == clsConstantes.nRELACION) {
            // Generar el cdigo si no ha sido ya generado
            if (!oRelacion.bGenerado) {
               // Generar el cdigo si en la relacin slo participan 2 entidades
               if (oRelacion.vEntRel.size() == 2) {
                  // Obtener la primera Entidad participante en la Relacin
                  erEntidad1 = (clsEntRel) oRelacion.vEntRel.elementAt(0);
                  // Obtener la segunda Entidad participante en la Relacin
                  erEntidad2 = (clsEntRel) oRelacion.vEntRel.elementAt(1);

                  // Comprobar que la Entidad cuyo cdigo se est generando
                  // participa en la Relacin que estamos considerando
                  if ( (erEntidad1.sNombre.equals(poEntidad.sNombre)) ||
                      (erEntidad2.sNombre.equals(poEntidad.sNombre))) {
                     // Asignar la Entidad cuyo cdigo estamos generando como
                     // primera Entidad participante en la Relacin
                     if (erEntidad2.sNombre.equals(poEntidad.sNombre)) {
                        erAux = erEntidad2;
                        erEntidad2 = erEntidad1;
                        erEntidad1 = erAux;
                     } // if

                     // Generar el cdigo si la Relacin no es N:M y participa
                     // totalmente en la relacin
                     if ( ( (erEntidad1.sMax.equals("1")) &&
                           (erEntidad2.sMax.equals("1"))) &&
                         ( (erEntidad1.sMin.equals("1")) ||
                          ( (erEntidad1.sMin.equals("0")) &&
                           (erEntidad2.sMin.equals("0")))) ||
                         ( (erEntidad1.sMax.equals("N")) &&
                          (erEntidad2.sMax.equals("1"))) ||
                         ( (erEntidad1.sMax.equals("M")) &&
                          (erEntidad2.sMax.equals("1")))) {

                        // Indicar que se ha generado el cdigo de la Relacin
                        oRelacion.bGenerado = true;
                        // Obtener la otra Entidad participante en la Relacin
                        oEntidadRelacionada = oGeneral.elmElemento(erEntidad2.
                           sNombre);

                        // Reemplazar la plantilla para la restriccin FOREIGN KEY
                        if ( (oGeneral.elmElemento(erEntidad1.sNombre).
                              vEspecializaciones.size() > 0) &&
                            ( (oConfig.nOpcionEsp == clsConstantes.nOPCION_C) ||
                             (oConfig.nOpcionEsp == clsConstantes.nOPCION_D))) {
                           gsReferencias += clsConstantes.
                              sCONSTRAINT_FOREIGN_KEY_C_D;
                        } // if
                        else {
                           gsReferencias += clsConstantes.
                              sCONSTRAINT_FOREIGN_KEY;
                        } // else

                        // Obtener si la otra entidad es Subclase
                        nSubclase = nEsSubclase(oEntidadRelacionada);

                        if (nSubclase == clsConstantes.nNO_SUBCLASE) {
                           // Si la otra Entidad no es Subclase
                           // Generar las referencias a los atributos
                           GenerarAtributosExternos(oEntidadRelacionada);
                           // Reemplazar el nombre de la entidad relacionada
                           gsTablas = gsTablas.replaceAll("%TablaReferencia",
                              oEntidadRelacionada.sNombre);

                           gsReferencias = gsReferencias.replaceAll(
                              "%TablaReferencia",
                              oEntidadRelacionada.sNombre);
                        } // if
                        else if (nSubclase ==
                                 clsConstantes.nSUBCLASE_ESPECIALIZACION) {
                           // Si la otra Entidad es Subclase de una Especializacin
                           GenerarAtributosExternosSubclase(
                              elmEspecializacionDeSubclase(
                              oEntidadRelacionada),
                              oGeneral.elmElemento(
                              oGeneral.sSuperclaseDeSubclase(
                              oEntidadRelacionada)));
                           // Obtener el nombre de la Tabla donde estar la Entidad
                           gsTablasubclase = oGeneral.sObtenerTablaSubclase(
                              oEntidadRelacionada, oConfig.nOpcionEsp);
                           // Reemplazar el nombre de la entidad relacionada en las Tablas
                           gsTablas = gsTablas.replaceAll("%TablaReferencia",
                              gsTablasubclase);
                           // Reemplazar el nombre de la entidad relacionada en las Referencias
                           gsReferencias = gsReferencias.replaceAll(
                              "%TablaReferencia", gsTablasubclase);
                        } // else if
                        else if (nSubclase ==
                                 clsConstantes.nSUBCLASE_TIPO_UNION) {
                           // Si la otra Entidad es Subclase de una Unin
                           GenerarLlaveSubclaseUnion(oEntidadRelacionada);

                           // Reemplazar el nombre de la entidad relacionada en las Tablas
                           gsTablas = gsTablas.replaceAll("%TablaReferencia",
                              oEntidadRelacionada.sNombre);
                           // Reemplazar el nombre de la entidad relacionada en las Referencias
                           gsReferencias = gsReferencias.replaceAll(
                              "%TablaReferencia", oEntidadRelacionada.sNombre);
                        } // else if
                        else if (nSubclase ==
                                 clsConstantes.nSUBCLASE_TIPO_INTERSECCION) {
                           // Si la otra Entidad es Subclase de una Unin
                           GenerarLlaveSubclaseInterseccion(
                              oEntidadRelacionada);

                           // Reemplazar el nombre de la entidad relacionada en las Tablas
                           gsTablas = gsTablas.replaceAll("%TablaReferencia",
                              oEntidadRelacionada.sNombre);
                           // Reemplazar el nombre de la entidad relacionada en las Referencias
                           gsReferencias = gsReferencias.replaceAll(
                              "%TablaReferencia", oEntidadRelacionada.sNombre);
                        } // else if
                        else if (nSubclase == clsConstantes.nSUBCLASE) {
                           // Generar las referencias a los atributos usand la llave de la Superclase
                           GenerarAtributosExternos(oGeneral.elmElemento(
                              oEntidadRelacionada.sSuperclase));
                           // Reemplazar el nombre de la entidad relacionada en las Tablas
                           gsTablas = gsTablas.replaceAll("%TablaReferencia",
                              oEntidadRelacionada.sNombre);
                           // Reemplazar el nombre de la entidad relacionada en las Referencias
                           gsReferencias = gsReferencias.replaceAll(
                              "%TablaReferencia", oEntidadRelacionada.sNombre);
                        } // else if

                        // Reemplazar los atributos de la relacin
                        GenerarAtributosRelacion(oRelacion);

                        // Reemplazar el nombre de la relacin
                        gsTablas = gsTablas.replaceAll("%Relacion",
                           oRelacion.sNombre);

                        // Reemplazar el nombre de la Superclase si la entidad es Subclase
                        // de una Especializacin con opcin C o D
                        if ( (oGeneral.elmElemento(erEntidad1.sNombre).
                              vEspecializaciones.size() > 0) &&
                            ( (oConfig.nOpcionEsp == clsConstantes.nOPCION_C) ||
                             (oConfig.nOpcionEsp == clsConstantes.nOPCION_D))) {
                           gsReferencias = gsReferencias.replaceAll(
                              "%NombreSuperclase",
                              oGeneral.sObtenerTablaSubclase(
                              oGeneral.elmElemento(erEntidad1.sNombre),
                              oConfig.nOpcionEsp));
                        } // if
                     } // if
                  } // if
               } // if
            } // if
            // Eliminar la ltima marca ",%ClavePrimaria"
            gsReferencias = gsReferencias.replaceAll(",%ClaveExterna", "");
            // Eliminar la ltima marca "%ClavePrimaria"
            gsReferencias = gsReferencias.replaceAll("%ClaveExterna", "");
            // Eliminar la ltima marca ",%ClavePrimaria"
            gsReferencias = gsReferencias.replaceAll(",%ClaveReferencia", "");
            // Eliminar la ltima marca "%ClavePrimaria"
            gsReferencias = gsReferencias.replaceAll("%ClaveReferencia", "");

         } // if
      } // for
   } // Procedimiento: GenerarRelacion_11_1N

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarRelacionMasDos                                    //
   // Parmetros: - poRelacion (clsElemento): Relacin cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para relaciones de grado mayor que dos    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarRelacionMasDos(clsElemento poRelacion) {

      clsEntRel erEntidad;
      clsElemento elmEntidad;

      if (!poRelacion.bGenerado) {
         poRelacion.bGenerado = true;

         // Aadir la plantilla para crear la tabla
         gsTablas += clsConstantes.sCREATE_TABLE;

         for (int iIndice = 0; iIndice < poRelacion.vEntRel.size(); iIndice++) {
            // Obtener la iIndice-sima entidad participante
            erEntidad = (clsEntRel) poRelacion.vEntRel.elementAt(iIndice);
            elmEntidad = oGeneral.elmElemento(erEntidad.sNombre);

            // Generar el cdigo asociado a la iIndice-sima entidad participante
            GenerarEntidadParticipante(elmEntidad);

         } // for
         // Reemplazar los atributos de la relacin
         GenerarAtributosRelacionMasDos(poRelacion);

         // Reemplazar el nombre de la relacin
         gsTablas = gsTablas.replaceAll("%Relacion", poRelacion.sNombre);

         // Reemplazar el nombre de la tabla
         gsTablas = gsTablas.replaceAll("%NombreTabla", poRelacion.sNombre);
         gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                                                  poRelacion.sNombre);

         // Eliminar las marcas
         EliminarMarcas();
      } // if
   } // Procedimiento: GenerarRelacionMasDos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarRelacion_NM                                       //
   // Parmetros: - poRelacion (clsElemento): Relacin cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para relaciones N:M                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarRelacion_NM(clsElemento poRelacion) {

      //clsElemento oElemento; // Objeto para un elemento
      clsElemento oEntidad1; // Objeto para una entidad participante
      clsElemento oEntidad2; // Objeto para una entidad participante
      clsEntRel erEntidad1;
      clsEntRel erEntidad2;
      clsEntRel erAux;

      if (!poRelacion.bGenerado) {
         if (poRelacion.vEntRel.size() == 2) {

            erEntidad1 = (clsEntRel) poRelacion.vEntRel.elementAt(0);
            erEntidad2 = (clsEntRel) poRelacion.vEntRel.elementAt(1);

            if ( ( (erEntidad1.sMax.equals("N")) || (erEntidad1.sMax.equals("M"))) &&
                ( (erEntidad2.sMax.equals("M")) || (erEntidad2.sMax.equals("N")))) {

               poRelacion.bGenerado = true;

               // Obtener las entidades pertenecientes a la relacin
               oEntidad1 = oGeneral.elmElemento(erEntidad1.sNombre);
               oEntidad2 = oGeneral.elmElemento(erEntidad2.sNombre);

               // Aadir la plantilla para crear la tabla
               gsTablas += clsConstantes.sCREATE_TABLE;

               // Generar el cdigo asociado a la primera entidad participante
               GenerarEntidadParticipante(oEntidad1);

               // Generar el cdigo asociado a la segunda entidad participante
               GenerarEntidadParticipante(oEntidad2);

               // Reemplazar los atributos de la relacin
               GenerarAtributosRelacion(poRelacion);

               // Reemplazar el nombre de la relacin
               gsTablas = gsTablas.replaceAll("%Relacion", poRelacion.sNombre);

               // Reemplazar el nombre de la tabla
               gsTablas = gsTablas.replaceAll("%NombreTabla",
                                              poRelacion.sNombre);
               gsReferencias = gsReferencias.replaceAll("%NombreTabla",
                  poRelacion.sNombre);
            } // if
         } // if
      } // if

      // Eliminar las marcas
      EliminarMarcas();
   } // Procedimiento: GenerarRelacion_NM

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarEntidadParticipante                               //
   // Parmetros: - poEntidad (clsElemento): Entidad participante             //
   // Descripcin: Genera el codigo para una entidad participante en una      //
   //              relacin N:M                                               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarEntidadParticipante(clsElemento poEntidad) {
      // Aadir la plantilla de nueva referencia para la entidad
      gsReferencias += clsConstantes.sCONSTRAINT_FOREIGN_KEY;
      // Generar los atributos correspondientes a la entidad
      GenerarAtributosRelacion_NM(poEntidad);

      if ( (poEntidad.vEspecializaciones == null) ||
          ( (poEntidad.vEspecializaciones != null) &&
           (poEntidad.vEspecializaciones.size() == 0)) ||
          ( (poEntidad.vEspecializaciones != null) &&
           (poEntidad.vEspecializaciones.size() > 0) &&
           ( (oConfig.nOpcionEsp == clsConstantes.nOPCION_A) ||
            (oConfig.nOpcionEsp == clsConstantes.nOPCION_B))) ||
          (poEntidad.sNombre.equals(oGeneral.sSuperclaseDeSubclase(poEntidad)))) {
         // Reemplazar el nombre de la entidad
         gsTablas = gsTablas.replaceAll("%TablaReferencia", poEntidad.sNombre);
         // Reemplazar el nombre de la entidad
         gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                                                  poEntidad.sNombre);
      } // if

      // Eliminar la marcas de la referencia
      gsReferencias = gsReferencias.replaceAll(",%ClaveExterna", "");
      // Eliminar la marcas de la referencia
      gsReferencias = gsReferencias.replaceAll(",%ClaveReferencia", "");
   } // Procedimiento: GenerarEntidadParticipante

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributo                               //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para las propiedades de un atributo       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributo(clsElemento poAtributo) {
      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (poAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + poAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (poAtributo.bNotNull) {
         // Aadir la plantilla para la restriccin NOT NULL
         sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL;
      } // if

      // Reemplazar la restriccin UNIQUE
      if (poAtributo.bUnique) {
         // Aadir la plantilla para la restriccin UNIQUE
         sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE;
      } // if

      // Reemplazar la restriccin CHECK
      if (poAtributo.bCheck) {
         // Aadir la plantilla para CHECK
         sPropiedades += clsConstantes.sCONSTRAINT_CHECK + poAtributo.sCheck;
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);

      // Aadir la restriccin PRIMARY KEY como restriccin de tabla
      if ( (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
          (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
          (poAtributo.bSuperllave)) {
         // Aadir la plantilla para la PRIMARY KEY
         gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                          clsConstantes.sCONSTRAINT_PRIMARY_KEY);
         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.sCLAVE_PRIMARIA);
      } // if
   } // Procedimiento: GenerarPropiedadesAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributo_NM                            //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para las propiedades de un atributo de la //
   //              tabla de una relacin N:M                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributo_NM(clsElemento poAtributo) {
      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (poAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + poAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (poAtributo.bNotNull) {
         // Aadir la plantilla para la restriccin NOT NULL
         sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL;
      } // if

      // Reemplazar la restriccin UNIQUE
      if (poAtributo.bUnique) {
         // Aadir la plantilla para la restriccin UNIQUE
         sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE;
      } // if

      // Reemplazar la restriccin CHECK
      if (poAtributo.bCheck) {
         // Aadir la plantilla para CHECK
         sPropiedades += clsConstantes.sCONSTRAINT_CHECK + poAtributo.sCheck;
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);

      // Aadir la restriccin PRIMARY KEY como restriccin de tabla
      if ( (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
          (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
          (poAtributo.bSuperllave)) {
         // Aadir la plantilla para la PRIMARY KEY
         gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                          clsConstantes.sCONSTRAINT_PRIMARY_KEY);
         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.sCLAVE_PRIMARIA_EXTERNA);
      } // if
   } // Procedimiento: GenerarPropiedadesAtributo_NM

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributo_NM_Debil                      //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para las propiedades de un atributo de la //
   //              tabla de una relacin N:M                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributo_NM_Debil(clsElemento poAtributo) {
      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (poAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + poAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (poAtributo.bNotNull) {
         // Aadir la plantilla para la restriccin NOT NULL
         sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL;
      } // if

      // Reemplazar la restriccin UNIQUE
      if (poAtributo.bUnique) {
         // Aadir la plantilla para la restriccin UNIQUE
         sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE;
      } // if

      // Reemplazar la restriccin CHECK
      if (poAtributo.bCheck) {
         // Aadir la plantilla para CHECK
         sPropiedades += clsConstantes.sCONSTRAINT_CHECK + poAtributo.sCheck;
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);

      // Aadir la restriccin PRIMARY KEY como restriccin de tabla
      if ( (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
          (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
          (poAtributo.bSuperllave)) {
         // Aadir la plantilla para la PRIMARY KEY
         gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                          clsConstantes.sCONSTRAINT_PRIMARY_KEY);
         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.
            sCLAVE_PRIMARIA_EXTERNA_PROPIETARIA_DEBIL);
      } // if
   } // Procedimiento: GenerarPropiedadesAtributo_NM_Debil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributo                               //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   //             - pvUnique (Vector): Vector de atributos Unique             //
   //             - pbUnique (boolean): Indica si hay restriccin Unique      //
   //             - pbComentario (boolean): Indica si hay comentario          //
   // Descripcin: Genera el codigo para las propiedades de un atributo y     //
   //              y crea la restriccin Unique de tabla                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributo(clsElemento elmAtributo,
                                           Vector pvUnique,
                                           boolean pbUnique,
                                           boolean pbComentario) {

      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (elmAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + elmAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (elmAtributo.bNotNull) {
         if (elmAtributo.sNotNull.equals("")) {
            // Aadir la plantilla para la restriccin NOT NULL
            sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL;
         } // if
         else {
            // Aadir la plantilla para la restriccin NOT NULL
            sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL_NOMBRE;
            // Reemplazar el nombre de la restriccin
            sPropiedades = sPropiedades.replaceFirst("%NombreRestriccion",
               elmAtributo.sNotNull);
         } // else
      } // if

      // Reemplazar la restriccin UNIQUE
      if (elmAtributo.bUnique) {
         // Aadir la restriccin como restriccin de atributo o de tabla
         if (elmAtributo.sUnique.equals("")) {
            // Aadir la plantilla para la restriccin UNIQUE
            sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE;
         } // if
         else {
            // Aadir al vector
            pvUnique.add(elmAtributo.sNombre + "@" + elmAtributo.sUnique);
         } // else
      } // if

      // Reemplazar la restriccin CHECK
      if (elmAtributo.bCheck) {
         if (elmAtributo.sNombreCheck.equals("")) {
            // Aadir la plantilla para la restriccin CHECK
            sPropiedades += clsConstantes.sCONSTRAINT_CHECK +
               elmAtributo.sCheck;
         } // if
         else {
            // Aadir la plantilla para la restriccin CHECK
            sPropiedades += clsConstantes.sCONSTRAINT_CHECK_NOMBRE +
               elmAtributo.sCheck;
            // Reemplazar el nombre de la restriccin
            sPropiedades = sPropiedades.replaceFirst("%NombreRestriccion",
               elmAtributo.sNombreCheck);
         } // else
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);

      // Aadir la restriccin PRIMARY KEY como restriccin de tabla
      if ( (elmAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
          (elmAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
          (elmAtributo.bSuperllave)) {
         // Aadir la plantilla para la PRIMARY KEY
         if ( (pbComentario) && (!pbUnique)) {
            gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                             clsConstantes.
               sCONSTRAINT_PRIMARY_KEY_COMENTARIOS);
         } // if
         else {
            gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                             clsConstantes.
                                             sCONSTRAINT_PRIMARY_KEY);
         } // else
         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.sCLAVE_PRIMARIA);
      } // if
   } // Procedimiento: GenerarPropiedadesAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributoMultivaluado                   //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para las propiedades de un atributo       //
   //              multivaluado                                               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributoMultivaluado(clsElemento elmAtributo) {

      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (elmAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + elmAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (elmAtributo.bNotNull) {
         // Aadir la plantilla para la restriccin NOT NULL
         sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL_MULT;
      } // if

      // Reemplazar la restriccin UNIQUE
      if (elmAtributo.bUnique) {
         // Aadir la plantilla para la restriccin UNIQUE
         sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE_MULT;
      } // if

      // Reemplazar la restriccin CHECK
      if (elmAtributo.bCheck) {
         // Aadir la plantilla para CHECK
         sPropiedades += clsConstantes.sCONSTRAINT_CHECK_MULT +
            elmAtributo.sCheck;
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);
   } // Procedimiento: GenerarPropiedadesAtributoMultivaluado

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributoRelacion                       //
   // Parmetros: - poAtributo (clsElemento): Atributo cuyo cdigo se genera  //
   // Descripcin: Genera el codigo para las propiedades de un atributo       //
   //              multivaluado                                               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributoRelacion(clsElemento poAtributo) {

      String sPropiedades; // Cadena con las propieades del atributo

      // Inicializar la cadena de propiedades a vaco
      sPropiedades = "";

      // Aadir DEFAULT
      if (poAtributo.bDefault) {
         // Aadir la plantilla para DEFAULT
         sPropiedades = clsConstantes.sDEFAULT + poAtributo.sDefault;
      } // if

      // Aadir la restriccin NOT NULL
      if (poAtributo.bNotNull) {
         // Aadir la plantilla para la restriccin NOT NULL
         sPropiedades += clsConstantes.sCONSTRAINT_NOT_NULL;
      } // if

      // Reemplazar la restriccin UNIQUE
      if (poAtributo.bUnique) {
         // Aadir la plantilla para la restriccin UNIQUE
         sPropiedades += clsConstantes.sCONSTRAINT_UNIQUE;
      } // if

      // Reemplazar la restriccin CHECK
      if (poAtributo.bCheck) {
         // Aadir la plantilla para CHECK
         sPropiedades += clsConstantes.sCONSTRAINT_CHECK + poAtributo.sCheck;
      } // if

      // Reemplazar las propiedades del atributo
      gsTablas = gsTablas.replaceFirst("%Propiedades", sPropiedades);

   } // Procedimiento: GenerarPropiedadesAtributoRelacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarLlaveSubclaseUnion                                //
   // Parmetros: - poSubclase (clsElemento): Subclase relacionada            //
   // Descripcin: Genera la llave para la relacin con una subclase de un    //
   //              tipo unin                                                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarLlaveSubclaseUnion(clsElemento poSubclase) {

      clsElemento oAtributo; // Atributo
      clsElemento oTipoUnion; // Tipo unin al que pertenece la Subclase
      clsElemento oSuperclase; // Primera Superclase del tipo unin

      // Obtener la Unin de la Subclase
      oTipoUnion = oGeneral.elmElemento( (String) poSubclase.vUniones.elementAt(
         0));

      if (oTipoUnion.bLlavesIguales) {
         // Obtener la primera Superclase de la Unin
         oSuperclase = oGeneral.elmElemento( (String) oTipoUnion.vSuperclases.
                                              elementAt(
            0));

         for (int i = 0; i < oSuperclase.vAtributos.size(); i++) {
            oAtributo = (clsElemento) oSuperclase.vAtributos.elementAt(i);

            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributosExternos(oAtributo);
            } // if
            else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                     oAtributo.bSuperllave) {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO_EXTERNO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar la marca de ClaveExterna
               gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
                  clsConstantes.sCLAVE_EXTERNA);

               // Reemplazar la marca de ClaveReferencia
               gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
                  clsConstantes.sCLAVE_REFERENCIA);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);

               // Reemplazar el nombre del atributo
               gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                  oAtributo.sNombre);
            } // else if
         } // for
      } // if
      else {
         // Aadir la plantilla para el atributo
         gsTablas = gsTablas.replaceFirst("%Atributos",
                                          clsConstantes.
                                          sATRIBUTO_EXTERNO_FICTICIO);
         // Reemplazar la marca de ClaveExterna
         gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
            clsConstantes.sCLAVE_EXTERNA);

         // Reemplazar la marca de ClaveReferencia
         gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
            clsConstantes.
            sCLAVE_REFERENCIA);

         // Reemplazar el nombre del atributo
         gsTablas = gsTablas.replaceAll("%NombreAtributo", oTipoUnion.sNombre);

         // Reemplazar el nombre del atributo
         gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                                                  oTipoUnion.sNombre);
      } // else

   } // Procedimiento: GenerarLlaveSubclaseUnion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarLlaveSubclaseInterseccion                         //
   // Parmetros: - poSubclase (clsElemento): Subclase relacionada            //
   // Descripcin: Genera la llave para la relacin con una subclase de un    //
   //              tipo interseccin                                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarLlaveSubclaseInterseccion(clsElemento elmSubclase) {

      clsElemento oAtributo; // Atributo
      clsElemento oTipoInterseccion; // Tipo interseccin al que pertenece la Subclase
      clsElemento oSuperclase; // Primera Superclase del tipo interseccin

      // Obtener la Interseccin de la Subclase
      oTipoInterseccion = oGeneral.elmElemento( (String) elmSubclase.
                                             vIntersecciones.
                                             elementAt(0));

      // Obtener la primera Superclase de la Interseccin
      oSuperclase = oGeneral.elmElemento( (String) oTipoInterseccion.
                                           vSuperclases.
                                           elementAt(
         0));

      for (int i = 0; i < oSuperclase.vAtributos.size(); i++) {
         oAtributo = (clsElemento) oSuperclase.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosExternos(oAtributo);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  oAtributo.bSuperllave) {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO_EXTERNO);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for
   } // Procedimiento: GenerarLlaveSubclaseInterseccion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosExternos                                 //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de las llaves externas //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosExternos(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para los elementos de la entidad

      // Recorrer el vector de atributos del elemento
      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         // Obtener el atributo actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosExternos(oAtributo);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                  (oAtributo.bSuperllave)) {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO_EXTERNO);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for

      // Comprobar si se trata de una entidad dbil para generar el cdigo
      // correspondiente a su entidad propietaria
      // Generar el cdigo asociado a la entidad propietaria
      if (poElemento.nTipo == clsConstantes.nENTIDAD_DEBIL) {
         CompletarEntidadDebil(elmEntidadPropietaria(poElemento));

         // Reemplazar el nombre de la entidad
         gsTablas = gsTablas.replaceAll("%TablaReferencia", poElemento.sNombre);
         // Reemplazar el nombre de la entidad
         gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                                                  poElemento.sNombre);
      } // if
   } // Procedimiento: GenerarAtributosExternos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosExternosSubclase                         //
   // Parmetros: - poEspecializacion (clsElemento): Objeto para la           //
   //               especializacin                                           //
   //             - poSuperclase (clsElemento): Objeto para la superclase     //
   // Descripcin: Genera el cdigo para los atributos de las llaves externas //
   //              para las subclases de las especializaciones                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosExternosSubclase(clsElemento poEspecializacion,
                                                 clsElemento poSuperclase) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int i = 0; i < poSuperclase.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poSuperclase.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosExternos(oAtributo);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  oAtributo.bSuperllave) {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO_EXTERNO);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for
   } // Procedimientos: GenerarAtributosExternosSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributoExternosSuperclase                        //
   // Parmetros: - poSuperclase (clsElemento) : Superclase cuyo cdigo se    //
   //               genera                                                    //
   // Descripcin: Genera la llave externa a la llave ficticia de la subclase //
   //              del tipo unin                                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributoExternosSuperclase(clsElemento poSuperclase) {

      // Aadir la plantilla para el atributo
      gsTablas = gsTablas.replaceFirst("%Atributos",
                                       clsConstantes.sATRIBUTO_EXTERNO_FICTICIO);

      // Aadir la plantilla de restriccin de clave externa
      gsReferencias += clsConstantes.sCONSTRAINT_FOREIGN_KEY;

      // Reemplazar la marca de ClaveExterna
      gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
                                                 clsConstantes.sCLAVE_EXTERNA);

      // Reemplazar la marca de ClaveReferencia
      gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
                                                 clsConstantes.
                                                 sCLAVE_REFERENCIA);

      // Reemplazar el nombre del atributo
      gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                     (String) poSuperclase.vUniones.elementAt(
         0));

      // Reemplazar la tabla de referencia
      gsTablas = gsTablas.replaceAll("%TablaReferencia",
                                     oGeneral.elmElemento( (String)
         poSuperclase.vUniones.elementAt(0)).sSubclase);

      // Reemplazar el nombre del atributo
      gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                                               (String) poSuperclase.vUniones.
                                               elementAt(0));

      // Reemplazar la tabla de referencia
      gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                                               oGeneral.elmElemento( (String)
         poSuperclase.vUniones.elementAt(0)).sSubclase);
   } // Procedimiento: GenerarAtributoExternosSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosPropietaria                              //
   // Parmetros: - poElemento (clsElemento) : Elemento propietario del       //
   //               atributo                                                  //
   //             - bpMultivaluado (boolean): Indica si el propietario es un  //
   //               atributo multivaluado                                     //
   // Descripcin: Genera el cdigo correspondiente al propietaro del atributo//
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosPropietaria(clsElemento poElemento,
                                            boolean bpMultivaluado) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oEntidad; // Entidad a la que pertenece el atributo

      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosPropietaria(oAtributo, bpMultivaluado);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                  (oAtributo.bSuperllave)) {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO_EXTERNO);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Aadir la plantilla para la PRIMARY KEY
            if (bpMultivaluado) {
               gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                                clsConstantes.
                                                sCONSTRAINT_PRIMARY_KEY_MULT);
            } // if
            else {
               gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                                clsConstantes.
                                                sCONSTRAINT_PRIMARY_KEY);
            } // else
            gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                             clsConstantes.
                                             sCLAVE_PRIMARIA_EXTERNA);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for
   } // Procedimiento: GenerarAtributosPropietaria

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosPropietariaMultivaluadoDebil             //
   // Parmetros: - poElemento (clsElemento) : Elemento propietario del       //
   //               atributo                                                  //
   // Descripcin: Genera el cdigo correspondiente a la entidad dbil        //
   //              propietaria de un atributo multivaluado                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosPropietariaMultivaluadoDebil(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosPropietariaMultivaluadoDebil(oAtributo);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  (oAtributo.bSuperllave)) {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.
               sATRIBUTO_EXTERNO_PROPIETARIA_DEBIL);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Aadir la plantilla para la PRIMARY KEY
            //   gsTablas = gsTablas.replaceFirst("%PrimaryKey",
            //                                   clsConstantes.
            //                                   sCONSTRAINT_PRIMARY_KEY_MULT);
            gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                             clsConstantes.
               sCLAVE_PRIMARIA_EXTERNA_PROPIETARIA_DEBIL);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA_PROPIETARIA_DEBIL);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA_PROPIETARIA_DEBIL);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for
   } // Procedimiento: GenerarAtributosPropietariaMultivaluadoDebil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosPropietariaDebil                         //
   // Parmetros: - poElemento (clsElemento) : Entidad propietaria de la      //
   //               entidad dbil                                             //
   // Descripcin: Genera el cdigo correspondiente a la entidad propietaria  //
   //              de una entidad dbil participante en una relacin no       //
   //              identificativa                                             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosPropietariaDebil(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosPropietariaDebil(oAtributo);
         } // if
         else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                  (oAtributo.bSuperllave)) {

            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.
               sATRIBUTO_EXTERNO_PROPIETARIA_DEBIL);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar la marca de ClaveExterna
            gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
               clsConstantes.sCLAVE_EXTERNA_PROPIETARIA_DEBIL);

            // Reemplazar la marca de ClaveReferencia
            gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
               clsConstantes.sCLAVE_REFERENCIA_PROPIETARIA_DEBIL);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);

            // Reemplazar el nombre del atributo
            gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
               oAtributo.sNombre);
         } // else if
      } // for
   } // Procedimiento: GenerarAtributosPropietariaDebil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos                                         //
   // Parmetros: - poElemento (clsElemento) : Objeto para el elemento        //
   // Descripcin: Genera el cdigo correspondiente a los atributos de un     //
   //              elemento del esquema                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para un atributo
      clsElemento oEspecializacion; // Objeto para una especializacin
      clsElemento oUnion; // Objeto para un tipo unin
      clsElemento oInterseccion; // Objeto para un tipo interseccin
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases
      Vector vUnique; // Vector con los atributos con propiedad Unique con nombre

      if (poElemento.nTipo == clsConstantes.nENTIDAD) {
         // Para Subclases puras
         if (!poElemento.sSuperclase.equals("")) {
            GenerarAtributosLlave(oGeneral.elmElemento(poElemento.sSuperclase));
         } // if

         if ( (poElemento.vEspecializaciones != null) &&
             (poElemento.vEspecializaciones.size() > 0)) {
            // Obtener la Especializacion
            oEspecializacion = oGeneral.elmElemento( (String) poElemento.
               vEspecializaciones.elementAt(0));
            // Tomar la llave de la Superclase de la Especializacin slo si el
            // elemento no es ya la Superclase de la Especializacin
            if (!oEspecializacion.sSuperclase.equals(poElemento.sNombre)) {
               GenerarAtributosLlave(oGeneral.elmElemento(oEspecializacion.
                  sSuperclase));
            } // if
         } // if

         if ( (poElemento.vUniones != null) &&
             (poElemento.vUniones.size() > 0)) {
            // Obtener la Unin
            oUnion = oGeneral.elmElemento( (String) poElemento.
                                            vUniones.elementAt(0));
            // Tomar la llave de la Superclase de la Unin slo si el
            // elemento no es ya la Superclase de la Unin
            bSuperclase = false;
            iSuperclases = 0;
            while ( (iSuperclases < oUnion.vSuperclases.size()) &&
                   !bSuperclase) {
               bSuperclase = ( (String) oUnion.vSuperclases.elementAt(
                  iSuperclases)).
                  equals(poElemento.sNombre);
               // Incrementar el indice
               iSuperclases++;
            } // while
            if (!bSuperclase) {
               GenerarAtributosLlave(oGeneral.elmElemento( (String) oUnion.
                  vSuperclases.
                  elementAt(0)));
            } // if
         } // if

         if ( (poElemento.vIntersecciones != null) &&
             (poElemento.vIntersecciones.size() > 0)) {
            // Obtener la Interseccin
            oInterseccion = oGeneral.elmElemento( (String) poElemento.
               vIntersecciones.elementAt(0));
            // Tomar la llave de la Superclase de la Interseccin slo si el
            // elemento no es ya la Superclase de la Interseccin
            bSuperclase = false;
            iSuperclases = 0;
            while ( (iSuperclases < oInterseccion.vSuperclases.size()) &&
                   !bSuperclase) {
               bSuperclase = ( (String) oInterseccion.vSuperclases.elementAt(
                  iSuperclases)).
                  equals(poElemento.sNombre);
               // Incrementar el indice
               iSuperclases++;
            } // while
            if (!bSuperclase) {
               GenerarAtributosLlave(oGeneral.elmElemento( (String)
                  oInterseccion.
                  vSuperclases.
                  elementAt(0)));
            } // if
         } // if
      } // if

      // Iniciar el vector de atributos Unique
      vUnique = new Vector();

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo, vUnique, 1 < 0, 1 < 0);

               // Reemplazar el comentario para el script del atributo
               if ( (oConfig.bComentScript) &&
                   (!oAtributo.sComentario.trim().equals(""))) {
                  gsTablas = gsTablas.replaceFirst("%ComentScript",
                     " -- " +
                     sFormatearComentario(
                     oAtributo.
                     sComentario,
                     false));
               } // if
               else {
                  gsTablas = gsTablas.replaceFirst("%ComentScript", "");
               } // else

               // Reemplazar el comentario para el diccionario de la BBDD
               if ( (oConfig.bComentDic) &&
                   (!oAtributo.sComentario.equals(""))) {
                  gsTablas = gsTablas.replaceFirst("%ComentDic",
                     clsConstantes.
                     sCOMENTARIO_COLUMNA);
                  gsTablas = gsTablas.replaceFirst("%Comentario",
                     sFormatearComentario(
                     oAtributo.sComentario, false));
               } // if

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for

      GenerarUniqueTabla(vUnique, false);
   } // Procedimiento: GenerarAtributos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos                                         //
   // Parmetros: - poElemento (clsElemento) : Objeto para el elemento        //
   //             - psUltimoAtributo (String): Nombre del ltimo atributo que //
   //               se genera para la tabla para que no se ponga coma despus //
   //             - pbLlave (boolean): Indica si es llave                     //
   //             - pbUnique (boolean): Indica si tiene restriccin Unique    //
   //             - pbComentario (booelan): Indica si tiene comentario        //
   // Descripcin: Genera el cdigo correspondiente a los atributos de un     //
   //              elemento del esquema                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos(clsElemento poElemento,
                                 String psUltimoAtributo,
                                 boolean pbLlave,
                                 boolean pbUnique,
                                 boolean pbComentario) {

      clsElemento oAtributo; // Objeto para un atributo
      clsElemento oEspecializacion; // Objeto para una especializacin
      clsElemento oUnion; // Objeto para un tipo unin
      clsElemento oInterseccion; // Objeto para un tipo interseccin
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases
      Vector vUnique; // Vector con los atributos con propiedad Unique con nombre

      if (poElemento.nTipo == clsConstantes.nENTIDAD) {
         // Para Subclases puras
         if (!poElemento.sSuperclase.equals("")) {
            GenerarAtributosLlave(oGeneral.elmElemento(poElemento.sSuperclase));
         } // if

         if ( (poElemento.vEspecializaciones != null) &&
             (poElemento.vEspecializaciones.size() > 0)) {
            // Obtener la Especializacion
            oEspecializacion = oGeneral.elmElemento( (String) poElemento.
               vEspecializaciones.elementAt(0));
            // Tomar la llave de la Superclase de la Especializacin slo si el
            // elemento no es ya la Superclase de la Especializacin
            if (!oEspecializacion.sSuperclase.equals(poElemento.sNombre)) {
               GenerarAtributosLlave(oGeneral.elmElemento(oEspecializacion.
                  sSuperclase));
            } // if
         } // if

         if ( (poElemento.vUniones != null) &&
             (poElemento.vUniones.size() > 0)) {
            // Obtener la Unin
            oUnion = oGeneral.elmElemento( (String) poElemento.
                                            vUniones.elementAt(0));
            // Tomar la llave de la Superclase de la Unin slo si el
            // elemento no es ya la Superclase de la Unin
            bSuperclase = false;
            iSuperclases = 0;
            while ( (iSuperclases < oUnion.vSuperclases.size()) &&
                   !bSuperclase) {
               bSuperclase = ( (String) oUnion.vSuperclases.elementAt(
                  iSuperclases)).
                  equals(poElemento.sNombre);
               // Incrementar el indice
               iSuperclases++;
            } // while
            if (!bSuperclase) {
               GenerarAtributosLlave(oGeneral.elmElemento( (String) oUnion.
                  vSuperclases.
                  elementAt(0)));
            } // if
         } // if

         if ( (poElemento.vIntersecciones != null) &&
             (poElemento.vIntersecciones.size() > 0)) {
            // Obtener la Interseccin
            oInterseccion = oGeneral.elmElemento( (String) poElemento.
               vIntersecciones.elementAt(0));
            // Tomar la llave de la Superclase de la Interseccin slo si el
            // elemento no es ya la Superclase de la Interseccin
            bSuperclase = false;
            iSuperclases = 0;
            while ( (iSuperclases < oInterseccion.vSuperclases.size()) &&
                   !bSuperclase) {
               bSuperclase = ( (String) oInterseccion.vSuperclases.elementAt(
                  iSuperclases)).
                  equals(poElemento.sNombre);
               // Incrementar el indice
               iSuperclases++;
            } // while
            if (!bSuperclase) {
               GenerarAtributosLlave(oGeneral.elmElemento( (String)
                  oInterseccion.
                  vSuperclases.
                  elementAt(0)));
            } // if
         } // if
      } // if

      // Iniciar el vector de atributos Unique
      vUnique = new Vector();

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo, psUltimoAtributo, pbLlave,
                                pbUnique,
                                pbComentario);
            } // if
            else {
               // Aadir la plantilla para el atributo
               if ( (oAtributo.sNombre.equals(psUltimoAtributo)) &&
                   (!pbLlave) && (!pbUnique)) {
                  gsTablas = gsTablas.replaceFirst("%Atributos",
                     clsConstantes.sULTIMO_ATRIBUTO);
               } // if
               else {
                  gsTablas = gsTablas.replaceFirst("%Atributos",
                     clsConstantes.sATRIBUTO);
               } // else

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo, vUnique, pbUnique,
                                          pbComentario);

               // Reemplazar el comentario para el script del atributo
               if ( (oConfig.bComentScript) &&
                   (!oAtributo.sComentario.trim().equals(""))) {
                  gsTablas = gsTablas.replaceFirst("%ComentScript",
                     " -- " +
                     sFormatearComentario(
                     oAtributo.
                     sComentario, false));
               } // if
               else {
                  gsTablas = gsTablas.replaceFirst("%ComentScript", "");
               } // else

               // Reemplazar el comentario para el diccionario de la BBDD
               if ( (oConfig.bComentDic) &&
                   (!oAtributo.sComentario.equals(""))) {
                  gsTablas = gsTablas.replaceFirst("%ComentDic",
                     clsConstantes.
                     sCOMENTARIO_COLUMNA);
                  gsTablas = gsTablas.replaceFirst("%Comentario",
                     sFormatearComentario(
                     oAtributo.sComentario, false));
               } // if

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for

      GenerarUniqueTabla(vUnique, pbComentario);
   } // Procedimiento: GenerarAtributos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sBuscarUltimoAtributo                                          //
   // Parmetros: - pvAtributos (Vector) : Vector de atributos                //
   // Retorno: Nombre del ltimo atributo                                     //
   // Descripcin: Recorre el vector para encontrar el nombre del ltio       //
   //              atributo                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private String sBuscarUltimoAtributo(Vector pvAtributos) {

      clsElemento oAtributo; // Objeto para el atributo
      String sAtributo = "";

      for (int iIndice = 0; iIndice < pvAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) pvAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               sAtributo = sBuscarUltimoAtributo(oAtributo.vAtributos);
            } // if
            else {
               sAtributo = oAtributo.sNombre;
            } // else
         } //if
      } // for
      return sAtributo;
   } // Funcin: sBuscarUltimoAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: vBuscarUltimoAtributo                                          //
   // Parmetros: - pvAtributos (Vector): Vector donde se busca el ltimo     //
   //               atributo                                                  //
   //             - pbLlave (boolean): Indicador de existencia de atributo    //
   //               llave                                                     //
   //             - pbUnique (boolean): Indicador de existencia de            //
   //               restriccines Unique de tabla                             //
   // Retorno: Vector que contiene el nombre del ltimo atributo, un valor    //
   //          que indica si hay atributos llave, otro que indica si hay      //
   //          restricciones Unique y otro que indica si hay comentarios      //
   // Descripcin: Busca el ltimo atributo, comprueba si hay atributos       //
   //              llave, restricciones Unique de tabla y si el ltimo        //
   //              atributo tiene comentario                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private Vector vBuscarUltimoAtributo(Vector pvAtributos,
                                        boolean pbLlave,
                                        boolean pbUnique) {

      clsElemento oAtributo; // Objeto para contener un atributo
      String sNombreAtributo = ""; // Nombre del ltimo atributo
      boolean bLlave; // Indica si hay algn atributo llave
      boolean bUnique; // Indica si hay alguna Unique de tabla
      boolean bComentario = false; // Indica si el ltimo atributo tiene comentario
      Vector vResultadoTotal = new Vector(); // Vector con los resultados de la funcin
      Vector vResultadoParcial = new Vector(); // Vector con resultados parciales

      // Recorrer el vector de atributos
      for (int iIndice = 0; iIndice < pvAtributos.size(); iIndice++) {
         // Obtener el atributo actual
         oAtributo = (clsElemento) pvAtributos.elementAt(iIndice);

         // Comprobar que no sea un atributo multivaluado
         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            // Comprobar si es un atributo compuesto
            if (oAtributo.vAtributos.size() > 0) {
               // Limpiar el vector con resultados parciales
               vResultadoParcial.removeAllElements();
               // Buscar en los atributos del atributo compuesto
               vResultadoParcial = vBuscarUltimoAtributo(oAtributo.vAtributos,
                  pbLlave,
                  pbUnique);
               // Recuperar el nombre del ltimo atributo del vector
               sNombreAtributo = (String) vResultadoParcial.elementAt(0);
               // Obtener si hay atributos llave
               bLlave = ( (String) vResultadoParcial.elementAt(1)).equals(
                  "true");
               // Obtener si hay alguna restriccion Unique de tabla
               bUnique = ( (String) vResultadoParcial.elementAt(2)).equals(
                  "true");
               // Obtener si el ltimo atributo tiene comentario
               bComentario = ( (String) vResultadoParcial.elementAt(3)).equals(
                  "true");
            } // if
            else {
               // Guardar el nombre del atributo
               sNombreAtributo = oAtributo.sNombre;
               // Guardar si es un atributo llave
               bLlave = ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                         (oAtributo.nTipo ==
                          clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                         (oAtributo.bSuperllave));
               // Guardar si tiene restriccin Unique de tabla
               bUnique = (!oAtributo.sUnique.equals(""));
               // Guardar si el atributo tiene coentario
               bComentario = (!oAtributo.sComentario.equals(""));
            } // else

            // Comprobar si no se ha encontrado atributo llave hasta el momento
            // para actualizar el valor total con el valor actual
            if (!pbLlave) {
               pbLlave = bLlave;
            } // if

            // Comprobar si no se ha encontrado restriccin Unique de tabla hasta
            // el momento para actualizar el valor total con el valor actual
            if (!pbUnique) {
               pbUnique = bUnique;
            } // if
         } //if
      } // for

      // Aadir los resultados obtenidos al vector de retorno
      vResultadoTotal.addElement(sNombreAtributo);
      vResultadoTotal.addElement(String.valueOf(pbLlave));
      vResultadoTotal.addElement(String.valueOf(pbUnique));
      vResultadoTotal.addElement(String.valueOf(bComentario));

      // Devolver el vector con los resultados obtenidos
      return vResultadoTotal;
   } // Funcin : vBuscarUltimoAtributo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos                                         //
   // Parmetros: - pvUnique (Vector) : Vector de atributos                   //
   //             - pbComentario (boolean): Indica si hay comentario          //
   //               se genera para la tabla para que no se ponga coma despus //
   // Descripcin: Genera el cdigo para la restriccin Unique de tabla       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarUniqueTabla(Vector pvUnique,
                                   boolean pbComentario) {

      String sUniqueActual = ""; // Restriccin Unique que se est generando
      String sAtribActual = ""; // Atributo Unique que se est generando
      int iBorrar; // Indice utilizado para borrar el vector

      // Generar la restriccin de tabla Unique
      while (pvUnique.size() > 0) {
         // Aadir la plantilla para la restriccin UNIQUE
         if (pbComentario) {
            gsTablas = gsTablas.replaceFirst("%Unique",
                                             clsConstantes.
               sCONSTRAINT_UNIQUE_MULTIPLE_COMENTARIOS);
            // Indicar que no hay comentario, porque esto solo debe hacerse para la primera
            pbComentario = false;
         }
         else {
            gsTablas = gsTablas.replaceFirst("%Unique",
                                             clsConstantes.
                                             sCONSTRAINT_UNIQUE_MULTIPLE);
         }

         // Obtener la restriccin Unique a generar
         sUniqueActual = sRestUnique( (String) pvUnique.elementAt(0));
         // Reemplazar el nombre de la restriccion
         gsTablas = gsTablas.replaceFirst("%NombreRestriccion", sUniqueActual);
         // Obtener el atributo a tratar
         sAtribActual = sAtriUnique( (String) pvUnique.elementAt(0));
         // Aadir la plantilla para aadir el atributo que participa en la restriccion
         gsTablas = gsTablas.replaceFirst("%AtributoUnico",
                                          clsConstantes.sATRIBUTO_UNICO);
         // Reemplazar el nombre del atributo
         gsTablas = gsTablas.replaceFirst("%NombreAtributo", sAtribActual);

         for (int iIndice = 1; iIndice < pvUnique.size(); iIndice++) {
            // Comprobar si el siguiente atributo pertenece a la restriccin actual
            if (sUniqueActual.equals(sRestUnique( (String) pvUnique.elementAt(
               iIndice)))) {
               // Obtener el atributo a tratar
               sAtribActual = sAtriUnique( (String) pvUnique.elementAt(iIndice));
               // Aadir la plantilla para aadir el atributo que participa en la restriccion
               gsTablas = gsTablas.replaceFirst("%AtributoUnico",
                                                clsConstantes.sATRIBUTO_UNICO);
               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceFirst("%NombreAtributo", sAtribActual);
            } // if
         } // for

         // Limpiar la marca para el siguiente atributo de esta restriccin
         gsTablas = gsTablas.replaceFirst(",%AtributoUnico", "");

         //Iniciarlizar el ndice para limpiar el vector
         iBorrar = 0;
         // Purgar el vector
         while (iBorrar < pvUnique.size()) {
            // Comprobar si el siguiente atributo pertenece a la restriccin actual
            if (sUniqueActual.equals(sRestUnique( (String) pvUnique.elementAt(
               iBorrar)))) {
               // Eliminar el elemento actual
               pvUnique.removeElementAt(iBorrar);
               // Iniciar el contador
               iBorrar = 0;
            } // if
            else {
               // Incrementar el contador
               iBorrar++;
            } // else
         } // while
      } // while
   } // Procedimiento: GenerarUniqueTabla

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sFormatearComentario                                           //
   // Parmetros: - psComentario (String) : Comentario                        //
   //             - pbParrafo (boolean): Indica si se genera un nuevo prrafo //
   //               se genera para la tabla para que no se ponga coma despus //
   // Retorno: El comentario formateado para el script                        //
   // Descripcin: Formatea el comentario para el script                      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private String sFormatearComentario(String psComentario,
                                       boolean pbParrafo) {

      String sComentario; // Cadena con el comentario formateado

      // Formatear el comentario
      if (psComentario.trim().equals("")) {
         sComentario = "";
      } // if
      else {
         if (pbParrafo) {
            sComentario = "-- " +
               psComentario.trim().replaceAll(String.valueOf(clsConstantes.
               cRETORNO_CARRO), "\n-- ") + "\n";
         } // if
         else {
            sComentario = psComentario.trim().replaceAll(String.valueOf(
               clsConstantes.
               cRETORNO_CARRO), " ");
         } // else
      } // else

      // Devolver la cadena con el comentario formateado
      return sComentario;
   } // Funcin: sFormatearComentario

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sRestUnique                                                    //
   // Parmetros: - psCadena (String): Cadena con la restriccin Unique       //
   // Retorno: Nombre de la restriccin Unique                                //
   // Descripcin: Extrae el nombre de la restriccin Unique de la cadena     //
   //              recibida                                                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private String sRestUnique(String psCadena) {
      return psCadena.substring(psCadena.lastIndexOf("@") + 1);
   } // Funcin: sRestUnique

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sAtriUnique                                                    //
   // Parmetros: - psCadena (String): Cadena con la restriccin Unique       //
   // Retorno: Nombre del atributo Unique                                     //
   // Descripcin: Extrae el nombre del atributo Unique de la cadena recibida //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private String sAtriUnique(String sCadena) {
      return sCadena.substring(0, sCadena.lastIndexOf("@"));
   } // Funcin: sAtriUnique

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosUnionDiferente                           //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de un tipo unin con   //
   //              llaves diferentes                                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosUnionDiferente(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oUnion; // Objeto para el tipo unin
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases

      // Obtener la Union a la que pertenece el elemento
      oUnion = oGeneral.elmElemento( (String) poElemento.vUniones.elementAt(
         0));

      // Tomar la llave de la Superclase de la Unin slo si el
      // elemento no es ya la Superclase de la Unin
      bSuperclase = false;
      iSuperclases = 0;
      while ( (iSuperclases < oUnion.vSuperclases.size()) && !bSuperclase) {
         bSuperclase = ( (String) oUnion.vSuperclases.elementAt(
            iSuperclases)).
            equals(poElemento.sNombre);
         // Incrementar el indice
         iSuperclases++;
      } // while
      if (bSuperclase) {
         // Generar la llave externa hacia la llave de la Subclase de la Unin
         GenerarAtributoExternosSuperclase(poElemento);
      } // if
      else {
         // Crear la llave ficticia para la Subclase de la Unin
         GenerarLlaveFicticia(poElemento);
      } // else

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for
   } // Procedimiento: GenerarAtributosUnionDiferente

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosSuperclaseUnion                          //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de una superclase de   //
   //              un tipo unin                                              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosSuperclaseUnion(clsElemento poElemento) {

      clsElemento elmAtributo;
      clsElemento elmEspecializacion;
      clsElemento elmUnion;
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         elmAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (elmAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (elmAtributo.vAtributos.size() > 0) {
               GenerarAtributos(elmAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                elmAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(elmAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              elmAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(elmAtributo.sNombre)) {
               oGeneral.vElementos.addElement(elmAtributo);
            } // if

         } // else
      } // for
   } // Procedimiento: GenerarAtributosSuperclaseUnion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosSuperclaseUnion                          //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de la  subclase de un  //
   //              tipo unin                                                 //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosSubclaseUnion(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oUnion; // Objeto para el tipo unin
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases

      if ( (poElemento.vUniones != null) &&
          (poElemento.vUniones.size() > 0)) {
         // Obtener la Unin
         oUnion = oGeneral.elmElemento( (String) poElemento.
                                         vUniones.elementAt(0));
         // Tomar la llave de la Superclase de la Unin slo si el
         // elemento no es ya la Superclase de la Unin
         bSuperclase = false;
         iSuperclases = 0;
         while ( (iSuperclases < poElemento.vUniones.size()) && !bSuperclase) {
            bSuperclase = ( (String) oUnion.vSuperclases.elementAt(
               iSuperclases)).
               equals(poElemento.sNombre);
            // Incrementar el indice
            iSuperclases++;
         } // while
         if (!bSuperclase) {
            GenerarAtributosLlave(oGeneral.elmElemento( (String) oUnion.
               vSuperclases.
               elementAt(0)));
         } // if
      } // if

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for
   } // Procedimiento: GenerarAtributosSubclaseUnion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos_B                                       //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de una entidad         //
   //              perteneciente a una especializacin usando la opcin B     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos_B(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oEspecializacion; // Objeto para la especializacin
      Vector vUnique; // Vector con los atributos con propiedad Unique con nombre

      if ( (poElemento.vEspecializaciones != null) &&
          (poElemento.vEspecializaciones.size() > 0)) {
         // Obtener la Especializacion
         oEspecializacion = oGeneral.elmElemento( (String) poElemento.
            vEspecializaciones.elementAt(0));
         // Tomar la llave de la Superclase de la Especializacin slo si el
         // elemento no es ya la Superclase de la Especializacin
         if (!oEspecializacion.sSuperclase.equals(poElemento.sNombre)) {
            GenerarAtributos(oGeneral.elmElemento(oEspecializacion.
                                                  sSuperclase));
         } // if
      } // if

      // Iniciar el vector de atributos Unique
      vUnique = new Vector();

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo, vUnique, 1 < 0, 1 < 0);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for

      GenerarUniqueTabla(vUnique, false);
   } // Procedimiento: GenerarAtributos_B

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos_C                                       //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de una entidad         //
   //              perteneciente a una especializacin usando la opcin C     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos_C(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      Vector vUnique; // Vector con los atributos con propiedad Unique con nombre

      // Iniciar el vector de atributos Unique
      vUnique = new Vector();

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo, vUnique, 1 < 0, 1 < 0);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for

      GenerarUniqueTabla(vUnique, false);
   } // Procedimiento: GenerarAtributos_C

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos_D                                       //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de una entidad         //
   //              perteneciente a una especializacin usando la opcin D     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos_D(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      Vector vUnique; // Vector con los atributos con propiedad Unique con nombre

      // Iniciar el vector de atributos Unique
      vUnique = new Vector();

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo, vUnique, 1 < 0, 1 < 0);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for

      GenerarUniqueTabla(vUnique, false);
   } // Procedimiento: GenerarAtributos_D

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributos_Subclases_D                             //
   // Parmetros: - poElemento (clsElemento): Objeto para el elemento         //
   // Descripcin: Genera el cdigo para los atributos de las subclases       //
   //              perteneciente a una especializacin usando la opcin D     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributos_Subclases_D(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oEspecializacion; // Objeto para la especializacin

      if ( (poElemento.vEspecializaciones != null) &&
          (poElemento.vEspecializaciones.size() > 0)) {
         // Obtener la Especializacion
         oEspecializacion = oGeneral.elmElemento( (String) poElemento.
            vEspecializaciones.elementAt(0));
         // Tomar la llave de la Superclase de la Especializacin slo si el
         // elemento no es ya la Superclase de la Especializacin
         if (!oEspecializacion.sSuperclase.equals(poElemento.sNombre)) {
            GenerarAtributosLlave(oGeneral.elmElemento(oEspecializacion.
               sSuperclase));
         } // if
      } // if

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);

         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributos(oAtributo);
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for
   } // Procedimiento: GenerarAtributos_Subclases_D

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarLlaveFicticia                                     //
   // Parmetros: poElemento (clsElemento) : Entidad cuyo cdigo se est      //
   // Descripcin: Generar el codigo para la llave ficticia de la Subclase    //
   //               que se est pasando                                       //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarLlaveFicticia(clsElemento poElemento) {

      // Aadir la plantilla para el atributo
      gsTablas = gsTablas.replaceFirst("%Atributos",
                                       clsConstantes.sATRIBUTO_FICTICIO);

      // Aadir la plantilla para la PRIMARY KEY
      gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                       clsConstantes.sCONSTRAINT_PRIMARY_KEY);
      gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                       clsConstantes.sCLAVE_PRIMARIA_FIC);

      // Reemplazar el nombre del atributo
      gsTablas = gsTablas.replaceAll("%AtributoFic",
                                     (String) poElemento.vUniones.elementAt(0));
   } // Procedimiento: GenerarLlaveFicticia

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosLlave                                    //
   // Parmetros: poElemento (clsElemento) : Objeto para el elemento          //
   // Descripcin: Genera el codigo para los atributos llaves del objeto      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosLlave(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);
         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributosLlave(oAtributo);
            } // if
            else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                     (oAtributo.nTipo ==
                      clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                     (oAtributo.bSuperllave)) {

               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Eliminar la marca del comentario
               gsTablas = gsTablas.replaceFirst("%ComentScript", "");


               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if

         } // else
      } // for
   } // Procedimiento: GenerarAtributosLlave

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosLlave_NM                                 //
   // Parmetros: poElemento (clsElemento) : Objeto para el elemento          //
   // Descripcin: Genera el codigo para los atributos llaves del objeto      //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosLlave_NM(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      boolean bEntidadDebil; // Indica si el atributo pertenece a una entidad dbil

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);
         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributosLlave_NM(oAtributo);
            } // if
            else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                     (oAtributo.nTipo ==
                      clsConstantes.nATRIBUTO_LLAVE_PARCIAL) ||
                     (oAtributo.bSuperllave)) {


               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.sATRIBUTO_EXTERNO);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo_NM(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);

               // Reemplazar la marca de ClaveExterna
               gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
                  clsConstantes.sCLAVE_EXTERNA);

               // Reemplazar la marca de ClaveReferencia
               gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
                  clsConstantes.sCLAVE_REFERENCIA);

               // Reemplazar el nombre del atributo
               gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                  oAtributo.sNombre);

               if ( (poElemento.vEspecializaciones != null) &&
                   (poElemento.vEspecializaciones.size() > 0) &&
                   ( (oConfig.nOpcionEsp == clsConstantes.nOPCION_C) ||
                    (oConfig.nOpcionEsp == clsConstantes.nOPCION_D))) {
                  // Reemplazar el nombre de la entidad
                  gsTablas = gsTablas.replaceAll("%TablaReferencia",
                                                 poElemento.sNombre);
                  // Reemplazar el nombre de la entidad
                  gsReferencias = gsReferencias.replaceAll("%TablaReferencia",
                     poElemento.sNombre);
               } // if
            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for
   } // Procedimiento: GenerarAtributosLlave_NM

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosLlave_NM_Debil                           //
   // Parmetros: poElemento (clsElemento) : Objeto para el elemento          //
   // Descripcin: Genera el codigo para los atributos llaves de una entidad  //
   //              dbil participante en una relacin N:M                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosLlave_NM_Debil(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el elemento actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);
         if (oAtributo.nTipo != clsConstantes.nATRIBUTO_MULTIVALUADO) {
            if (oAtributo.vAtributos.size() > 0) {
               GenerarAtributosLlave_NM_Debil(oAtributo);
            } // if
            else if ( (oAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
                     oAtributo.bSuperllave) {

               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.
                  sATRIBUTO_EXTERNO_PROPIETARIA_DEBIL);

               // Reemplazar el dominio del atributo
               gsTablas = gsTablas.replaceFirst("%Dominio",
                                                oAtributo.sDominio);

               // Reemplazar las restricciones del atributo
               GenerarPropiedadesAtributo_NM_Debil(oAtributo);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oAtributo.sNombre);
               // Reemplazar la marca de ClaveExterna
               gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
                  clsConstantes.sCLAVE_EXTERNA_PROPIETARIA_DEBIL);

               // Reemplazar la marca de ClaveReferencia
               gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
                  clsConstantes.sCLAVE_REFERENCIA_PROPIETARIA_DEBIL);

               // Reemplazar el nombre del atributo
               gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                  oAtributo.sNombre);

            } // else
         } // if
         else {
            if (!bExisteMultivaluado(oAtributo.sNombre)) {
               oGeneral.vElementos.addElement(oAtributo);
            } // if
         } // else
      } // for
   } // Procedimiento: GenerarAtributosLlave_NM_Debil

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosRelacion                                 //
   // Parmetros: poElemento (clsElemento): Objeto para el elemento           //
   // Descripcin: Genera el codigo para los atributos de una relacin        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosRelacion(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosRelacion(oAtributo);
         } // if
         else {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO_RELACION);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar las restricciones del atributo
            GenerarPropiedadesAtributoRelacion(oAtributo);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);
         } // if
      } // for
   } // Procedimiento: GenerarAtributosRelacion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosRelacionMasDos                           //
   // Parmetros: poElemento (clsElemento): Objeto para el elemento           //
   // Descripcin: Genera el codigo para los atributos de una relacin        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosRelacionMasDos(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo

      for (int i = 0; i < poElemento.vAtributos.size(); i++) {
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(i);

         if (oAtributo.vAtributos.size() > 0) {
            GenerarAtributosRelacionMasDos(oAtributo);
         }
         else {
            // Aadir la plantilla para el atributo
            gsTablas = gsTablas.replaceFirst("%Atributos",
                                             clsConstantes.sATRIBUTO);

            // Reemplazar el dominio del atributo
            gsTablas = gsTablas.replaceFirst("%Dominio", oAtributo.sDominio);

            // Reemplazar las restricciones del atributo
            GenerarPropiedadesAtributoRelacion(oAtributo);

            // Reemplazar el nombre del atributo
            gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                           oAtributo.sNombre);
         } // else
      } // for
   } // Procedimiento: GenerarAtributosRelacionMasDos

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarAtributosRelacion_NM                              //
   // Parmetros: poElemento (clsElemento): Objeto para el elemento           //
   // Descripcin: Genera el codigo para los atributos de una relacin N:M    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarAtributosRelacion_NM(clsElemento poElemento) {

      clsElemento oAtributo; // Objeto para el atributo
      clsElemento oEspecializacion; // Objeto para una especializacin
      clsElemento oUnion; // Objeto para un tipo unin
      clsElemento oInterseccion; // Objeto para un tipo interseccin
      boolean bSuperclase; // Indica si elmElemento es Superclase de Union
      int iSuperclases; // Indice para recorrer el vector de superclases

      // Para Subclases puras
      if (!poElemento.sSuperclase.equals("")) {
         GenerarAtributosLlave_NM(oGeneral.elmElemento(poElemento.sSuperclase));
      } // if

      // Para entidades dbiles
      if (poElemento.nTipo == clsConstantes.nENTIDAD_DEBIL) {
         GenerarAtributosLlave_NM(poElemento);
         GenerarAtributosLlave_NM_Debil(elmEntidadPropietaria(poElemento));

         // Reemplazar la entidad propietaria
         // Reemplazar el nombre de la entidad
         gsTablas = gsTablas.replaceAll("%TablaPropietaria",
                                        elmEntidadPropietaria(poElemento).
                                        sNombre);
         // Reemplazar el nombre de la entidad
         gsReferencias = gsReferencias.replaceAll("%TablaPropietaria",
                                                  elmEntidadPropietaria(
            poElemento).sNombre);

      } // if

      if ( (poElemento.vEspecializaciones != null) &&
          (poElemento.vEspecializaciones.size() > 0)) {
         // Obtener la Especializacion
         oEspecializacion = oGeneral.elmElemento( (String) poElemento.
            vEspecializaciones.elementAt(0));
         // Tomar la llave de la Superclase de la Especializacin slo si el
         // elemento no es ya la Superclase de la Especializacin
         if (!oEspecializacion.sSuperclase.equals(poElemento.sNombre)) {
            GenerarAtributosLlave_NM(oGeneral.elmElemento(oEspecializacion.
               sSuperclase));
         } // if
      } // if

      if ( (poElemento.vUniones != null) &&
          (poElemento.vUniones.size() > 0)) {
         // Obtener la Unin
         oUnion = oGeneral.elmElemento( (String) poElemento.
                                         vUniones.elementAt(0));
         // Tomar la llave de la Superclase de la Unin slo si el
         // elemento no es ya la Superclase de la Unin
         bSuperclase = false;
         iSuperclases = 0;
         while ( (iSuperclases < oUnion.vSuperclases.size()) && !bSuperclase) {
            bSuperclase = ( (String) oUnion.vSuperclases.elementAt(
               iSuperclases)).
               equals(poElemento.sNombre);
            // Incrementar el indice
            iSuperclases++;
         } // poElemento
         if (!bSuperclase) {
            // Distinguir entre Uniones con llaves iguales y con llaves diferentes
            if (oUnion.bLlavesIguales) {
               GenerarAtributosLlave_NM(oGeneral.elmElemento( (String) oUnion.
                  vSuperclases.
                  elementAt(0)));
            } // if
            else {
               // Aadir la plantilla para el atributo
               gsTablas = gsTablas.replaceFirst("%Atributos",
                                                clsConstantes.
                                                sATRIBUTO_EXTERNO_FICTICIO);

               // Aadir la plantilla para la PRIMARY KEY
               gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                                clsConstantes.
                                                sCONSTRAINT_PRIMARY_KEY);
               gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                                clsConstantes.
                                                sCLAVE_PRIMARIA_EXTERNA);

               // Reemplazar la marca de ClaveExterna
               gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
                  clsConstantes.sCLAVE_EXTERNA);

               // Reemplazar la marca de ClaveReferencia
               gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
                  clsConstantes.
                  sCLAVE_REFERENCIA);

               // Reemplazar el nombre del atributo
               gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                              oUnion.sNombre);

               // Reemplazar el nombre del atributo
               gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                  oUnion.sNombre);
            } // else
         } // if
      } // if
      if ( (poElemento.vIntersecciones != null) &&
          (poElemento.vIntersecciones.size() > 0)) {
         // Obtener la Interseccin
         oInterseccion = oGeneral.elmElemento( (String) poElemento.
                                                vIntersecciones.elementAt(0));
         // Tomar la llave de la Superclase de la Interseccin slo si el
         // elemento no es ya la Superclase de la Interseccin
         bSuperclase = false;
         iSuperclases = 0;
         while ( (iSuperclases < oInterseccion.vSuperclases.size()) &&
                !bSuperclase) {
            bSuperclase = ( (String) oInterseccion.vSuperclases.elementAt(
               iSuperclases)).
               equals(poElemento.sNombre);
            // Incrementar el indice
            iSuperclases++;
         } // while
         if (!bSuperclase) {
            GenerarAtributosLlave_NM(oGeneral.elmElemento( (String)
               oInterseccion.
               vSuperclases.
               elementAt(0)));
         } // if
      } // if

      for (int iIndice = 0; iIndice < poElemento.vAtributos.size(); iIndice++) {
         // Obtener el atributo actual
         oAtributo = (clsElemento) poElemento.vAtributos.elementAt(iIndice);
         // Generar las propiedades del atributo actual
         GenerarPropiedadesAtributosNM(oAtributo);
      } // for
   } // Procedimiento: GenerarAtributosRelacion_NM

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: GenerarPropiedadesAtributosNM                            //
   // Parmetros: poElemento (clsElemento): Objeto para el elemento           //
   // Descripcin: Genera el codigo para las propiedades de un atributo de    //
   //              una relacin N:M                                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void GenerarPropiedadesAtributosNM(clsElemento poAtributo) {

      boolean bEntidadDebil; // Indica si el atributo pertenece a una entidad dbil

      // Saber si el atributo pertenece a una entidad dbil
      bEntidadDebil = (oGeneral.elmElemento(poAtributo.sElementoAtributo).nTipo !=
                       clsConstantes.nENTIDAD_DEBIL);

      if (poAtributo.vAtributos.size() > 0) {
         for (int iIndice = 0; iIndice < poAtributo.vAtributos.size(); iIndice++) {
            GenerarPropiedadesAtributosNM( (clsElemento) poAtributo.vAtributos.
                                          elementAt(iIndice));
         } // for
      } // if
      else if ( (poAtributo.nTipo == clsConstantes.nATRIBUTO_LLAVE) ||
               (poAtributo.bSuperllave && bEntidadDebil)) {
         // Aadir la plantilla para la PRIMARY KEY
         gsTablas = gsTablas.replaceFirst("%PrimaryKey",
                                          clsConstantes.
                                          sCONSTRAINT_PRIMARY_KEY);
         gsTablas = gsTablas.replaceFirst("%ClavePrimaria",
                                          clsConstantes.
                                          sCLAVE_PRIMARIA_EXTERNA);

         // Aadir la plantilla para el atributo
         gsTablas = gsTablas.replaceFirst("%Atributos",
                                          clsConstantes.sATRIBUTO_EXTERNO);

         // Reemplazar la marca de ClaveExterna
         gsReferencias = gsReferencias.replaceFirst("%ClaveExterna",
            clsConstantes.sCLAVE_EXTERNA);

         // Reemplazar la marca de ClaveReferencia
         gsReferencias = gsReferencias.replaceFirst("%ClaveReferencia",
            clsConstantes.sCLAVE_REFERENCIA);

         // Reemplazar el dominio del atributo
         gsTablas = gsTablas.replaceFirst("%Dominio", poAtributo.sDominio);

         // Reemplazar el nombre del atributo
         gsTablas = gsTablas.replaceAll("%NombreAtributo",
                                        poAtributo.sNombre);

         // Reemplazar el nombre del atributo
         gsReferencias = gsReferencias.replaceAll("%NombreAtributo",
                                                  poAtributo.sNombre);
      } // else
   } // Procedimiento: GenerarPropiedadesAtributosNM

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sGenerarScript                                                 //
   // Parmetros: No                                                          //
   // Retorno: Cadena con el script                                           //
   // Descripcin: Construye una cadena con el script de creacin de la bbddv //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public String sGenerarScript() {
      // Limpiar la cadena con el cdigo
      gsTablas = "";
      // Limpiar la cadena con el cdigo de las referencias
      gsReferencias = "";
      // Llamar al mtodo que genera el script
      GenerarScript();
      return gsTablas + gsReferencias;
   } // Funcin: sGenerarScript

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: sSuperclaseDeSubclase                                          //
   // Parmetros: poEntidad (clsElemento) : Entidad que se quiere comprobar   //
   // Retorno: Valor que indica si la entidad recibida es subclase            //
   // Descripcin: Devuelve si la entidad pasada es Subclase                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private int nEsSubclase(clsElemento poEntidad) {

      int nResultado; // Variable con el resultado de la comprobacin

      // Considerar por defecto que no es Subclase
      nResultado = clsConstantes.nNO_SUBCLASE;

      // Comprobar si es Subclase y en caso afirmativo determinar de qu lo es
      if (!poEntidad.sSuperclase.equals("")) {
         // Indicar que es Subclase de una Entidad
         nResultado = clsConstantes.nSUBCLASE;
      } // if
      else if (poEntidad.vEspecializaciones.size() > 0) {
         // Indicar que es Subclase de una Especializacin
         nResultado = clsConstantes.nSUBCLASE_ESPECIALIZACION;
      } // else if
      else if (poEntidad.vUniones.size() > 0) {
         // Indicar que es Subclase de una Unin
         nResultado = clsConstantes.nSUBCLASE_TIPO_UNION;
      } // else if
      else if (poEntidad.vIntersecciones.size() > 0) {
         // Indicar que es Subclase de una Interseccin
         nResultado = clsConstantes.nSUBCLASE_TIPO_INTERSECCION;
      } // else if

      // Devolver el resultado
      return nResultado;
   } // Funcin: bEsSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: elmEspecializacionDeSubclase                                   //
   // Parmetros: poSubclase (Elemento): Subclase cuya Superclase se quiere   //
   //             conocer                                                     //
   // Retorno: Objeto con la superclase de la subclase                        //
   // Descripcin: Devuelvela Superclase para la Subclase pasadacomo parmetro//
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private clsElemento elmEspecializacionDeSubclase(clsElemento poSubclase) {
      return oGeneral.elmElemento( (String) poSubclase.vEspecializaciones.
                                  elementAt(0));
   } // Funcin: elmEspecializacionDeSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: elmEntidadPropietaria                                          //
   // Parmetros: poEntidad (clsElemento) : Entidad dbil cuya propietaria    //
   //             se quiere obtener                                           //
   // Retorno: Objeto con la entidad propietaria de la entidad dbil          //
   // Descripcin: Devuelve un objeto con la entidad propietaria de la        //
   //              entidad dbil que se recibe                                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private clsElemento elmEntidadPropietaria(clsElemento poEntidad) {

      int iIndice; // ndice para recorrer el vector de relaciones
      clsElemento oRelacion = null; // Objeto para la relacin identificativa
      clsElemento oEntProp = null; // Objeto con la entidad propietaria
      boolean bEncontrada; // Indica si se ha encontrado la relacin identificativa
      String sEntProp; // Nombre de la entidad propietaria

      bEncontrada = false;
      iIndice = 0;
      // Recorrer el vector de relaciones hasta encontrar la relacin dbil
      while ( (iIndice < poEntidad.vRelaciones.size()) && !bEncontrada) {
         // Obtener la relacin actual
         oRelacion = oGeneral.elmElemento( (String) poEntidad.vRelaciones.
                                          elementAt(iIndice));
         // Comprobar si se ha encontrado la relacin dbil
         bEncontrada = (oRelacion.nTipo ==
                        clsConstantes.nRELACION_IDENTIFICATIVA);

         iIndice++;
      } // while

      // Obtener la entidad propietaria
      if ( ( (clsEntRel) oRelacion.vEntRel.elementAt(0)).sNombre.equals(
         poEntidad.sNombre)) {
         sEntProp = ( (clsEntRel) oRelacion.vEntRel.elementAt(1)).sNombre;
      } // if
      else {
         sEntProp = ( (clsEntRel) oRelacion.vEntRel.elementAt(0)).sNombre;
      } // else

      // Obtener el objeto con la entidad propietaria
      oEntProp = oGeneral.elmElemento(sEntProp);

      // Devolver el objeto con la entidad propietaria
      return oEntProp;
   } // Funcin: elmEntidadPropietaria

   // Indica si existe un atributo multivaluado con ese nombre
   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: elmEntidadPropietaria                                          //
   // Parmetros: psNombre (String): Nombre del atributo que se busca         //
   // Retorno: Valor lgico que indica si se ha encontrado el atributo        //
   // Descripcin: Indica si existe un atributo multivaluado con ese nombre   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private boolean bExisteMultivaluado(String psNombre) {

      boolean bEncontrado; // Valor de retorno
      int iIndice; // ndice para recorrer el vector de elementos
      clsElemento oElemento; // Objeto con el elemento actual

      // Suponer que no se ha encontrado
      bEncontrado = false;
      // Iniciar el ndice
      iIndice = 0;
      while ( (iIndice < oGeneral.vElementos.size()) && !bEncontrado) {
         // Obtener el elemento actual
         oElemento = (clsElemento) oGeneral.vElementos.elementAt(iIndice);
         // Obtener si se ha encontrado el elemento
         bEncontrado = ( (oElemento.nTipo ==
                          clsConstantes.nATRIBUTO_MULTIVALUADO) &&
                        (oElemento.sNombre.equals(psNombre)));
         iIndice++;
      } // while

      // Devolver el valor de la bsqueda
      return bEncontrado;
   } // Funcin: bExisteMultivaluado

} // Clase: clsScript