package Derytas;

import java.awt.*;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsSubclase                                                         //
// Mtodos: - public clsSubclase: Constructor de la clase                     //
//          - private void LimpiarVentana: Establece los valores iniciales de //
//            la ventana                                                      //
//          - private void Ocultar: Cierra la ventana                         //
//          - private void AgregarSuperclase: Agregar una entidad como        //
//            superclase                                                      //
//          - private void QuitarSuperclase: Quitar una entidad como          //
//            superclase                                                      //
//          - private void ActivarAgregarSuperclase: Habilitar el botn para  //
//            agregar una superclase                                          //
//          - private void ActivarAgregarSubclase: Habilitar el botn para    //
//            agregar una subclase                                            //
//          - private void AgregarSubclase: Agrega una entidad como subclase  //
//          - private void QuitarSubclase: Quita una entidad como subclase    //
//          - private void ActivarQuitarSub: Habilita el botn para quitar    //
//            entidad como subclase                                           //
// Descripcin: Clase para crear una relacin superclase-subclase entre dos   //
//              entidades                                                     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
public class clsSubclase
   extends Frame {

   // Variables de clase
   private clsGeneral oGeneral;
   private clsConfig oConfig;

   // Componentes de la ventana
   private Label lblSuperclases;
   private List lstSuperclases;
   private Label lblSubclases;
   private List lstSubclases;
   private Label lblBtnSuper;
   private Button btnAgregarSuper;
   private Button btnQuitarSuper;
   private Label lblBtnSub;
   private Button btnAgregarSub;
   private Button btnQuitarSub;
   private Label lblSubclase;
   private TextField txtSubclase;
   private Button btnCrear;
   private Button btnCerrar;
   private Checkbox chbCerrar;
   private Label lblSuperclase;
   private TextField txtSuperclase;
   private String sNombreAntiguo;

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsSubclase                                               //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   //             - poConfig (clsConfig): Objeto de la clase clsConfig para   //
   //               poder acceder a las variables de configuracin            //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsSubclase(clsGeneral poGeneral,
                      clsConfig poConfig) {

      // Inicializacin de variables

      oGeneral = poGeneral;
      oConfig = poConfig;

      int nAnchoButton = clsConstantes.nANCHO_BUTTON / 2 +
         clsConstantes.nSEP_COM;
      int nAltoList = clsConstantes.nALTO_LIST / 2;
      int nAnchoLabelButton = clsConstantes.nANCHO_BUTTON +
         2 * clsConstantes.nSEP_COM;

      // Crear los componentes de la ventana
      lblSuperclases = new Label("Elegir Entidad Superclase");
      lblSubclases = new Label("Elegir Entidad Subclase");
      lblBtnSuper = new Label("  Quitar/Agregar");
      lblSuperclase = new Label("Superclase");
      lstSuperclases = new List();
      lstSubclases = new List();
      btnAgregarSuper = new Button(">>");
      btnQuitarSuper = new Button("<<");
      txtSuperclase = new TextField();
      lblBtnSub = new Label("  Quitar/Agregar");
      lblSubclase = new Label("Subclase");
      txtSubclase = new TextField();
      btnAgregarSub = new Button(">>");
      btnQuitarSub = new Button("<<");
      btnCrear = new Button("Crear Subclase");
      btnCerrar = new Button("Cancelar");
      chbCerrar = new Checkbox("Cerrar despus de Crear");

      // Propiedades de los componentes de la ventana

      // lblSuperclases
      // Establecer tamao y posicin
      lblSuperclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                             clsConstantes.nSEP_VVER,
                                             clsConstantes.nANCHO_LABEL,
                                             clsConstantes.nALTO_COM));

      // lstSuperclases
      // Establecer tamao y posicin
      lstSuperclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                             lblSuperclases.getY() +
                                             clsConstantes.nALTO_COM,
                                             clsConstantes.nANCHO_LIST,
                                             nAltoList));
      // Aadir el componente al listener para cuando se cambie la seleccin
      lstSuperclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblSubclases
      // Establecer tamao y posicin
      lblSubclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                           lstSuperclases.getY() +
                                           nAltoList +
                                           clsConstantes.nSEP_COM,
                                           clsConstantes.nANCHO_LABEL,
                                           clsConstantes.nALTO_COM));

      // lstSubclases
      // Establecer tamao y posicin
      lstSubclases.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                           lblSubclases.getY() +
                                           clsConstantes.nALTO_COM,
                                           clsConstantes.nANCHO_LIST,
                                           nAltoList));
      // Aadir el componente al listener para cuando se cambie la seleccin
      lstSubclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSuper
      // Establecer tamao y posicin
      lblBtnSuper.setBounds(new Rectangle(lblSuperclases.getX() +
                                          clsConstantes.nANCHO_LABEL +
                                          clsConstantes.nSEP_COM,
                                          lblSuperclases.getY(),
                                          nAnchoLabelButton,
                                          clsConstantes.nALTO_COM));

      // btnQuitarSuper
      // Establecer tamao y posicin
      btnQuitarSuper.setBounds(new Rectangle(lblBtnSuper.getX(),
                                             lstSuperclases.getY(),
                                             nAnchoButton,
                                             clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSuper
      // Establecer tamao y posicin
      btnAgregarSuper.setBounds(new Rectangle(btnQuitarSuper.getX() +
                                              nAnchoButton +
                                              clsConstantes.nSEP_COM,
                                              btnQuitarSuper.getY(),
                                              nAnchoButton,
                                              clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSuper.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSub
      // Establecer tamao y posicin
      lblBtnSub.setBounds(new Rectangle(lblBtnSuper.getX(),
                                        lblSubclases.getY(),
                                        nAnchoLabelButton,
                                        clsConstantes.nALTO_COM));

      // btnQuitarSub
      btnQuitarSub.setBounds(new Rectangle(lblBtnSub.getX(),
                                           lblBtnSub.getY() +
                                           clsConstantes.nALTO_COM,
                                           nAnchoButton,
                                           clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSub
      // Establecer tamao y posicin
      btnAgregarSub.setBounds(new Rectangle(btnQuitarSub.getX() +
                                            nAnchoButton +
                                            clsConstantes.nSEP_COM,
                                            btnQuitarSub.getY(),
                                            nAnchoButton,
                                            clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSub.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblSuperclase
      // Establecer tamao y posicin
      lblSuperclase.setBounds(new Rectangle(btnAgregarSuper.getX() +
                                            nAnchoButton +
                                            clsConstantes.nSEP_COM,
                                            lblSuperclases.getY(),
                                            clsConstantes.nANCHO_LABEL,
                                            clsConstantes.nALTO_COM));

      // txtSuperclase
      // Establecer tamao y posicin
      txtSuperclase.setBounds(new Rectangle(lblSuperclase.getX(),
                                            btnAgregarSuper.getY(),
                                            clsConstantes.
                                            nANCHO_TEXTFIELD,
                                            clsConstantes.nALTO_COM));
      txtSuperclase.setEnabled(false);

      // lblSubclase
      // Establecer tamao y posicin
      lblSubclase.setBounds(new Rectangle(lblSuperclase.getX(),
                                          lblBtnSub.getY(),
                                          clsConstantes.nANCHO_LABEL,
                                          clsConstantes.nALTO_COM));

      // txtSubclase
      // Establecer tamao y posicin
      txtSubclase.setBounds(new Rectangle(lblSuperclase.getX(),
                                          lblSubclase.getY() +
                                          clsConstantes.nALTO_COM,
                                          clsConstantes.nANCHO_TEXTFIELD,
                                          clsConstantes.nALTO_COM));
      // Deshablitar el campo
      txtSubclase.setEnabled(false);

      // btnCerrar
      // Establecer tamao y posicin
      btnCerrar.setBounds(new Rectangle(txtSubclase.getX() +
                                        clsConstantes.nANCHO_LIST -
                                        clsConstantes.nANCHO_BUTTON,
                                        txtSubclase.getY() + nAltoList +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_BUTTON,
                                        clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCerrar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnCrear
      // Establecer tamao y posicin
      btnCrear.setBounds(new Rectangle(btnCerrar.getX() -
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR -
                                       clsConstantes.nSEP_COM,
                                       btnCerrar.getY(),
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR,
                                       clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCrear.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            CrearSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // chbCerrar
      // Establecer tamao y posicin
      chbCerrar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        btnCrear.getY() +
                                        clsConstantes.nALTO_BUTTON +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_CHECKBOX +
                                        40,
                                        clsConstantes.nALTO_COM));
      // Obtener la opcin para cerrar de la variable de configuracin
      chbCerrar.setState(oConfig.bCerrar);

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(oGeneral.nAnchoVentana(btnCerrar.getX()),
              oGeneral.nAltoVentana(chbCerrar.getY()));
      // Asignar el ttulo
      setTitle("Nueva Subclase");
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Establecer el icono de la ventana
      setIconImage(oGeneral.imgLogo);
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana actual
      oGeneral.EstablecerActual(this);
      // Aadir los componenentes a la ventana
      add(lblSuperclases);
      add(lblSubclases);
      add(lblBtnSuper);
      add(lblSuperclase);
      add(txtSuperclase);
      add(lstSuperclases);
      add(lstSubclases);
      add(btnAgregarSuper);
      add(btnQuitarSuper);
      add(lblSubclase);
      add(txtSubclase);
      add(lblBtnSub);
      add(btnAgregarSub);
      add(btnQuitarSub);
      add(btnCrear);
      add(btnCerrar);
      add(chbCerrar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // Limpiar la ventana
      LimpiarVentana();
      // Mostrar la ventana
      setVisible(true);
   } // Procedimiento: clsSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: LimpiarVentana                                           //
   // Parmetros: No                                                          //
   // Descripcin: Establece los valores iniciales de la ventana              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void LimpiarVentana() {
      // Cargar la lista de superclases
      oGeneral.CargarListaSuperclases(lstSuperclases);
      // Deshabilitar el botn para agregar la superclase
      btnAgregarSuper.setEnabled(false);
      // Deshabilitar el botn para quitar la superclase
      btnQuitarSuper.setEnabled(false);
      // Limpiar la superclase
      txtSuperclase.setText("");
      // Cargar la lista de subclases
      oGeneral.CargarListaSubclases(lstSubclases);
      // Deshabilitar el botn para agregar la subclase
      btnAgregarSub.setEnabled(false);
      // Deshabilitar el botn para quitar la subclase
      btnQuitarSub.setEnabled(false);
      // Limpiar la subclase
      txtSubclase.setText("");
      // Dehabilitar el botn Crear
      btnCrear.setEnabled(false);
   } // Procedimiento: LimpiarVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Lgica necesaria  para cerrar la ventana                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Limpiar la ventana actual
      oGeneral.EstablecerActual(null);
      // Guardar si las ventanas deben cerrarse o no despus de crear
      oConfig.bCerrar = chbCerrar.getState();
      // Indicar que no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
      // Ocultar la ventana
      this.dispose();
   } // Procedimiento: Ocultar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSuperclase                                        //
   // Parmetros: No                                                          //
   // Descripcin: Agregar una entidad como superclase                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSuperclase() {
      txtSuperclase.setText(lstSuperclases.getSelectedItem());
      lstSuperclases.remove(lstSuperclases.getSelectedIndex());
      btnAgregarSub.setEnabled(false);
      btnAgregarSuper.setEnabled(false);
      btnQuitarSuper.setEnabled(true);
      btnCrear.setEnabled(!txtSubclase.getText().equals(""));
   } // Procedimiento: AgregarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSuperclase                                         //
   // Parmetros: No                                                          //
   // Descripcin: Quita una entidad como superclase                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSuperclase() {
      lstSuperclases.add(txtSuperclase.getText());
      txtSuperclase.setText("");
      btnQuitarSuper.setEnabled(false);
      btnCrear.setEnabled(false);
   } // Procedimiento: QuitarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSuperclase                                 //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para agregar una entidad como superclase //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSuperclase() {
      btnAgregarSuper.setEnabled(txtSuperclase.getText().equals(""));
   } // Procedimiento: ActivarAgregarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSubclase                                   //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para agregar una entidad como subclase   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSubclase() {
      btnAgregarSub.setEnabled(txtSubclase.getText().equals(""));
   } // Procedimiento: ActivarAgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSubclase                                          //
   // Parmetros: No                                                          //
   // Descripcin: Agrega una entidad como subclase                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSubclase() {
      txtSubclase.setText(lstSubclases.getSelectedItem());
      lstSubclases.remove(lstSubclases.getSelectedIndex());
      btnAgregarSub.setEnabled(false);
      btnAgregarSuper.setEnabled(false);
      btnQuitarSub.setEnabled(true);
      btnCrear.setEnabled(!txtSuperclase.getText().equals(""));
   } // Procedimiento: AgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSubclase                                           //
   // Parmetros: No                                                          //
   // Descripcin: Quita una entidad como subclase                            //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSubclase() {
      lstSubclases.add(txtSubclase.getText());
      txtSubclase.setText("");
      btnQuitarSub.setEnabled(false);
      btnCrear.setEnabled(false);
   } // Procedimiento: QuitarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarQuitarSub                                         //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para quitar una entidad ocmo subclase    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarQuitarSub() {
      btnQuitarSub.setEnabled(true);
   } // Procedimiento: ActivarQuitarSub

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CrearSubclase                                            //
   // Parmetros: No                                                          //
   // Descripcin: Crea la relacin superclase-subclase entre las entidades   //
   //              indicadas                                                  //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public void CrearSubclase() {
      // Asignar la Subclase a la Superclase
      oGeneral.elmElemento(txtSuperclase.getText()).sSubclase = txtSubclase.
         getText();
      // Asignar la Superclase a la Subclase
      oGeneral.elmElemento(txtSubclase.getText()).sSuperclase =
         txtSuperclase.
         getText();

      // Actualizar la variable global bCerrar con el valor de la ventana
      oConfig.bCerrar = chbCerrar.getState();

      // Comprobar si se debe ocultar la ventana
      if (oConfig.bCerrar) {
         // Ocultar la ventana
         Ocultar();
      } // if
      else {
         // Limpiar la ventana
         LimpiarVentana();
      } // else

      // Actualizar el esquema
      oGeneral.Repintar();
   } // Procedimiento: CrearSubclase

} // CLASE: clsSubclase
