package Derytas;

import java.util.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Clase: clsTipoInterseccion                                                 //
// Mtodos: - public clsTipoInterseccion: Constructor de la clase             //
//          - private void Mostrar: Muestra la ventana segn el modo de       //
//            apertura indicado                                               //
//          - private void Ocultar: Cierra la ventana                         //
//          - private void AgregarSubclase: Agrega una entidad como subclase  //
//          - private void QuitarSubclase: Quitar una entidad como subclse    //
//          - private void ActivarAgregarSuperclase: Habilita el botn para   //
//            agregar una superclase                                          //
//          - private void ActivarAgregarSubclase: Habilita el botn para     //
//            agregar la subclase                                             //
//          - private void AgregarSuperclase: Agrega la entidad seleccionada  //
//            como superclase                                                 //
//          - private void QuitarSuperclase: Quita la entidad seleccionada    //
//            como superclase                                                 //
//          - private void ActivarQuitarSuper: Habilitar el botn para        //
//            eliminar una superclase                                         //
//          - private void HabilitarCrear: Habilita/deshabilita el botn Crear//
//          - private void LimpiarVentana: Establece los valores iniciales de //
//            la ventana                                                      //
//          - private void CrearSubclaseCompartida: Crea el tipo interseccin //
//          - private void QuitarInterseccionEntidades: Quita el tipo         //
//            interseccin de las entidades                                   //
//          - private boolean bValidar: Comprueba que los datos introducidos  //
//            para la creacin del tipo interseccin son correctos            //
//          - private void ActualizarTitulo: Actualiza el ttulo de la        //
//            ventana                                                         //
//          - private void AgregarASuperclases: Agrega el tipo interseccin a //
//            las superclases                                                 //
// Descripcin: Clase para crear y modificar tipos unin                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
class clsTipoInterseccion extends Frame{

   // Variables de clase
   private clsGeneral oGeneral;
   private clsConfig oConfig;
   private clsMensajes oMensajes;
   private int nModo; // Modo de apertura de la ventana
   private String sNombreAntiguo;

   // Componentes de la ventana
   private Label lblNombre;
   private TextField txtNombre;
   private Label lblTipo;
   private CheckboxGroup cbgTipo;
   private Checkbox chbTotal;
   private Checkbox chbParcial;
   private Label lblListaSuperclases;
   private List lstListaSuperclases;
   private Label lblListaSubclase;
   private List lstListaSubclase;
   private Label lblBtnSub;
   private Button btnAgregarSub;
   private Button btnQuitarSub;
   private Label lblBtnSuper;
   private Button btnAgregarSuper;
   private Button btnQuitarSuper;
   private Label lblSuperclases;
   private List lstSuperclases;
   private Button btnCrear;
   private Button btnCerrar;
   private Checkbox chbCerrar;
   private Vector vSuperclases;
   private Label lblSubclase;
   private TextField txtSubclase;

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: clsTipoInterseccion                                      //
   // Parmetros: - poGeneral (clsGeneral): Objeto de la clase clsGeneral     //
   //               para poder acceder a los mtodos de carcter general      //
   //             - poConfig (clsConfig): Objeto de la clase clsConfig para   //
   //               poder acceder a las variables de configuracin            //
   //             - pnModo (int): Modo de acceso a la ventana                 //
   // Descripcin: Constructor de la clase                                    //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   public clsTipoInterseccion(clsGeneral poGeneral,
                              clsConfig poConfig,
                              int pnModo) {

      // Inicializacin de variables

      oGeneral = poGeneral;
      oConfig = poConfig;
      oMensajes = new clsMensajes(oGeneral);
      nModo = pnModo;

      int nAnchoButton = clsConstantes.nANCHO_BUTTON / 2;
      int nAltoList = clsConstantes.nALTO_LIST / 2;
      int nAnchoLabelButton = clsConstantes.nANCHO_BUTTON +
         2 * clsConstantes.nSEP_COM;

      // Crear los componentes de la ventana
      lblNombre = new Label("Nombre del Tipo Interseccin");
      txtNombre = new TextField();
      lblTipo = new Label("Participacin del Tipo Interseccin");
      cbgTipo = new CheckboxGroup();
      chbTotal = new Checkbox(clsConstantes.sTIPO_INTERSECCION_TOTAL,
                              cbgTipo, true);
      chbParcial = new Checkbox(clsConstantes.
                                sTIPO_INTERSECCION_PARCIAL,
                                cbgTipo, false);
      lblListaSuperclases = new Label("Elegir Entidades Superclases");
      lblListaSubclase = new Label("Elegir Entidad Subclase");
      lblBtnSub = new Label(" Quitar/Agregar");
      lblSubclase = new Label(
         "Subclase del Tipo Interseccin");
      lstListaSuperclases = new List();
      lstListaSubclase = new List();
      btnAgregarSub = new Button(">>");
      btnQuitarSub = new Button("<<");
      txtSubclase = new TextField();
      lblBtnSuper = new Label(" Quitar/Agregar");
      lblSuperclases = new Label("Superclases del Tipo Interseccin");
      lstSuperclases = new List();
      btnAgregarSuper = new Button(">>");
      btnQuitarSuper = new Button("<<");
      btnCrear = new Button("Crear Tipo Interseccin");
      btnCerrar = new Button("Cancelar");
      chbCerrar = new Checkbox("Cerrar despus de Crear");
      if (nModo == clsConstantes.nMODO_ALTA) {
         vSuperclases = new Vector();
      } // if
      else {
         vSuperclases = (Vector) oGeneral.oModificar.vSuperclases.clone();
      } // else

      // Propiedades de los componentes de la ventana

      // lblNombre
      // Establecer tamao y posicin
      lblNombre.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        clsConstantes.nSEP_VVER,
                                        clsConstantes.nANCHO_LABEL,
                                        clsConstantes.nALTO_COM));

      // txtNombre
      // Establecer tamao y posicin
      txtNombre.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        lblNombre.getY() +
                                        clsConstantes.nALTO_COM,
                                        clsConstantes.nANCHO_TEXTFIELD,
                                        clsConstantes.nALTO_COM));
      // Controlar el teclado
      txtNombre.addKeyListener(new KeyListener() {

         String sNombre; // Nombre de la entidad

         public void keyTyped(KeyEvent e) {
            //  No hace falta
         }; // keyTyped

         public void keyPressed(KeyEvent e) {
            if ( (e.getKeyCode() == e.VK_ENTER) &&
                (! (txtNombre.getText().equals("")))) {
              // Crear el tipo interseccin cuando se pulsa ENTER sobre el nombre
               CrearSubclaseCompartida();
            } // if
            else {
               // Habilitar/Deshabilitar el botn Crear
               HabilitarCrear();
               if (txtNombre.getText().length() <= clsConstantes.nMAX_NOMBRE) {
                  // Guardar el nombre escrito hasta el momento
                  sNombre = txtNombre.getText();
                  // Actualizar el ttulo de la ventana
                  ActualizarTitulo();
               } // if
               else {
                  txtNombre.setText(sNombre);
               } // else
            } // else
         } // keyPressed

         public void keyReleased(KeyEvent e) {
            HabilitarCrear();
            if (txtNombre.getText().length() <= clsConstantes.nMAX_NOMBRE) {
               // Guardar el nombre escrito hasta el momento
               sNombre = txtNombre.getText();
               // Actualizar el ttulo de la ventana
               ActualizarTitulo();
            } // if
            else {
               txtNombre.setText(sNombre);
            } // else
         } // keyReleased
      });  // addKeyListener

      // lblTipo
      // Establecer tamao y posicin
      lblTipo.setBounds(new Rectangle(lblNombre.getX() +
                                      lblNombre.getWidth() +
                                      3 * clsConstantes.nSEP_COM +
                                      clsConstantes.nANCHO_BUTTON,
                                      lblNombre.getY(),
                                      clsConstantes.nANCHO_LABEL,
                                      clsConstantes.nALTO_COM));

      // chbTotal
      // Establecer tamao y posicin
      chbTotal.setBounds(new Rectangle(lblTipo.getX(),
                                       lblTipo.getY() +
                                       lblTipo.getHeight(),
                                       50,
                                       clsConstantes.nALTO_COM));

      // chbParcial
      // Establecer tamao y posicin
      chbParcial.setBounds(new Rectangle(chbTotal.getX() +
                                         chbTotal.getWidth() +
                                         clsConstantes.nSEP_COM,
                                         chbTotal.getY(),
                                         100,
                                         clsConstantes.nALTO_COM));

      // lblListaSuperclases
      // Establecer tamao y posicin
      lblListaSuperclases.setBounds(new Rectangle(clsConstantes.
                                                  nSEP_VHOR,
                                                  chbTotal.getY() +
                                                  clsConstantes.nALTO_COM +
                                                  clsConstantes.nSEP_COM,
                                                  clsConstantes.nANCHO_LABEL,
                                                  clsConstantes.nALTO_COM));

      // lstListaSuperclases
      // Establecer tamao y posicin
      lstListaSuperclases.setBounds(new Rectangle(clsConstantes.
                                                  nSEP_VHOR,
                                                  lblListaSuperclases.getY() +
                                                  clsConstantes.nALTO_COM,
                                                  clsConstantes.nANCHO_LIST,
                                                  nAltoList));
      // Cargar la lista para las superclases
      oGeneral.CargarListaSuperclases(lstListaSuperclases);
      // Aadir el componente al listener para cuando se cambie la seleccin
      lstListaSuperclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblListaSubclase
      // Establecer tamao y posicin
      lblListaSubclase.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                               lstListaSuperclases.getY() +
                                               nAltoList +
                                               clsConstantes.nSEP_COM,
                                               clsConstantes.nANCHO_LABEL,
                                               clsConstantes.nALTO_COM));

      // lstListaSubclase
      // Establecer tamao y posicin
      lstListaSubclase.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                               lblListaSubclase.getY() +
                                               clsConstantes.nALTO_COM,
                                               clsConstantes.nANCHO_LIST,
                                               nAltoList));
      // Cargar la lista para las subclases
      oGeneral.CargarListaSubclases(lstListaSubclase);
      // Aadir el componente al listener para cuando se cambie la seleccin
      lstListaSubclase.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarAgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSuper
      // Establecer tamao y posicin
      lblBtnSuper.setBounds(new Rectangle(lblListaSuperclases.getX() +
                                          clsConstantes.nANCHO_LABEL +
                                          clsConstantes.nSEP_COM,
                                          lblListaSuperclases.getY(),
                                          nAnchoLabelButton,
                                          clsConstantes.nALTO_COM));

      // btnQuitarSuper
      btnQuitarSuper.setBounds(new Rectangle(lblBtnSuper.getX(),
                                             lblBtnSuper.getY() +
                                             clsConstantes.nALTO_COM,
                                             nAnchoButton,
                                             clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnQuitarSuper.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSuper
      // Establecer tamao y posicin
      btnAgregarSuper.setBounds(new Rectangle(btnQuitarSuper.getX() +
                                              nAnchoButton +
                                              clsConstantes.nSEP_COM,
                                              btnQuitarSuper.getY(),
                                              nAnchoButton,
                                              clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSuper.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSuper.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSuperclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblBtnSub
      // Establecer tamao y posicin
      lblBtnSub.setBounds(new Rectangle(lblListaSubclase.getX() +
                                        clsConstantes.nANCHO_LABEL +
                                        clsConstantes.nSEP_COM,
                                        lblListaSubclase.getY(),
                                        nAnchoLabelButton,
                                        clsConstantes.nALTO_COM));

      // btnQuitarSub
      // Establecer tamao y posicin
      btnQuitarSub.setBounds(new Rectangle(lblBtnSuper.getX(),
                                           lstListaSubclase.getY(),
                                           nAnchoButton,
                                           clsConstantes.nALTO_BUTTON));
      // Habilitar el botn segn el modo de acceso
      btnQuitarSub.setEnabled(nModo == clsConstantes.nMODO_MODIFICAR);
      // Aadir el componente al listener para cuando se pulse el botn
      btnQuitarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            QuitarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnAgregarSub
      // Establecer tamao y posicin
      btnAgregarSub.setBounds(new Rectangle(btnQuitarSub.getX() +
                                            nAnchoButton +
                                            clsConstantes.nSEP_COM,
                                            btnQuitarSub.getY(),
                                            nAnchoButton,
                                            clsConstantes.nALTO_BUTTON));
      // Deshabilitar el botn
      btnAgregarSub.setEnabled(false);
      // Aadir el componente al listener para cuando se pulse el botn
      btnAgregarSub.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            AgregarSubclase();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblSuperclases
      // Establecer tamao y posicin
      lblSuperclases.setBounds(new Rectangle(lblBtnSuper.getX() +
                                             clsConstantes.nANCHO_BUTTON +
                                             2 * clsConstantes.nSEP_COM,
                                             lblBtnSuper.getY(),
                                             clsConstantes.nANCHO_LABEL,
                                             clsConstantes.nALTO_COM));

      // lstSuperclases
      // Establecer tamao y posicin
      lstSuperclases.setBounds(new Rectangle(lblSuperclases.getX(),
                                             lblSuperclases.getY() +
                                             clsConstantes.nALTO_COM,
                                             clsConstantes.nANCHO_LIST,
                                             nAltoList));
      // Aadir el componente al listener para cuando se cambie la seleccin
      lstSuperclases.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            ActivarQuitarSuper();
         } // Evento: actionPerformed
      }); // addActionListener

      // lblSubclase
      // Establecer tamao y posicin
      lblSubclase.setBounds(new Rectangle(lblSuperclases.getX(),
                                          lblBtnSub.getY(),
                                          clsConstantes.nANCHO_LABEL,
                                          clsConstantes.nALTO_COM));

      // txtSubclase
      // Establecer tamao y posicin
      txtSubclase.setBounds(new Rectangle(lblSubclase.getX(),
                                          lblSubclase.getY() +
                                          clsConstantes.nALTO_COM,
                                          clsConstantes.nANCHO_TEXTFIELD,
                                          clsConstantes.nALTO_COM));
      // Deshabilitar el campo
      txtSubclase.setEnabled(false);

      // btnCerrar
      // Establecer tamao y posicin
      btnCerrar.setBounds(new Rectangle(lstSuperclases.getX() +
                                        clsConstantes.nANCHO_LIST -
                                        clsConstantes.nANCHO_BUTTON,
                                        lstListaSubclase.getY() +
                                        nAltoList +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_BUTTON,
                                        clsConstantes.nALTO_BUTTON));
      // Aadir el componente al listener para cuando se pulse el botn
      btnCerrar.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // Evento: actionPerformed
      }); // addActionListener

      // btnCrear
      // Establecer tamao y posicin
      btnCrear.setBounds(new Rectangle(btnCerrar.getX() -
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR -
                                       clsConstantes.nSEP_COM,
                                       btnCerrar.getY(),
                                       clsConstantes.
                                       nANCHO_BUTTON_CREAR,
                                       clsConstantes.nALTO_BUTTON));
      // Habilitar el botn segun el modo de acceso
      btnCrear.setEnabled(nModo == clsConstantes.nMODO_MODIFICAR);
      // Aadir el componente al listener para cuando se pulse el botn
      btnCrear.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            // Llamar al mtodo que gestiona el evento
            CrearSubclaseCompartida();
         } // Evento: actionPerformed
      });  // addActionListener

      // chbCerrar
      // Establecer tamao y posicin
      chbCerrar.setBounds(new Rectangle(clsConstantes.nSEP_VHOR,
                                        btnCrear.getY() +
                                        clsConstantes.nALTO_BUTTON +
                                        clsConstantes.nSEP_COM,
                                        clsConstantes.nANCHO_CHECKBOX +
                                        40,
                                        clsConstantes.nALTO_COM));
      // Obtener la opcin para cerrar de la variable de configuracin
      chbCerrar.setState(oConfig.bCerrar);

      // Propiedades de la ventana
      // Establecer el tamao
      setSize(oGeneral.nAnchoVentana(btnCerrar.getX()),
              oGeneral.nAltoVentana(chbCerrar.getY()));
      // Establecer tipo de Layout
      setLayout(null);
      // Impedir que se redimensione la ventana
      setResizable(false);
      // Establecer el icono de la ventana
      setIconImage(oGeneral.imgLogo);
      // Centrar la ventana
      oGeneral.CentrarVentana(this);
      // Indicar que sta es la ventana actual
      oGeneral.EstablecerActual(this);
      // Aadir los componenentes a la ventana
      add(lblNombre);
      add(txtNombre);
      add(lblTipo);
      add(chbTotal);
      add(chbParcial);
      add(lblListaSuperclases);
      add(lblListaSubclase);
      add(lblBtnSub);
      add(lblSubclase);
      add(txtSubclase);
      add(lstListaSuperclases);
      add(lstListaSubclase);
      add(btnAgregarSub);
      add(btnQuitarSub);
      add(lblSuperclases);
      add(lstSuperclases);
      add(lblBtnSuper);
      add(btnAgregarSuper);
      add(btnQuitarSuper);
      add(btnCrear);
      add(btnCerrar);
      add(chbCerrar);
      // Aadir la ventana al listener para cuando se cierre la ventana
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            // Llamar al mtodo que gestiona el evento
            Ocultar();
         } // windowClosing
      }); // addWindowListener
      // Mostrar los datos de la ventana segn el modo de acceso
      Mostrar();
      // Mostrar la ventana
      setVisible(true);
   } // Procedimiento: clsTipoInterseccion

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Mostrar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Limpia los campos de la ventana o los informa con los      //
   //              datos de un tipo interseccin entidad segun el modo de     //
   //              acceso                                                     //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Mostrar() {
      if (nModo == clsConstantes.nMODO_ALTA) {
         // Limpiar la ventana
         LimpiarVentana();
      } // if
      else {
         // Cambiar el ttulo del botn de crear
         btnCrear.setLabel("Modificar Tipo Interseccin");
         // Cambiar el ttulo de la check de cerrar la ventana
         chbCerrar.setLabel("Cerrar despus de Modificar");
         // Cerrar la ventana tras modificar
         chbCerrar.setState(true);
         // Impedir que no se cierre la ventana, inhabilitando la check
         chbCerrar.setEnabled(false);
         // Guardar el Nombre original
         sNombreAntiguo = oGeneral.oModificar.sNombre;
         // Mostrar el Nombre
         txtNombre.setText(sNombreAntiguo);
         // Identificar el tipo de Interseccin
         if (oGeneral.oModificar.nTipo ==
             clsConstantes.nTIPO_INTERSECCION_PARCIAL) {
            cbgTipo.setSelectedCheckbox(chbParcial);
         }
         else {
            cbgTipo.setSelectedCheckbox(chbTotal);
         }
         // Mostrar la Subclase de la subclase compartida y quitarla de las disponibles
         txtSubclase.setText(oGeneral.oModificar.sSubclase);
         //////lstListaSubclase.remove(oGeneral.oModificar.sSubclase);
         // Mostrar las entidades Superclase de la Interseccin y quitarlas de las disponibles
         for (int i = 0; i < vSuperclases.size(); i++) {
            lstSuperclases.add( (String) vSuperclases.elementAt(i));
           /* lstListaSuperclases.remove( (String) vSuperclases.
                                       elementAt(i));*/
         } // for
         // Cambiar el ttulo de la ventana
         this.setTitle("Tipo Interseccin: " +
                             oGeneral.oModificar.sNombre);

      } // if
      // Centrar el Frame
      oGeneral.CentrarVentana(this);
      // Mostrar la ventana
      this.setVisible(true);
   } // Procedimiento: Mostrar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: Ocultar                                                  //
   // Parmetros: No                                                          //
   // Descripcin: Lgica necesaria  para cerrar la ventana                   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void Ocultar() {
      // Limpiar la ventana actual
      oGeneral.EstablecerActual(null);
      // Guardar si las ventanas deben cerrarse o no despus de crear
      oConfig.bCerrar = chbCerrar.getState();
      // Indicar que no hay ninguna ventana abierta
      oGeneral.bVentanaAbierta = false;
      // Ocultar la ventana
      this.dispose();
   } // Procedimiento: Ocultar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSubclase                                          //
   // Parmetros: No                                                          //
   // Descripcin: Agregar una entidad como subclase                          //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSubclase() {
      txtSubclase.setText(lstListaSubclase.getSelectedItem());
      lstListaSubclase.remove(lstListaSubclase.getSelectedIndex());
      btnAgregarSub.setEnabled(false);
      btnQuitarSub.setEnabled(true);
      HabilitarCrear();
   } // Procedimiento: AgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSubclase                                           //
   // Parmetros: No                                                          //
   // Descripcin: Quitar una entidad como subclase                           //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSubclase() {
      lstListaSubclase.add(txtSubclase.getText());
      txtSubclase.setText("");
      btnQuitarSub.setEnabled(false);
      btnCrear.setEnabled(false);
   } // Procedimiento: QuitarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSuperclase                                 //
   // Parmetros: No                                                          //
   // Descripcin: Habilitar el botn para agregar una superclase             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSuperclase() {
      btnAgregarSuper.setEnabled(true);
   } // Procedimiento: ActivarAgregarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarAgregarSubclase                                   //
   // Parmetros: No                                                          //
   // Descripcin: Habilitar el botn para agregar la subclase                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarAgregarSubclase() {
      btnAgregarSub.setEnabled(true);
   } // Procedimiento: ActivarAgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarSuperclase                                        //
   // Parmetros: No                                                          //
   // Descripcin: Agrega la entidad seleccionada como superclase             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarSuperclase() {

      String sSuperclase;

      btnAgregarSuper.setEnabled(false);

      sSuperclase = lstListaSuperclases.getSelectedItem();
      lstSuperclases.add(sSuperclase);
      vSuperclases.addElement(sSuperclase);
      lstListaSuperclases.remove(lstListaSuperclases.getSelectedIndex());
      HabilitarCrear();
   } // Procedimiento: AgregarSubclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarSuperclase                                         //
   // Parmetros: No                                                          //
   // Descripcin: Quitar la entidad seleccionada como superclase             //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarSuperclase() {
      int iSuperclase;

      iSuperclase = lstSuperclases.getSelectedIndex();
      vSuperclases.removeElementAt(iSuperclase);
      lstListaSuperclases.add(lstSuperclases.getSelectedItem());
      lstSuperclases.remove(iSuperclase);
      btnQuitarSuper.setEnabled(false);
      HabilitarCrear();
   } // Procedimiento: QuitarSuperclase

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActivarQuitarSuper                                       //
   // Parmetros: No                                                          //
   // Descripcin: Habilita el botn para quitar una superclase               //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActivarQuitarSuper() {
      btnQuitarSuper.setEnabled(true);
   } // Procedimiento: ActivarQuitarSuper

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: HabilitarCrear                                           //
   // Parmetros: No                                                          //
   // Descripcin: Habilita/deshabilita el botn Crear                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void HabilitarCrear() {
      btnCrear.setEnabled(!txtNombre.getText().equals("") &&
                          (vSuperclases.size() > 1) &&
                          !txtSubclase.getText().equals(""));
   } // Procedimiento: HabilitarCrear

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: LimpiarVentana                                           //
   // Parmetros: No                                                          //
   // Descripcin: Establece los valores iniciales de la ventana              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void LimpiarVentana() {
      txtNombre.setText("");
      this.setTitle("Nuevo Tipo Interseccin");
      btnAgregarSub.setEnabled(false);
      btnAgregarSuper.setEnabled(false);
      btnQuitarSub.setEnabled(false);
      btnQuitarSuper.setEnabled(false);
      txtSubclase.setText("");
      lstSuperclases.removeAll();
      vSuperclases.removeAllElements();
      lstListaSuperclases.removeAll();
      lstListaSubclase.removeAll();
      oGeneral.CargarListaSuperclases(lstListaSuperclases);
      oGeneral.CargarListaSubclases(lstListaSubclase);
      btnCrear.setEnabled(false);
      txtNombre.requestFocus();
   } // Procedimiento: LimpiarVentana

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: CrearSubclaseCompartida                                  //
   // Parmetros: No                                                          //
   // Descripcin: Crea la entidad con los datos introducidos en la ventana   //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void CrearSubclaseCompartida() {

      String sNombre;
      int nTipo;
      clsElemento oEntidad; // Objeto para entidades
      clsElemento oInterseccion; // Objeto para el tipo interseccin

      String sTipo;

      // Obtener el nombre de la Interseccin
      sNombre = oGeneral.sFiltrarNombre(txtNombre.getText());
      // Obtener el tipo
      sTipo = cbgTipo.getSelectedCheckbox().getLabel();

      if (sTipo.equals(clsConstantes.sTIPO_INTERSECCION_PARCIAL)) {
         nTipo = clsConstantes.nTIPO_INTERSECCION_PARCIAL;
      } // if
      else {
         nTipo = clsConstantes.nTIPO_INTERSECCION_TOTAL;
      } // else

      if (bValidar(sNombre, nTipo)) {
         if (oGeneral.oModificar == null) {
            oInterseccion = new clsElemento(oGeneral, oConfig.nVerAtributos);

            // Asigna el Nombre del elemento
            oInterseccion.sNombre = sNombre;
            // Asigna el Tipo de elemento
            oInterseccion.nTipo = nTipo;
            // Asigna la coordenada X de la posicin del elemento
            oInterseccion.nX = oGeneral.nXInicial;
            // Asigna la coordenada Y de la posicin del elemento
            oInterseccion.nY = oGeneral.nYInicial;
            // Buscar una posicin libre en el esquema
            while (oGeneral.bEnElemento(oInterseccion.nX,
                                        oInterseccion.nY,
                                        false)) {
               // Asigna la coordenada X de la posicin del elemento
               oInterseccion.nX += clsConstantes.nSEP_COM;
               // Asigna la coordenada Y de la posicin del elemento
               oInterseccion.nY += clsConstantes.nSEP_COM;
            } // while
            // Asigna el Ancho del elemento
            oInterseccion.nAncho = clsConstantes.nANCHO_ESPGEN_UNCAT;
            // Asigna el Alto del elemento
            oInterseccion.nAlto = clsConstantes.nALTO_ESPGEN_UNCAT;
            oInterseccion.sSubclase = txtSubclase.getText();
            oInterseccion.vSuperclases = (Vector) vSuperclases.clone();
            oGeneral.elmElemento(oInterseccion.sSubclase).vIntersecciones.
               add(
               sNombre);
            // Agregar el tipo interseccin a las superclases
            AgregarInterseccionASuperclases(oInterseccion);
            // Agregar el elemento al vector de elementos
            oGeneral.vElementos.addElement(oInterseccion);
         } // if
         else {
            oGeneral.oModificar.sNombre = sNombre;
            oGeneral.oModificar.nTipo = nTipo;
            oGeneral.oModificar.sSubclase = txtSubclase.getText();
            oGeneral.oModificar.vSuperclases = (Vector) vSuperclases.clone();

            QuitarInterseccionEntidades(sNombreAntiguo);
            oEntidad = oGeneral.elmElemento(oGeneral.oModificar.sSubclase);
            oEntidad.vIntersecciones.add(oGeneral.oModificar.sNombre);
            AgregarInterseccionASuperclases(oGeneral.oModificar);

         } // else
         oGeneral.oModificar = null;

         // Actualizar la variable global bCerrar con el valor de la ventana
         oConfig.bCerrar = chbCerrar.getState();

         // Comprobar si se debe ocultar la ventana
         if (oConfig.bCerrar) {
            // Ocultar la ventana
            Ocultar();
         } // if
         else {
            // Limpiar la ventana
            LimpiarVentana();
         } // else

         // Actualizar el esquema
         oGeneral.Repintar();
      } // if
   } // Procedimiento: CrearSubclaseCompartida

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: QuitarInterseccionEntidades                              //
   // Parmetros: - psNombreAntiguo (String): Nombre del tipo interseccin    //
   // Descripcin: Quita el tipo interseccin de las entidades                //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void QuitarInterseccionEntidades(String psNombreAntiguo) {

      int iElemento; // ndice para recorrer el vector de elementos
      clsElemento elmElemento; // Elemento actual a tratar
      int iInterseccion; // ndice para recorrer el vector de relaciones
      boolean bEncontrada;

      for (iElemento = 0; iElemento < oGeneral.vElementos.size(); iElemento++) {
         elmElemento = (clsElemento) oGeneral.vElementos.elementAt(iElemento);
         if ( (elmElemento.nTipo == clsConstantes.nENTIDAD) ||
             (elmElemento.nTipo == clsConstantes.nENTIDAD_DEBIL)) {
            bEncontrada = false;
            iInterseccion = 0;
            while ( (!bEncontrada) &&
                   (iInterseccion < elmElemento.vIntersecciones.size())) {
               if ( ( (String) elmElemento.vIntersecciones.elementAt(
                  iInterseccion)).equals(
                  psNombreAntiguo)) {
                  elmElemento.vIntersecciones.removeElementAt(iInterseccion);
               } // if
               iInterseccion++;
            } // while
         } // if
      } // for
   } // Procedimiento: QuitarInterseccionEntidades

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Funcin: bValidar                                                       //
   // Parmetros: - psNombre (String): Nombre del Nombre del tipo interseccin//
   //             - pnTipo (int): Tipo del tipo interseccin                  //
   // Retorno: Devuelve un valor lgico que indica si se han pasado o no      //
   //          todas las validaciones                                         //
   // Descripcin: Comprueba que los datos para crear el tipo interseccin son//
   //              correctos, mostrando un mensaje de error para los datos    //
   //              que no sean vlidos                                        //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private boolean bValidar(String sNombre, int nTipo) {
      // Validar que el nombre no sea vaco
      if (sNombre.equals("")) {
         // Mostrar el mensaje de error si el nombre est vaco
         oMensajes.MostrarMensaje(clsConstantes.sERROR_CAMPO_VACIO,
                                  "Nombre",
                                  this);
         // Devolver el error
         return false;
      } // if

      // Validar que el tipo interseccin no exista ya (si no es modificacin)
      if ( (oGeneral.oModificar == null) ||
          ( (oGeneral.oModificar != null) && (!sNombre.equals(sNombreAntiguo)))) {

         if (oGeneral.bExisteElemento(sNombre, nTipo, oGeneral.vElementos)) {
            // Mostrar el mensaje de error si el nombre est vaco
            oMensajes.MostrarMensaje(clsConstantes.sERROR_ELEMENTO_YA_EXISTE,
                                     sNombre,
                                     this);
            // Devolver el error
            return false;
         } // if
      } // if

      // Validar que todas las superclases tienen la misma llave
      if (!oGeneral.bCompararAtributosSuperclases(vSuperclases)) {
         // Mostrar el mensaje de error si las superclases tienen llaves distintas
         oMensajes.MostrarMensaje(clsConstantes.sERROR_LLAVES_TIPO_INTER,
                                  this);
         // Devolver el error
         return false;
      } // if

      // Devolver el xito, ya que llegados a este punto se han pasado todas las validaciones
      return true;
   } // Funcin: bValidar

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: ActualizarTitulo                                         //
   // Parmetros: No                                                          //
   // Descripcin: Actualiza el ttulo de la ventana con el valor introducido //
   //              para el nombre despus de aplicarle el filtro              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void ActualizarTitulo() {
      if (txtNombre.getText().equals("")) {
         this.setTitle("Nuevo Tipo Interseccin");
      } // if
      else {
         this.setTitle("Tipo Interseccin: " +
                             oGeneral.sFiltrarNombre(txtNombre.getText()));
      } // else
   } // Procedimiento: ActualizarTitulo

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   // Procedimiento: AgregarInterseccionASuperclases                          //
   // Parmetros: - poElemento (clsElemento): Objeto con el tipo interseccin //
   // Descripcin: Agrega el tipo interseccin a las superclases              //
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   private void AgregarInterseccionASuperclases(clsElemento poElemento) {

      clsElemento oEntidad; // Objeto para la entidad

      for (int i = 0; i < poElemento.vSuperclases.size(); i++) {
         oEntidad = oGeneral.elmElemento( (String) vSuperclases.elementAt(i));
         oEntidad.vIntersecciones.addElement(poElemento.sNombre);
      } // for
   } // Procedimiento: AgregarInterseccionASuperclases

} // Clase: clsTipoInterseccion
